/****************************************************************************** 
 * Copyright 1991-2008 by Quantum Corporation.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * Quantum Corporation.
 *******************************************************************************/

// JavaScript Class CPort
// Implement with "var myBlade = new CBlade();"
function CBlade( id, location, serial, wwnn, fw_ver, ccl, status )
{

    this.id          = id;
    this.location    = location;
    this.serial      = serial;
    this.wwnn       = wwnn;
    this.fw_ver     = fw_ver;
    this.ccl            = ccl;
    this.status     = status;
    
    this.ports      = new Array();
}


// JavaScript Class CPort
// Implement with "var myPort = new CPort();"
function CBPort(id, bladeId, portNum, status, speed, loopId, frameSize, mode, connection, loopIdMode, speedAct, wwnn)
{
    this.id              = id;
    this.bladeId        = bladeId;
    this.portNum         = portNum;
    this.status         = status;
    this.speed          = speed;
    this.loopId         = loopId;
    this.frameSize  = frameSize;
    this.mode           = mode;
    this.connection     = connection;
    this.loopIdMode     = loopIdMode;
    this.speedAct       = speedAct;
    this.wwnn         = wwnn;
    
    function dump()
    {
        document.write("Port Dump -> id="+this.id+
                            " | bladeId="+this.bladeId+
                            " | portNum="+this.portNum+
                            " | status="+this.status+
                            " | speed="+this.speed+
                            " | loopId="+this.loopId+
                            " | frameSize="+this.frameSize+ 
                            " | mode="+this.mode+ 
                            " | connection="+this.connection+ 
                            " | loopIdMode="+this.loopIdMode    );
    
    }
}


/**********************************************
 * Switch the Blade Selection DIV to bladeDiv
 * NOTE: You can over-ride this function by 
 * creating your own in the calling page. 
 * See IOBPortConfig.htm for an example.
 **********************************************/
function selectBlade()
{
    // Make sure a Blade is Selected
    if( document.forms.MainForm.bladeId.value == "" )
        alert( "You must select a I/O Blade to proceed." );
    else
        switchDiv("bladeSelDiv", "bladeDiv");
}


/**********************************************
 * Switch the Host Selection DIV to bladeDiv
 **********************************************/
function selectHost()
{
    switchDiv("bladeSelDiv", "bladeDiv");
}

