/******************************************************************************
* Copyright 1991-2008 by Quantum, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* Quantum, Inc.
*******************************************************************************/

// Name: common.js
//
// Purpose: Common JavaScript functions for Scalar i500.
//
// $Id: common.js 1.114 2007/10/31 15:19:00MDT Jim Boyd (jboyd) dev  $
//
// ##################################################################

//Globals for dynamic timing of operations
var elapsedTime;
var seconds=0;
var minutes=0;
var hours=0;
var timerRunning = false;
var windowHandle = null;
var prog_windowHandle = null;
var selectedMenu;
var globalAction;
var statusFrame = "";
var submitForm;
var dragObj = new Object();
var browser = new Browser();
var bCloseProgressWindow = false;
var ClockSize = 'auto';
var ClockVisible = 'visible';
dragObj.zIndex = 2;
var IPv6Enabled = false;
var DNSEnabled = false;

var errorString = "";

/*************************************************
 * Trim function for strings and standalone
 ************************************************/
String.prototype.trim = function() {
   return this.replace(/^\s+|\s+$/g,"");
}
String.prototype.ltrim = function() {
   return this.replace(/^\s+/,"");
}
String.prototype.rtrim = function() {
   return this.replace(/\s+$/,"");
}
// example of using trim, ltrim, and rtrim
//var myString = " hello my name is ";
//alert("*"+myString.trim()+"*");
//alert("*"+myString.ltrim()+"*");
//alert("*"+myString.rtrim()+"*");

//============================================================================================================
function trim(stringToTrim) 
{
   return stringToTrim.replace(/^\s+|\s+$/g,"");
}

//============================================================================================================
function ltrim(stringToTrim) 
{
   return stringToTrim.replace(/^\s+/,"");
}

//============================================================================================================
function rtrim(stringToTrim) 
{
   return stringToTrim.replace(/\s+$/,"");
}
// example of using trim, ltrim, and rtrim
//var myString = " hello my name is ";
//alert("*"+trim(myString)+"*");
//alert("*"+ltrim(myString)+"*");
//alert("*"+rtrim(myString)+"*");



//============================================================================================================
/* Generic Functions used to have the Enabled/Disabled Clickable on Checkboxes.
   You can optionaly have the function enable and disable another form item by 
   passing in the third option.

   Here is an example of the HTML code needed to use these functions.
       <tr>
         <td align="right" width="50%">Bootup - Unexpected Removal After Power Up:<td>
         <td align="left" width="50%" onMouseOver="buttonOver(this);"> 
            <table cellpadding="0" cellspacing="0"><tr><td align="left">
               <tr><td>
                  <input type="checkbox" id="unexPower" name="unexPower" style="cursor:pointer;" onClick="fnSwitch('unexPower','unexPower_span' );" title="Enable unexpected after power up media security" <?=$msd->unexPower?"checked":""?>>
               </td>
               <td align="left" onClick="javascript:buttonSel(getElementById('unexPower'));fnSwitch('unexPower','unexPower_span' );" >
                  &nbsp;<span id="unexPower_span"><?=$msd->unexPower?"Enabled":"Disabled"?></span>
               </td></tr>
            </table>
         </td>
      </tr>
*/
 
function buttonSel( aCb )
{
    aCb.checked = !aCb.checked;
}

function buttonOver( aTD )
{
    aTD.style.cursor = "pointer";
}

function fnSwitch(aCb, aSpan, aForm, aObj)
{
    //!?! Make this generic to work with all the chekboxes.
   var theForm = document.forms[aForm];
   
   if( theForm[aCb].checked )
   {
      if( aObj != undefined )
          changeObjectVisibility(aObj, "visible");
      document.getElementById(aSpan).innerHTML = 'Enabled';
   }
   else
   {
      if( aObj != undefined )
          changeObjectVisibility(aObj, "hidden");
      document.getElementById(aSpan).innerHTML = 'Disabled';
   }
}

// For Radio Buttons. (We don't want to deselect these ever
// just select them. The browser will handle delselecting the other Radio buttons in the group
function buttonSelAlways( aCb )
{
    aCb.checked = true;
}



//============================================================================================================
/******************************************************
 * Reboot using the CMI reboot method.
 ******************************************************/
function Reboot()
{
  // Reset the timer incase this reboot failes also
  //## NOTE: This same time is also set in index.htm
  setTimeout('Reboot()', 600000);
  
  location = "reboot.htm?CheckReboot=1";
}

//============================================================================================================
/******************************************************
 * Reboot using the Linux System reboot command.
 ******************************************************/
function RebootSys()
{
  // Reset the timer incase this reboot failes also
  //## NOTE: This same time is also set in index.htm
  setTimeout('RebootSys()', 600000);
  
  location = "reboot.htm?CheckReboot=1&UseSys=1";
}

//============================================================================================================
// This is a fuction that loads the action name in the progress
// window.
function loadActionName()
{
    if( frames.progFrame.frames[0].document.getElementById('actionName') )
    {
        //windowHandle.returnStatus.name = statusFrame;
        frames.progFrame.returnStatus.name = statusFrame;
        // change the action name
        //windowHandle.progressWindow.document.getElementById('actionName').innerHTML = globalAction;
        frames.progFrame.frames[0].document.getElementById('actionName').innerHTML = globalAction;

        /*###################################################################
         # NOTE: IE gets an Access violation error when submiting this form 
         # with an invalid filename. As far as I can tell this is the ONLY 
         # thing that can casue an error here, so I am using the try-catch 
         # to catch error, and display an alert.
         # We can not submit the form so there is no way to get the error 
         # to show in the progress window like it does with Firefox
         ###################################################################*/
        try
        {
            // submit the form
            document.forms[submitForm].submit();
        }
        catch(err)
        {
            alert("The filename entered can not be found.\nPlease re-enter it and try again.");
            if (browser.isIE)
            {
               location.reload();
            }
            else
            {
               location.reload(true);
            }
        }
        return 0;
    }
    
    setTimeout("loadActionName()", 2000)
}

//============================================================================================================
// Clear the Hidden grayed divs that disable the controls on the page.
function clearDisabled()
{
   document.getElementById('progressWinBG').style.visibility = 'hidden';
   top.frames['topFrame'].getStyleObject('progressWinBG').visibility = 'hidden';
   bEnableButtons = true;
   top.frames['topFrame'].bDisableMenu   = false;
   //parent.parent.window.location.href=parent.parent.window.location.href;
}

//============================================================================================================
// Closes the progress window when a user defined operation is complete
// If the process is still running, alert the user to please wait
function closeProgressWindow(success)
{
   // Let the onUnload function know the close was already handled.
   // It will reset this flag. The closeProgressWindowX fuction ALWAYS
   // runs after this function if this fuction runs at all.
   bCloseProgressWindow = true;
  
   var action = document.getElementById('actionName').innerHTML;
   if (document.getElementById('status').innerHTML == "In Progress...")
   {
      alert("Process still running. Please wait...");
      return;
   }
   else
   {
//     if (parent.window.opener && !parent.window.opener.closed)
//     {
       if (action == "Modifying Ticket")
       {
          // This is for RAS
          parent.window.opener.parent.window.opener.location.reload();
          parent.window.opener.close();
       }
       else if (action == "Defining Unknown Media")
       {
          // This is for defining unknown media.  Need to refresh both windows.
          parent.window.opener.location.reload();
          parent.window.opener.parent.window.opener.location.reload();
       }
//       else if (parent.window.opener.operationInProgressComplete)
       else if (parent.parent.operationInProgressComplete)
       {
//          parent.window.opener.operationInProgressComplete(action, success);
//          alert("... We are in parent.operationInProgressComplete ...");
          parent.parent.operationInProgressComplete(action, success);
       }
       else
       {
          // reload the page
//          parent.window.opener.location.reload();
          //parent.parent.location.reload();
//         alert("... href is " + parent.parent.window.location.href + " ...");
         /*#################################################################################
          # When the href has a #topframe or any #???? text the href = href does NOT reload
          # the window. We must call reload when this is the case.
          #################################################################################*/
         if( parent.parent.window.location.href.match('#') )
            parent.parent.window.location.reload();
         else
            parent.parent.window.location.href=parent.parent.window.location.href;
       }
//     }
//     parent.window.close();
      ToggleProgress();
   }
}

//============================================================================================================
// This method allows a running process to be cancelled
// Intended primarly for Diagnostic progress windows.
function cancelProgressWindow(success)
{
   // Let the onUnload function know the close was already handled.
   // It will reset this flag. The closeProgressWindowX fuction ALWAYS
   // runs after this function if this fuction runs at all.
   bCloseProgressWindow = true;
   var action = document.getElementById('actionName').innerHTML;
   if (document.getElementById('status').innerHTML == "In Progress...")
   {
      if (!confirm("Test is still in progress. Are you sure you want to terminate the test?"))
      {
         return;
      }

   }
   if (action == "Modifying Ticket")
   {
      // This is for RAS
      parent.window.opener.parent.window.opener.location.reload();
      parent.window.opener.close();
   }
   else if (action == "Defining Unknown Media")
   {
       // This is for defining unknown media.  Need to refresh both windows.
       parent.window.opener.location.reload();
       parent.window.opener.parent.window.opener.location.reload();
   }
// else if (parent.window.opener.operationInProgressComplete)
   else if (parent.parent.operationInProgressComplete)
   {
//     parent.window.opener.operationInProgressComplete(action, success);
//     alert("... We are in parent.operationInProgressComplete ...");
       parent.parent.operationInProgressComplete(action, success);
   }
   else
   {
      // reload the page
      /*#################################################################################
        # When the href has a #topframe or any #???? text the href = href does NOT reload
        # the window. We must call reload when this is the case.
        #################################################################################*/
       if( parent.parent.window.location.href.match('#') )
          parent.parent.window.location.reload();
       else
          parent.parent.window.location.href=parent.parent.window.location.href;
   }

   ToggleProgress();
}
//============================================================================================================
// Starts the dynamic timer (Elapsed time), increments in 1 second intervals.
// Also sets a variable to true indicating that the process is running.
function startTimer()
{
   //if (parent.frames[0].document.getElementById('status').innerHTML == "In Progress...")
   if (document.getElementById('status').innerHTML == "In Progress...")
   {
     timerRunning = true;
     elapsedTime = setInterval('incrTime()', 1000);
   }
}

//============================================================================================================
// Increments the timer and displays the new value on the browser page
function incrTime()
{
   var tseconds;
   var tminutes;
   var thours;

   seconds++;

   if (seconds >= 60)
   {
      minutes++;
      seconds = 0;
   }
   if (minutes >= 60)
   {
      minutes = 0;
      hours++;
   }

   // put a zero in front of the time if it is a single digit
   if (seconds < 10)
   {
      tseconds = "0" + seconds;
   }
   else
   {
      tseconds = seconds;
   }

   if (minutes < 10)
   {
      tminutes = "0" + minutes;
   }
   else
   {
      tminutes = minutes;
   }

   if (hours < 10)
   {
      thours = "0" + hours;
   }
   else
   {
      thours = hours;
   }

   document.getElementById('time').innerHTML = thours + ":" + tminutes + ":" + tseconds;
   
   // Stop the Timer
   if( document.getElementById('status').innerHTML != 'In Progress...' )
      clearInterval(elapsedTime);
}


function daysInMonth(month,year) 
{
    var m = [31,28,31,30,31,30,31,31,30,31,30,31];
    if (month != 2) 
        return m[month - 1];
    if (year%4 != 0) 
        return m[1];
    if (year%100 == 0 && year%400 != 0) 
        return m[1];
    return m[1] + 1;
}

//============================================================================================================
// Allows the buttons on given pages to change colors when the mouse scrolls over it.
// Basically changes between two different images.
function changeImage(state, button, img_name)
{
   // this is if you are using the same image in div tags.  If so you have
   // to name the image something different for each one.  This is used in
   // the wizard pages for the buttons (next,back)
   if (img_name == null)
   {
      img_name = button;
   }

   // if button is greyed out don't do anything.
   current_image = document.images[img_name].src;
   // search returns (-1) if the string is not found, otherwise
   // it return the position of the matching string.
   if ((current_image.search("grey") != -1) && (state < 2))
   {
      return 1;
   }

   if (state == 0)
   {
      //button is up
      document.images[img_name].src =  "images/buttons/" + button + ".gif";
   }
   else if (state == 1)
   {
      //button is down
      document.images[img_name].src =  "images/buttons/" + button + "_down.gif";
   }
   else if (state == 2)
   {
      //button is greyed out
      document.images[img_name].src =  "images/buttons/" + button + "_grey.gif";
   }
   else //(state == 3)
   {
      //ungrey button
      document.images[img_name].src =  "images/buttons/" + button + ".gif";
   }
}

//============================================================================================================
// This function allows the user to print the current content page if
// a printer image button is available.  For instance, the help page uses
// this to print help information that is displayed.
function printContent()
{
   parent.contentFrame.focus();
   parent.contentFrame.print();
}

//============================================================================================================
// changes the visiblity of a layer or 'div'
function changeObjectVisibility(objectId, newVisibility)
{
   // first get the object's stylesheet
   var styleObject = getStyleObject(objectId)
   
   // then if we find a stylesheet, set its visibility
   // as requested
   if (styleObject)
   {
      styleObject.visibility = newVisibility;
      return;
   }
   else
   {
      return;
   }
}

//============================================================================================================
// Determines which browser you are using and sets the style
// accordingly.
function getStyleObject(objectId)
{
   // checkW3C DOM, then MSIE 4, then NN 4.
   //
   if(document.getElementById && document.getElementById(objectId))
   {
      return document.getElementById(objectId).style;
   }
   else if (document.all && document.all(objectId))
   {
      return document.all(objectId).style;
   }
   else if (document.layers && document.layers[objectId])
   {
      return document.layers[objectId];
   }
   else
   {
      return;
   }
}

//============================================================================================================
// This function checks if all form elements have been filled in.
// This function should be used for non wizard pages.  For the wizards
// please use switchIfDone.
function checkForm(form_name)
{

  for (var loop=0; loop < document.forms[form_name].elements.length; loop++)
  {
    if (document.forms[form_name].elements[loop].type != "hidden")
    {
       if (document.forms[form_name].elements[loop].value == "")
       {
          alert('Please complete the form before moving on.');
          return (1);
       }
    }
  }
  return (0);
}

//============================================================================================================
// This function checks if all form elements have been filled in.  Besides
// from this function, other functions may need to be called to make sure
// the contents entered in a field are valid, (numbers, letters, symbols etc.)
function switchIfDone(form_name, this_div, next_div, numberactions)
{
  var complete = true;

  for (var loop=0; loop < document.forms[form_name].elements.length; loop++)
  {
    if (document.forms[form_name].elements[loop].value == "")
    {
      complete = false;
    }
  }
  if (complete == true)
  {
    switchDiv(this_div, next_div);
  }
  else
  {
    alert('Please complete the form before moving on.');
  }
}

//============================================================================================================
function switchDiv(this_div, next_div)
{
  // move the current visible layer to hidden and replace it
  // with the next layer
  if (getStyleObject(this_div) && getStyleObject(next_div))
  {
    changeObjectVisibility(this_div, "hidden");
    changeObjectVisibility(this_div+"_background", "hidden");
    changeObjectVisibility(next_div, "visible");
    changeObjectVisibility(next_div+"_background", "visible");
  }
}

//============================================================================================================
// This function is called when a wizard is complete and the user
// clicks finished.  It basically sends the user back to the product
// home page.
function returnHome()
{
  // If process is running, don't allow user to go next or back
  if (timerRunning == true)
  {
     alert("Configuration in progress. Please wait...");
     return;
  }
  else
  {
     parent.contentFrame.location = "../jsp/HomePage.htm";
  }
}


//============================================================================================================
// This function is called for input fields that should be number
// based.  It make sure the number is valid and it is not greater
// than the allowed amount.  For example when selecting slot count
// for adding a library.  The user is licensed for a set amount,
// don't let the user specify more.
function checkValidNumber(number)
{
   var pattern = /\D/;
   var string = number.value;

   if( number.value.match(pattern) )
   {
      alert("Only numerical characters are allowed.");
      // remove the invalid character and put focus on the input field
      string = string.replace(/\D/g, '');
      number.value = string;
      number.focus();
      return(1);
   }
   return(0);
}

//============================================================================================================
/* See checkValidPageNumberX below for a function that will work with all Forms and Iframes
   You can only use this function if your form is 0 and your iFrame is named: iframeList
   because of the call to showPage when ENTER is pressed*/
function checkValidPageNumber(number, e)
{
   var key = e.keyCode;
   var pattern = /\D/;
   var string = number.value;

   // The user pressed ENTER while changing the PageNumber in the edit field.
   if (key == 13)
      showPage('value');

   if( number.value.match(pattern) )
   {
      alert("Only numerical characters are allowed.");
      // remove the invalid character and put focus on the input field
      var re = /\D/;
      string = string.replace(re, '');
      number.value = string;
      number.focus();
      return(1);
   }
   return(0);
}

//============================================================================================================
/* The eXtended version of the call that passes FormName and FrameName so we can call the
   appropreate showPageForForm() function when ENTER is pressed. This version is needed
   if you have more than one iframe list on your page or your form is NOT 0 and your iFrame
   is NOT named iframeList.
*/
function checkValidPageNumberX(number, e, aFormName, aFrameName, prefix)
{
   var key = e.keyCode;
   var pattern = /\D/;
   var string = number.value;


   if( number.value.match(pattern) )
   {
      alert("Only numerical characters are allowed.");
      // remove the invalid character and put focus on the input field
      var re = /\D/;
      string = string.replace(re, '');
      number.value = string;
      number.focus();
      return(1);
   }

   // The user pressed ENTER while changing the PageNumber in the edit field.
   if (key == 13)
      showPageForForm(aFormName, aFrameName, 'value', prefix);

   return(0);
}

//============================================================================================================
//
// check for a valid IP4 address
//
function isValidIP4Address(ipaddr) 
{
   var re = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/;

   if (re.test(ipaddr)) 
   {
      var parts = ipaddr.split(".");
      if (parseInt(parseFloat(parts[0])) == 0) 
      { 
         return(1); 
      }
      for (var i=0; i<parts.length; i++) 
      {
         if (parseInt(parseFloat(parts[i])) > 255) 
         { 
            return(1); 
         }
      }
      return(0);
   } 
   else 
   {
      return(1);
   }
}

//============================================================================================================
// This function is called for input fields that are string based.
// The string can contain numbers, letter, and underscores.
function checkValidDNSName(name)
{
   var re = /[^A-Za-z0-9_\.]/;

   if( name.value.match(re) || (name.length < 2))
   {
      return(1);
   }
   return(0);
}

//============================================================================================================
function checkEmailAddress(emailAddress, isBlankOK)
{
   var email = emailAddress.value;
   AtPos = email.indexOf("@")
   StopPos = email.lastIndexOf(".")

   if (isBlankOK == true && email == "")
   {     
      return true;
   }

   if (AtPos == -1 || StopPos == -1)
   {
      alert("Invalid E-mail address");
      return false;
   }

   if (StopPos < AtPos)
   {
      alert("Invalid E-mail address");
      return false;
   }
   if (StopPos - AtPos == 1)
   {
      alert("Invalid E-mail address");
      return false;
   }

   return true;
}

//============================================================================================================
// This function is called for input fields that are string based.
// The string can contain numbers, letter, and underscores and ONLY lowercase letters.
//                                                             =======================
function checkValidString(name)
{
   var pattern = /[^a-z0-9_]/;
   var string = name.value;

   if( name.value.match(pattern) )
   {
      alert("Only lowercase letters, numbers, and underscores are allowed in the text string.");
      // remove the invalid character and put focus on the input field
      string = string.replace(/[^a-z0-9_]/g, "");
      name.value = string;
      focusField = name;
      setTimeout(setTheFocus, 10);
      return(1);
   }
   return(0);
}

//============================================================================================================
// These two functions implement the "basic" field validation that should be the baseline for all fields.
// If a field does not use any other type of validation, it should use this.  Also, the rules contained here
// should be implemented by any other validation function as well.
// 
// These prevent users from storing data that contains html tags or comments that may cause the UI to
// display improperly when the data is rendered.  It also prevents script exploits from being installed
// onto the UI.
// 
// The first one is the preferred way to call it.  "niceName" will be used in the alert dialog to describe
// the source of the error.  It generally should be the same as the text labeling the field.  The second 
// one is retained for compatibility with existing code but should be considered deprecated.  If the
// second one it used, the name shown in the alert will be the field's "name" attribute.

function validateInputCharactersWithName( inputField, niceName )
{
    var pattern = /(<.*>)|(<!--)|(-->)|[^A-Za-z0-9@() ,;:\.\-_\[\]\/\*\?]/g; 
    var returnCode = 0;

    // Only check things of type "text" or "textArea"
    if ( inputField.type == 'text' || inputField.type == 'textArea')
    {
        var originalText = inputField.value;
        var newText = originalText.replace(pattern, "");

        if(originalText != newText) 
        {
            // This means that illegal strings were found and replaced - 
            // notify the user, put the altered text into the field and
            // refocus it.

            alert(niceName + ": Invalid character entered, only the following characters are allowed: alpha-numeric @ ( ) ; : / [ ] , . - _ * ?");
            inputField.value = newText;
            focusField = inputField;
            setTimeout(setTheFocus, 10);
            returnCode = 1;
        }
    }

    return(returnCode);
}

function validateInputCharacters( inputField )
{
    return(validateInputCharactersWithName(inputField, inputField.name));
}

//============================================================================================================
// This function is called for input fields that are string based.
// The string can contain numbers, letter, underscores, and dashes.
function checkValidBarcode(barcode)
{
   var pattern = /[^A-Z0-9]/;
   var string = barcode.value;

   if( barcode.value.match(pattern) )
   {
      alert("Only numbers and capital letters are allowed in a barcode label.");
      // remove the invalid character and put focus on the input field
      string = string.slice(0,-1);
      barcode.value = string;
      barcode.focus();
      return(1);
   }
   return(0);
}

//============================================================================================================
// This function launches the progress window for a functional
// operation. The Action needs to be passed in and is what
// operation is taking place. example: "Create User". Also the formNumber
// that the user wants to submit must be passed in. The variable
// statusFrame is used to set a unique name for the frame that
// will hold the return information.  This is necessary for two
// progress windows to be open at the same time.
function openProgressWindow(actionName,formNumber)
{
    var location = launchProgressWindowDo;
    var windowName = new Date().getTime();

    // set the global variable for the form you want to submit
    submitForm = formNumber;
    globalAction = actionName;

    // set a unique name for the returnStatus frame
    statusFrame = "R" + new Date().getTime();
    // set the target of the form to the unique frame name
    document.forms[formNumber].target = statusFrame;

    // check to see if window is already open.  If it
    // is return.
/*    if (windowHandle != null)
    {
       if (!windowHandle.closed)
       {
          windowHandle.focus();
          return (1);
       }
       else
       {
          windowHandle = null;
       }
    }
*/
    /*###################################################################
     # This is a HACK becasue we are not using the CMI to do FDM we need
     # to lock others out before starting the File download.
     # CR 47329
     ####################################################################*/
    if( actionName == "Updating Software" )
    {
      location += '?lock=1';
    }

//    windowHandle = window.open(location, windowName,"height=475,width=475,resizable");
//    windowHandle.focus();

//      prog_windowHandle = windowHandle;    // Set the GLobal incase we need to close this window

    ToggleProgress();
    //startTimer();
    // load the name and frame name and submit when finished.
    setTimeout("loadActionName()", 2000)
}

//============================================================================================================
// Function that allows me to stop the operation dynamic timer and
// return success or failure.
function returnStatus( bCloseWindow, useComplete, bContinueOnErr )
{
   var errorString = "";
   var output = "";
   var errno;
   var errcode; 

   //alert("In returnStatus "+ bCloseWindow +" | "+ useComplete +" | "+  bContinueOnErr + " ............................");

   if ((parent.frames[0]) && (parent.frames[1]))
   {
      // stop the timer
      parent.frames[0].timerRunning = false;
      // The timer is now being stopped in incrTime()
      //parent.frames[0].clearInterval(top.frames[0].elapsedTime);

      // get information passed back about operation (errno, message)
      errno = parent.frames[1].document.forms[0].errno.value;
      errcode = parent.frames[1].document.forms[0].errcode.value;
   }
   else
   {
      setTimeout("returnStatus();", 200);
      return;
   }

   var bContinue = true;
   
   // operation failed
   if (errno != 0)
   {
      parent.frames[0].document.images["progress"].src = "images/failure.gif";
      parent.frames[0].document.getElementById('status').innerHTML = "Operation Failed";
      //alert("Continuing on Error = " + bContinueOnErr);
      if( bContinueOnErr )
      {
         bContinue = true;
         parent.frames[0].document.getElementById('errorListCont').src = "showError.htm?code=" + errcode + "&cont=1";
         parent.frames[0].switchDiv('nodetails','showdetailsCont');
      }
      else
      {
         bContinue = false;
         parent.frames[0].document.getElementById('errorList').src = "showError.htm?code=" + errcode;
         parent.frames[0].switchDiv('nodetails','showdetails');
      }
   }
   
   
   if( bContinue )
   {
      if( bCloseWindow == 1 )
      {
         // Change the status so when the window closes it will not popup the warning
         // that you closed the progress window prematurly.
         parent.frames[0].document.getElementById('status').innerHTML = "Closing";
         // Set the parent back to the login page and close the progress window.
         top.window.location = "index.htm";
         //parent.close();
         return;
      }
      
      if( useComplete )
      {
         parent.frames[0].document.images["progress"].src = "images/completed.gif";
         parent.frames[0].document.getElementById('status').innerHTML = "Operation Completed";
         parent.frames[0].document.getElementById('progress_message').innerHTML =
            "<center><font size='+1'>" + 
            "The operation completed.<br>RAS tickets may exist for device reported failures."
            "</font></center>";
      }
      else
      {
         parent.frames[0].document.images["progress"].src = "images/success.gif";
         parent.frames[0].document.getElementById('status').innerHTML = "Operation Succeeded";
      }
      
      if( bCloseWindow == 2 )   // Display Network setting have change message
      {
         parent.frames[0].document.getElementById('progress_message').innerHTML = 
            "<font size='+1'>" + 
            "<font color='red'><center>CAUTION:</center></font>" + 
            
            "Changing the network settings may interrupt the library connection and library communication. " +
            "Your current browser session may have become invalid.  Please close your browser then reconnect to the " +
            "library with your new configuration settings." +

             "</font>";
//         alert("We Will now close the window");
//         top.close();
         return;
      }
      else if( bCloseWindow == 3 )   // Display Network setting have change message
      {

         parent.frames[0].document.getElementById('progress_message').innerHTML = 
         parent.frames[1].document.forms[0].text.value;
//         alert("We Will now close the window");
//         top.close();
         
      }
      else if( bCloseWindow == 4 )   // Display passed message
      {
          parent.frames[0].document.getElementById('progress_message').innerHTML = 
             "<font size='+1'>" + 
             "<font color='red'><center>CAUTION:</center></font>" + 

              "New keys have been generated on your encryption key server pair when enabling LME on a QKM partition. " +
              "You will need to perform a backup of your key servers for disaster recovery purposes." +

              "</font>";
      }
      else if( bCloseWindow == 5 )   // Display passed message
      {
          parent.frames[0].document.getElementById('progress_message').innerHTML = 
             "<font size='+1'>" + 
             "<font color='red'><center>CAUTION:</center></font>" + 

              "In case any of the features licensed changed the menus, you will need to refresh the browser page, to load those changes.";

              "</font>";
              // Note: This gets an error in IE stating we can not execute a freed script once the Close button is pressed on the progress window
              //top.frames['topFrame'].location.href = "topFrame.htm";
              //top.frames['topFrame'].location.reload(true);
      }
   }

   // display close button
   parent.frames[0].document.images["close"].src = "images/buttons/close.gif";

   // Check for additional buttons in case this is Diagnostic progress window
   if (parent.frames[0].document.images["cancel"])
       parent.frames[0].document.images["cancel"].src = "images/clear.gif";

   if (parent.frames[0].document.images["save"])
       parent.frames[0].document.images["save"].src = "images/buttons/save.gif";
}

//============================================================================================================
// This function changes the menu image depending on which operation you
// click on
function changeMenu(item)
{
   document.images["menugif"].src = "images/menubar/" + item + "_menu.gif";
   selectedMenu = document.images["menugif"].src;
}

//============================================================================================================
// This function changes the menu button image depending on which operation you
// scroll over
function changeMenuButton(state, button)
{
   if (state == 0)
   {
      //button is up
      document.images[button].src =  "images/menu_buttons/" + button + ".gif";
   }
   else if (state == 1)
   {
      //button is down
      document.images[button].src =  "images/menu_buttons/" + button + "_down.gif";
   }
}

//============================================================================================================
// This function changes the menubar image when the mouse rolls
// over a menu item.  This is NOT called when a menu item is selected.
function rollOver(over)
{
  var selected;

  selectedMenu = document.images["menugif"].src;
  selected=selectedMenu.split("_");

  if (selected[0].match(over))
  {
     return;
  }
  else
  {
     document.images["menugif"].src = selected[0] + "_" + over + "over_menu.gif";
     return;
  }
}

//============================================================================================================
// This function returns the menubar image to what ever was selected
// when the mouse is not over the image.
function currentMenu()
{
   document.images["menugif"].src = selectedMenu;
}

//============================================================================================================
// This function changes the icon image when the mouse rolls over it.
function changeIcon(state, icon, icon_name)
{
   if (icon_name == null)
   {
      icon_name = icon;
   }
   if (state == 0)
   {
      //button is up
      document.images[icon_name].src =  "images/icons/" + icon + ".gif";
   }
   else
   {
      //button is down
      document.images[icon_name].src =  "images/icons/" + icon + "_down.gif";
   }
}

//============================================================================================================
// closes the current session window
function confirmLogOut()
{
   if (confirm("Are you sure you want to end your session and logout?"))
   {
      parent.location = 'logoff.htm';
      return;
   }
   else
   {
      return;
   }
}

//============================================================================================================
// function is used to generate the list of
// selected media to pass back.  Used for expire media,
// export media, report media.
function buildMediaList(formNumber, description, action)
{
   var f = document.forms[formNumber];
   var list;
   var gotone = 0;
   var checkboxList = frames["selectMediaList"].document.getElementsByTagName('input');
   
   for (i=0; i<checkboxList.length; i++)
   {
      if ((checkboxList[i].type == "checkbox") && (checkboxList[i].checked))
      {
         if (!gotone)
         {
            list = checkboxList[i].value;
            gotone = 1;
         }
         else
         {
            list += " " + checkboxList[i].value;
         }
      }
   }
   if (!gotone)
   {
      alert("Please select a barcode.");
      return;
   }
   
   // save the media list
   f.mediaList.value = list;
   
   if (confirm("Are you sure you want to " + action + " the selected media?"))
   {
      // launch the progress window
      openProgressWindow(description, formNumber);
   }
   else
   {
      return;
   }
}

//============================================================================================================
// This function reloads the home page when the home button is clicked.
function loadHomePage()
{
   // detecting a popup window, close and reload the main page
   if (parent.opener)
   {
      window.close();
      window.opener.top.location.href="homeview.htm";
   }
   else
   {
      top.location.href="homeview.htm";
   }
}

//============================================================================================================
// This function reloads the home page when the home button is clicked.
function loadContentPage(page)
{
   // reload content page
   top.frames['contentFrame'].location.href=page;
}

//============================================================================================================
// This function is called for the filter strings
// The string can contain numbers, letter, dashes, and *.
function checkValidFilter(name)
{
   var pattern = /[^A-Za-z0-9*-]/;
   var multipleChar= /[*-]/g;
   var number;

   //remove leading and ending spaces in string
   name = name.replace(/^\s+/g, '').replace(/\s+$/g, '');

   // make sure all characters are valid.
   if( name.match(pattern) )
   {
      alert("Invalid filter string [ " + name + " ].\nOnly letters, numbers, hyphens, and asterisks\nare allowed in the filter string.");
      return(1);
   }

   // no multiple *'s or -'s can be in a single string
   if (number=name.match(multipleChar))
   {
      if (number.length > 1)
      {
         alert("Invalid filter string [ " + name + " ].\nOnly one asterisk or hyphen is allowed in a filter string.");
         return(1);
      }
   }

   return(0);
}

//============================================================================================================
// this shows the window for selection a barcode filter
function showFilterSelect(topDiv)
{
   var top = getStyleObject(topDiv);

   if (top.visibility == "visible")
   {
      top.visibility = 'hidden';
   }
   else
   {
      top.visibility = 'visible';
   }
   // store the current values just in case cancel is pushed
   /*
   if (document.forms[0].filter[0].checked)
   {
      g_filterRule = "ALL";
   }
   else
   {
      g_filterRule = document.forms[0].filterPatternBox.value;
   }
   */
}

//============================================================================================================
// check to see if filter is being applied by enter key
function checkApplyFilter(e)
{
   var key = e.keyCode;
   if (key == 13)
   {
      applyFilterSelect('filterSelect');
      //sortBy('filter');
   }
   else
   {
      return;
   }
}

//============================================================================================================
// check to see if filter is being applied by enter key for specific form
function checkApplyFilterForForm(form,e)
{
   var key = e.keyCode;
   if (key == 13)
   {
      applyFilterSelectForForm(formName,'filterSelect');
      //sortBy('filter');
   }
   else
   {
      return;
   }
}


//============================================================================================================
function applyFilterSelectForForm(formName)
{
   var f = document.forms[formName];
   var filter;
   var list;
   
   //do some validation checking
   if (f.filterPatternBox.value != "")
   {
      filter = f.filterPatternBox.value;
      list = filter.split(",");
      for (i=0; i<list.length; i++)
      {
         // check to make sure valid characters first
         if (checkValidFilter(list[i]))
         {
            f.filterPatternBox.focus();
            return;
         }
      }
   }
   f.filterPattern.value = f.filterPatternBox.value;
   f.submit();
}

//============================================================================================================
// This apply's the filter and reloads the page.
function applyFilterSelect(topDiv)
{
   var f = document.forms[0];
   var filter;
   var list;
   
   //do some validation checking
   if (f.filterPatternBox.value != "")
   {
      filter = f.filterPatternBox.value;
      list = filter.split(",");
      for (i=0; i<list.length; i++)
      {
         // check to make sure valid characters first
         if (checkValidFilter(list[i]))
         {
            f.filterPatternBox.focus();
            return;
         }
      }
   }
   f.filterPattern.value = f.filterPatternBox.value;
   f.submit();
}


//============================================================================================================
// this functions hides the filter page and resets
// the settings if cancel was pushed
function hideFilterSelect(topDiv,button)
{
   var top = getStyleObject(topDiv);
   var f = document.forms[0];

   top.visibility = 'hidden';

/*
   if (button == "cancel")
   {
      // restore the values if they have changed
      if (g_filterRule == "ALL")
      {
         f.filter[0].checked = true;
         f.filterPatternBox.value = "";
      }
      else
      {
         f.filter[1].checked = true;
         f.filterPatternBox.value = g_filterRule;
      }
   }
   */
}

//============================================================================================================
// This function checks to see which button is pushed
// and performs the necessary tasks.
function checkFilterSelection()
{
   var f=document.forms[0];

   // user selected All
   if (f.filter[0].checked)
   {
      f.filterPatternBox.value = "";
   }
   else
   {
     f.filterPatternBox.focus();
   }
}


//============================================================================================================
/*
* deselects 'Check All' checkbox on pages with inner frame
* If formNumber is omitted, formNumber = 0
* If the list control does not have the ridiculas paging feature set noPage to a 1
* else just don't pass it.
*/
function deselectAllCheckbox(source, checkboxName, formNumber, noPage)
{
   if( source.checked )
      return;

   if( !formNumber )
      formNumber = 0;

       

   var checkAllBox = eval("parent.document.forms[" + formNumber + "]." + checkboxName);
   if( checkAllBox )
   {
      checkAllBox.checked = false;
      if( ! noPage )
      {
          var currentPage = parent.document.forms[formNumber].currentPageNumber.value;
          var hiddenStatus = eval("document.forms[0].page" + currentPage);
          if( hiddenStatus )
             hiddenStatus.value = 0;
      }
   }
}


//============================================================================================================
// only multiple select the rows on the viewed page
// checks/unchecks all items
// maxSelected is the maxium number selected allowed; 0 for any
function selectAllViewableItems(formName,frameName,maxSelected)
{
   var f = document.forms[formName];
   var currentPage = f.currentPageNumber.value;
   var numberRows = frames[frameName].document.forms[0].numRows.value;
   var numberPages = f.pages.value;
   var rowsPerPage = parseInt(frames[frameName].document.forms[0].rowsPerPage.value);
   var rowsOnLastPage = 0;
   var update;
   var rows;
   var firstNum = 0;
   var lastNum = 0;
   var status;

   // calculate what number of rows are visible.
   if( numberPages == 1)
   {
      lastNum = numberRows;
   }
   else // multiple pages
   {
      if (currentPage != numberPages)
      {
         lastNum = currentPage * rowsPerPage;
         firstNum = lastNum - rowsPerPage;
      }
      else
      {
         lastNum = numberRows;
         rowsOnLastPage = rowsPerPage - ((numberPages * rowsPerPage) - numberRows);
         firstNum = lastNum - rowsOnLastPage;
      }
   }

   var sourceSelect;

   if (document.forms[formName].allSourceSelect.checked)
   {
      var limitSelected = false;
      var numSelected = 0;

      if( maxSelected > 0 )
      {
         limitSelected = true;
         var checkboxList = frames[frameName].document.getElementsByTagName('input');
         for(var i=0; i<checkboxList.length; i++ )
         {
            if( checkboxList[i].type == 'checkbox' && checkboxList[i].checked)
            {
               numSelected++;
            }
         }
      }

      // the user wants to select all media
      for (i=firstNum; i<lastNum; i++)
      {
         update = eval("frames[frameName].document.forms[0].page" + currentPage);
         update.value = 1;

         sourceSelect = eval("frames[frameName].document.forms[0].sourceSelect" + i);

         if( limitSelected )
         {
            if( sourceSelect.checked ) continue;
            if( ++numSelected > maxSelected ) break;
         }

         if( !sourceSelect.disabled )
         {
            sourceSelect.checked = true;
         }
      }
   }
   else
   {
      // the user wants to deselect all items
      var checkboxList = frames[frameName].document.getElementsByTagName('input');

      for(var j=0; j<checkboxList.length; j++ )
      {
         if( checkboxList[j].type == 'checkbox' && checkboxList[j].checked)
         {
            checkboxList[j].checked = false;
         }
      }
   }
}


//============================================================================================================
// multiple select/deselect the rows on ALL the page
// checks/unchecks all items
// maxSelected is the maxium number selected allowed; 0 for any
function selectAllItems(formName,frameName,maxSelected)
{
   var f = document.forms[formName];
   var currentPage = f.currentPageNumber.value;
   var numberRows = frames[frameName].document.forms[0].numRows.value;
   var numberPages = f.pages.value;
   var rowsPerPage = parseInt(frames[frameName].document.forms[0].rowsPerPage.value);
   var rowsOnLastPage = 0;
   var update;
   var rows;
   var firstNum = 0;
   var lastNum = numberRows;
   var status;

   var sourceSelect;

   if (document.forms[formName].allSourceSelect.checked)
   {
      var limitSelected = false;
      var numSelected = 0;

      if( maxSelected > 0 )
      {
         limitSelected = true;
         var checkboxList = frames[frameName].document.getElementsByTagName('input');
         for(var i=0; i<checkboxList.length; i++ )
         {
            if( checkboxList[i].type == 'checkbox' && checkboxList[i].checked)
            {
               numSelected++;
            }
         }
      }
      else
         return;   // If 0 Don't bother

      // the user wants to select all media
      for (i=firstNum; i<lastNum; i++)
      {
         update = eval("frames[frameName].document.forms[0].page" + currentPage);
         update.value = 1;

         sourceSelect = eval("frames[frameName].document.forms[0].sourceSelect" + i);

         if( limitSelected )
         {
            if( sourceSelect.checked ) continue;
            if( ++numSelected > maxSelected ) break;
         }

         if( !sourceSelect.disabled )
         {
            sourceSelect.checked = true;
         }
      }
   }
   else
   {
      // the user wants to deselect all items
      var checkboxList = frames[frameName].document.getElementsByTagName('input');

      for(var j=0; j<checkboxList.length; j++ )
      {
         if( checkboxList[j].type == 'checkbox' && checkboxList[j].checked)
         {
            checkboxList[j].checked = false;
         }
      }
   }
}


//============================================================================================================
// this function is a quick and dirty way to differentiate between
// Netscape and other browsers.  If we require more detailed browser
// detection in the future, this function will need to be enhanced.
function isNetscape()
{
   if (navigator.userAgent.indexOf('MSIE') > 0)
      return false;
   return true;
}


//============================================================================================================
// load menus on main summary page
function loadMenus()
{
   if (parent.frames[1]&&parent.frames[0].Go)
   {
      parent.frames[0].Go();
      // put focus to top of page.
      document.location.href="#topPage";
      return;
   }
   else
   {
      setTimeout("loadMenus();", 200);
   }
}


//============================================================================================================
// Display the current page selection
function showReportPage(input)
{
   if (input == "init")
   {
      if (top.frames["contentList"].document.getElementById("page1"))
      {
         top.frames["contentList"].document.getElementById("page1").style.visibility = "visible";
         top.document.forms[0].currentPageNumber.value = 1;
         top.document.forms[0].number.value = 1;
         top.document.forms[0].numberItems.value = document.forms[0].numberItems.value;
         top.document.forms[0].pages.value = document.forms[0].pages.value;
         top.document.getElementById("dispNumItems").innerHTML =
            document.forms[0].numberItems.value;
         top.document.getElementById("dispNumPages").innerHTML =
            document.forms[0].pages.value;
         return;
      }
      else
      {
         setTimeout("showPage();", 200);
         return;
      }
   }

   var f = document.forms[0];
   var pages = parseInt(f.pages.value);
   var hidePage;
   var visiblePage;
   var currentPage = parseInt(f.number.value);
   var prevPage = parseInt(f.currentPageNumber.value);
   var inputNumber =0;

   if(f.number.value == "" )
   {
      f.number.value = 1;
   }

   if (currentPage <= 0)
   {
      f.number.value = 1;
      currentPage = f.number.value;
   }

   if (currentPage > pages)
   {
      f.number.value = pages;
      currentPage = f.number.value;
   }

   if (input == "next")
   {
      if (f.currentPageNumber.value == pages)
      {
         return;
      }
      else
      {
         inputNumber = currentPage + 1;
      }
   }
   else if (input == "back")
   {
      if (f.currentPageNumber.value == 1)
      {
         return;
      }
      else
      {
         inputNumber = currentPage - 1;
      }
   }
   else if (input == "value")
   {
      inputNumber = f.number.value;
   }

   // don't load the same page again
   if (inputNumber == prevPage)
   {
      return;
   }

   f.number.value = inputNumber;
   f.currentPageNumber.value = inputNumber;

   // hide previous page
   hidePage = "page" + prevPage;
   top.frames["contentList"].document.getElementById(hidePage).style.visibility = "hidden";


   // show new page
   visiblePage = "page" + inputNumber;

   top.frames["contentList"].document.getElementById(visiblePage).style.visibility = "visible";
   return;
}


//============================================================================================================
// allows user to drag help filter window
function dragStart(event, id)
{
  var el;
  var x, y;

  // If an element id was given, find it. Otherwise use the element being
  // clicked on.
  if (id)
  {
    dragObj.elNode = document.getElementById(id);
  }
  else
  {
    if (browser.isIE)
      dragObj.elNode = window.event.srcElement;
    if (browser.isNS)
      dragObj.elNode = event.target;

    // If this is a text node, use its parent element.

    if (dragObj.elNode.nodeType == 3)
      dragObj.elNode = dragObj.elNode.parentNode;
  }

// Get cursor position with respect to the page.

  if (browser.isIE) 
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) 
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }
//  t = "X=" + x + "| Y=" + y + "<br>\n";
//  document.getElementById('xyDisplay').innerHTML = t;

// Save starting positions of cursor and element.

  dragObj.cursorStartX = x;
  dragObj.cursorStartY = y;
  dragObj.elStartLeft  = parseInt(dragObj.elNode.style.left, 10);
  dragObj.elStartTop   = parseInt(dragObj.elNode.style.top, 10);

  if (isNaN(dragObj.elStartLeft))
  {
    dragObj.elStartLeft = findPosX(dragObj.elNode);;
  }
  if (isNaN(dragObj.elStartTop))
  {
    dragObj.elStartTop  = findPosY(dragObj.elNode);;
  }
// Update element's z-index.

  dragObj.elNode.style.zIndex = ++dragObj.zIndex;

// Capture mousemove and mouseup events on the page.

  if (browser.isIE) 
  {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStop);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS) 
  {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStop, true);
    event.preventDefault();
  }
}


//============================================================================================================
function dragGo(event) 
{

  var x, y;

  // Get cursor position with respect to the page.

  if (browser.isIE) 
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) 
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

// Move drag element by the same amount the cursor has moved.

  dragObj.elNode.style.left =
    (dragObj.elStartLeft + x - dragObj.cursorStartX) + "px";
  dragObj.elNode.style.top  =
    (dragObj.elStartTop  + y - dragObj.cursorStartY) + "px";

  if (browser.isIE) 
  {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS)
    event.preventDefault();
}


//============================================================================================================
function dragStop(event) 
{
  // Stop capturing mousemove and mouseup events.

  if (browser.isIE) 
  {
    document.detachEvent("onmousemove", dragGo);
    document.detachEvent("onmouseup",   dragStop);
  }
  if (browser.isNS) 
  {
    document.removeEventListener("mousemove", dragGo,   true);
    document.removeEventListener("mouseup",   dragStop, true);
  }
}


//============================================================================================================
// Determine browser and version.

function Browser() 
{
  var ua, s, i;

  this.isIE    = false;
  this.isNS    = false;
  this.version = null;

  ua = navigator.userAgent;

  s = "MSIE";
  if ((i = ua.indexOf(s)) >= 0) 
  {
    this.isIE = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  s = "Netscape6/";
  if ((i = ua.indexOf(s)) >= 0) 
  {
    this.isNS = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  // Treat any other "Gecko" browser as NS 6.1.

  s = "Gecko";
  if ((i = ua.indexOf(s)) >= 0) 
  {
    this.isNS = true;
    this.version = 6.1;
    return;
  }
}

//============================================================================================================

// submit a form for sorting table data and update the column sort arrow
function sortBy(name, columns)
{
   sortByOnForm(0, name, columns);
}

//============================================================================================================

function sortByOnForm(formName, name, columns)
{
   var f = document.forms[formName];
   var currentSortOn = f.orderOn.value;

   if( currentSortOn == name )
   {
      if( f.orderBy.value == "ASC" )
      {
         f.orderBy.value = "DESC";
      }
      else
      {
         f.orderBy.value = "ASC";
      }
   }
   else
   {
      f.orderBy.value = 'ASC';
   }

   f.orderOn.value = name;
   var numCols = columns.length;
   for (i = 0; i < numCols; i++)
   {
      document.images[columns[i]].src = "images/clear.gif";
   }
   if (f.orderBy.value == "ASC")
   {
      document.images[name].src = "images/arrowDown.gif";
   }
   else
   {
      document.images[name].src = "images/arrowUp.gif";
   }
   f.submit();
}

//============================================================================================================

function checkRange(inputElement, rangeId)
{
   if (parseInt(inputElement.value))
   {
      var max = document.getElementById(rangeId).innerHTML;
      if (inputElement.value > max)
      {
         alert("Value entered must be less than " + max + ".");
         inputElement.focus();
         return false;
      }
   }
   else
   {
      alert("Value must be a integer value.");
      inputElement.focus();
      return false;
   }
   return true;
}


//============================================================================================================

/*****************************************************************************************
 * chg_div (aDesc, aDiv)
 *  chg_div will change the contence of the <DIV> passed in With the aDesc passed in.
 *  Here is an example of a <DIV> that will be loaded with the aDesc.
 *  <div id="chg_divdesc" align="center" style="font-size: 14pt; color: black;"></div>
 *  This area can be out in the open BODY or in between <td></td> etc...
 *
 *  aDesc is the html text to put in the DIV area (See above)
 *  If '' is passed the saved html is replaced.
 *  If the Description is has a # as the First character the data is assumed to be an
 *  ID of a hidden DIV tag that will be used to populate the aDiv passed in
 *
 * Note: You must call this first with a aDesc filled in so the current contince of the
 *       DIV will be saved. If you call this with aDesc == '' you'll get
 *       "undefined" as the replacement text and the original contence will be lost.
 *****************************************************************************************/
var savedInnerHTML;  // This must be define outside the {} to remain persistant between calls

function chg_div( aDesc, aDiv )
{
  // Set the default DIV name if one is not supplied.
  if( aDiv == null )
  {
      aDiv = 'chg_divdesc';
  }

  if( aDesc == '' )
  {
    if (document.getElementById)
      document.getElementById(aDiv).innerHTML = savedInnerHTML;
    else
      aDiv.innerHTML = savedInnerHTML;
  }
  else
  {
    // Note: aDesc[0] == '#' Does NOT work in exploder
    if( aDesc.substring(0,1) == '#' )
    {
      // Use the variable after striping the # off the front
      aDesc = aDesc.substring(1,999); //Chop off the #
      if (document.getElementById)
        aDesc = document.getElementById(aDesc).innerHTML;
      else
        aDesc = aDesc.innerHTML;
    }

    // Use the text passed
    if (document.getElementById)
    {
      savedInnerHTML = document.getElementById(aDiv).innerHTML;
      document.getElementById(aDiv).innerHTML = aDesc;
    }
    else
    {
      savedInnerHTML = aDiv.innerHTML;
      aDiv.innerHTML = aDesc;
    }
  }
}

//============================================================================================================
// Just swap the image passed with the Pic passed
// Uses /images as the bas directory
// See changeImage to change images in the /images/buttons dir
// and changeIcon to change images in the image/icon dir.
function changePic( aPic, aImg_name )
{
   document.images[aImg_name].src =  "images/" + aPic;
}

//============================================================================================================

/****************************************************************
 * Play a beep
 * Netscape - if Java is enabled.
 * Explorer - use the beep.wav with the BGSOUND tag.
 *
 * NOTE: The use of this function requires you to add the
 * following line to your HTML code that is calling this function.
 * Add it below the <body> tag
 * <BGSOUND SRC="#" ID="beep" AUTOSTART="TRUE">
 ****************************************************************/
function beep()
{
  if (isNetscape())
  {
    if ((navigator.javaEnabled != null) && (navigator.javaEnabled()))
    {
      java.awt.Toolkit.getDefaultToolkit().beep();
    }
  }
  else
  {
    document.getElementById('beep').src='snd/beep.wav';
  }

}

//============================================================================================================

/****************************************************************
 * Find an Object's (Element's) X postition
 * Netscape - Works
 * Explorer - Works
 ****************************************************************/
function findPosX(obj)
{
  var curleft = 0;
  if (obj.offsetParent)
  {
    while (obj.offsetParent)
    {
      curleft += obj.offsetLeft
      obj = obj.offsetParent;
    }
  }
  else if (obj.x)
    curleft += obj.x;
  return curleft;
}

//============================================================================================================

/****************************************************************
 * Find an Object's (Element's) Y postition
 * Netscape - Works
 * Explorer - Works
 ****************************************************************/
function findPosY(obj)
{
  var curtop = 0;
  if (obj.offsetParent)
  {
    while (obj.offsetParent)
    {
      curtop += obj.offsetTop
      obj = obj.offsetParent;
    }
  }
  else if (obj.y)
    curtop += obj.y;
  return curtop;
}

//============================================================================================================

/****************************************************************
 * Helper functions to get the x and y of an element
 ****************************************************************/
function getOffsetX (el) 
{
  var ol = el.offsetLeft;
  while ((el = el.offsetParent) != null)
    ol += el.offsetLeft;
  return ol;
}

//============================================================================================================

function getOffsetY (el) 
{
  var ot = el.offsetTop;
  while((el = el.offsetParent) != null)
    ot += el.offsetTop;
  return ot;
}

//============================================================================================================

/****************************************************************
 * You miust set the var focusFiled before setting the timer to
 * this function.
 ****************************************************************/
function setTheFocus()
{
  focusField.focus();
  focusField.select();

  return true;
}

//============================================================================================================

/***************************************************************
 * Bring up a caution dialog warning the user the operation
 * could take up to Several minutes to complete
 ***************************************************************/
function cautionUpToSeveralMin()
{
  
  return confirm( "CAUTION: This request can take several minutes to complete.\nDo you want to perform the operation?" );
}

/***************************************************************
 * Bring up a caution dialog warning the user the operation
 * could take up to 60 minutes to complete
 ***************************************************************/
function cautionUpTo60Min()
{
  
  return confirm( "CAUTION: This request can take up to 60 minutes to complete.\nDo you want to perform the operation?" );
}

/***************************************************************
 * Bring up a caution dialog warning the user the operation
 * could take up to 30 minutes to complete
 ***************************************************************/
function cautionUpTo30Min()
{
  
  return confirm( "CAUTION: This request can take up to 30 minutes to complete.\nDo you want to perform the operation?" );
}

//============================================================================================================

/***************************************************************
 * Bring up a caution dialog warning the user the library will
 * be taken offline if they proceed.
 ***************************************************************/
function cautionLibOffline()
{
  
  return confirm( "CAUTION: This request will take the selected partition offline and limit\nsuccessful host communication. Do you want to perform the operation?" );
}

//============================================================================================================

/***************************************************************
 * Bring up a caution dialog warning the user the drive will
 * be taken offline if they proceed.
 ***************************************************************/
function cautionDriveOffline()
{
  return confirm( "CAUTION: This request will take the selected data transfer element offline and limit\nsuccessful host communication. Do you want to perform the operation?" );
}

//============================================================================================================

/***************************************************************
 * Bring up a caution dialog warning the user the library will
 * be taken offline if they proceed.
 ***************************************************************/
function cautionNetOffline()
{
  return confirm( "CAUTION: This request will modify network connectivity parameters and requires remote communication\ninterfaces to be reconfigured. Do you want to perform the operation?" );
}

/***************************************************************
 * Bring up a caution dialog warning the user that any data on 
 * the scratch tape in the top I/E station will be overwritten.
 ***************************************************************/
function cautionDataOverwritten()
{
  return confirm( "CAUTION: This request requires a scratch tape cartridge in the top I/E station.  Any data on the scratch tape cartridge will be overwritten. Do you want to perform the operation?" );
}

//============================================================================================================

/***********************************************************************************
 * Progress Window code that is not part of the original one.
 ***********************************************************************************/
var iOpacity = 0;
var iShadeHeight = 0;

//============================================================================================================

/*
 * Increment the opacisty
 */
function IncShade()
{
   if (isNetscape())
      maxOpacity = 0.3;
   else
      maxOpacity = 0.4;   // Exploder needs to go a little darker to look the same as Firefox.
   
   e = document.getElementById('progressWinBG');
   e.style.opacity = iOpacity;
   if (browser.isIE)
   {
      e.style.filter = 'alpha(opacity=' + (iOpacity*100) + ')';   
   }
   e.style['-moz-opacity'] = iOpacity;         

   // See if we need to run the inc again.
   if( iOpacity < maxOpacity )
   {
      iOpacity += .01;
      setInterval('IncShade()', 60)
   }
}

//============================================================================================================

/*
 * Makes the shade go down in 5% increments
 */
function IncShadeDown()
{
   e = document.getElementById('progressWinBG');
   e.style.height = iShadeHeight + "%";
      // See if we need t run the inc again.
   if( iShadeHeight < 100 )
   {
      iShadeHeight += 5;
      setInterval('IncShadeDown()', 100)
   }

}

//============================================================================================================

/*
 * Makes the shade go down all the way
 */
function ShadeDown()
{
   e = document.getElementById('progressWinBG');
   e.style.height = document.body.scrollHeight;
}

//============================================================================================================

/*
 * Toggle the Progress Window-popup on and off
 */
function ToggleProgress()
{
   var bgTF        = top.frames['topFrame'].getStyleObject('progressWinBG');
   var bg          = top.frames['contentFrame'].getStyleObject('progressWinBG');
   var progress    = top.frames['contentFrame'].getStyleObject('progressWin');
   var progShad    = top.frames['contentFrame'].getStyleObject('progressWinShadow');
   var off         = top.frames['contentFrame'].getStyleObject('srvmnu');

   if( progress != null )
   {
      if (progress.visibility == "visible")
      {
         top.frames['contentFrame'].frames.progFrame.frames[0].document.getElementById('status').innerHTML = "Closing...";
         top.frames['contentFrame'].frames.progFrame.frames[0].document.images["close"].src = "images/clear.gif";
         top.frames['contentFrame'].frames.progFrame.frames[0].document.images["progress"].src = "images/working.gif";

         if( off != null )
            off.visibility = 'visible';
            
         // Leave the main background divs visable, so the user still can not press any buttons while the page reloads.
         // Alex saw this when he had a bunch of logging turned on and the page reload took sevel seconds. He was able
         // to re-select source and destination on the move media page.
         // See loading.js IsPageLoaded() to see where we make this visable.
         //bgTF.visibility = 'hidden';
         //bg.visibility = 'hidden';
         progress.visibility = 'hidden';        
         progShad.visibility = 'hidden';        
         bEnableButtons = true;
         top.frames['topFrame'].bDisableMenu   = false;
      }
      else
      {
         // We are opening a new progress window.
         // Need to clear this out if the user used the back button to go to another dirve op page.
         top.frames['contentFrame'].frames.progFrame.frames[0].document.getElementById('progress_message').innerHTML = "";

         top.frames['contentFrame'].frames.progFrame.frames[0].document.getElementById('status').innerHTML = "In Progress...";
         // Move progress window layer to center of main window to show
         if (document.all) 
         {   // Internet Explorer
//            progressWin.className = 'show';
            progressWinShadow.style.left = ((document.body.clientWidth/2) - (progressWin.offsetWidth/2)) + 10;
            progressWinShadow.style.top = 40;
            //progressWinShadow.style.top = (document.body.scrollTop+(document.body.clientHeight/2) - (progressWin.offsetHeight/2)) + 20;
            progressWin.style.left = (document.body.clientWidth/2) - (progressWin.offsetWidth/2) + 0;
            progressWin.style.top = 20;
            //progressWin.style.top = document.body.scrollTop+(document.body.clientHeight/2) - (progressWin.offsetHeight/2);
         } 
         else if (document.layers) 
         {   // Netscape
//            document.progressWin.visibility = true;
            document.progressWinShadow.left = ((window.innerWidth/2) - 200) + 20;
            document.progressWinShadow.top = (window.pageYOffset+(window.innerHeight/2) - 100) + 10;
            document.progressWin.left = (window.innerWidth/2) - 200;
            document.progressWin.top = window.pageYOffset+(window.innerHeight/2) - 100;
         } 
         else if (document.getElementById) 
         {   // Netscape 6+
//            document.getElementById("progressWin").className = 'show';
            document.getElementById("progressWinShadow").style.left = ((window.innerWidth/2)- 360) + 20;
//            document.getElementById("progressWinShadow").style.top = (window.pageYOffset+(window.innerHeight/2) - 160) + 20;
            document.getElementById("progressWinShadow").style.top =   1 + 20;         
            document.getElementById("progressWin").style.left = (window.innerWidth/2)- 360;
//            document.getElementById("progressWin").style.top = window.pageYOffset+(window.innerHeight/2) - 160;
            document.getElementById("progressWin").style.top =   1;         
         }
      
         // Reset all Info to a fresh progress window.
         top.frames['contentFrame'].frames.progFrame.frames[0].seconds = 0;
         top.frames['contentFrame'].frames.progFrame.frames[0].minutes = 0;
         top.frames['contentFrame'].frames.progFrame.frames[0].hours = 0;
         top.frames['contentFrame'].frames.progFrame.frames[0].startTimer();
         top.frames['contentFrame'].frames.progFrame.frames[0].document.images["close"].src = "images/clear.gif";
         top.frames['contentFrame'].frames.progFrame.frames[0].switchDiv('showdetails', 'nodetails');

         if( off != null )
            off.visibility = 'hidden';
         bgTF.visibility = 'visible';
         bg.visibility = 'visible';
         progress.visibility = 'visible';
         progShad.visibility = 'visible';
         bEnableButtons = false;     
         top.frames['topFrame'].bDisableMenu   = true;
         
         if (isNetscape())
            iOpacity = 0.3;
         else
            iOpacity = 0.4;   // Exploder need to go alittle darker to look the same as Firefox.
         
         iShadeWidth = 0;
         //IncShadeDown();   // Uncomment this to make the shade go down like a window shade.
         //iOpacity = 0; // Uncomment this if you want the shading to happen in incremental steps.
         
         ShadeDown();   // Becasue IE calcs the height of the inital shade it needs to be 0 to start with. So we nned to make its height 100% here.
         IncShade();
         // Move the page to the top so the user can see the progress Window.
         top.frames['contentFrame'].scroll(0,0);

      }
   }
   else
      alert("Progress Window object not found - Please clear your browser's cache and try the operation again.");
}

//============================================================================================================

//
// Insure that the entered characters are either an IP or host name
//
function checkHostOrIP( aField, aBlankOk )
{
   var pattern = /[^\.:0-9_A-Za-z-]/;
   var patternV4 = /[^\.0-9]/;
   var string = aField.value;
   var errorString = "";
   var ret;
   
   // If it's BLANK and blanks are ok Just Exit
   if( aField.value == "" && aBlankOk == "1" )
      return true;

   if( aField.value == ""  && aBlankOk != "1" )
      errorString = errorString + ' \"BLANK\" cannot be used here.';
   else if( string.match(pattern) )
      errorString = "Please enter a valid IP or host name";
      
   if( errorString == "" )
   {
      // Now determine if we need to validate IPv6 or IPv4
      if( aField.value.search(":") != -1 )
      {
         ret = verifyIPv6( aField, aBlankOk );
      }
      else 
      {
         tmp = aField.value.split(".");
         if( tmp.length >= 1 )   // Is it a HOSTNAME or IPv4 address
         {
            // if each section is a number it's an IPv4 address. Else assume a Valid Hostname and just exit
            if( ! aField.value.match( patternV4 ) )
               ret = verifyIPv4( aField, aBlankOk );
         }
      }
   }
   
   if( errorString != "" || ret == false )
   {
      if( errorString != "" )
         alert (errorString);
      
      window.status = errorString;
      focusField = aField;
      setTimeout( setTheFocus, 10 );
      return false;
   }
   return true;
}


//============================================================================================================

/****************************************************************
   Determine which verify function to call, IPv4 or IPv6
 ****************************************************************/
function verifyIP( aField, aBlankOK ) 
{
   var ret = false;
    // First detemine if the address is IPv4 or IPv6
   // Remember IPv4 can have "." but not ":" and IPv6 can have both, but must have a :
   if( aField.value.search(":") == -1 )
   {
      // Must be an IPv4 address
      ret =  verifyIPv4( aField, aBlankOK );
   }
   else   // Default to IPv6 if it had any :'s in it
      ret = verifyIPv6( aField, aBlankOK );

   if( ret == false )
   {
      window.status = errorString;
      focusField = aField;
      setTimeout( setTheFocus, 10 );
      return false;
   }

   return ret;
}

//============================================================================================================

/****************************************************************
 * Verify that the data in the input field passed is a valid 
 * IPv4 address.
 * If aBlankOK is true then Blank IPs are OK
 * Also sets the Global Var okToApply according to the 
 * validation of the field.
 ****************************************************************/
function verifyIPv4( aField, aBlankOK ) 
{
  var IPvalue = aField.value;

  errorString = "";
  theName = "Entered IP address";

  var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
  if (IPvalue == "0.0.0.0" && aBlankOK != "1")
    errorString = errorString + theName + ' "'+IPvalue+'" is a special IP address and cannot be used here.';
  if (IPvalue == "255.255.255.255")
    errorString = errorString + theName + ' "'+IPvalue+'" is a special IP address and cannot be used here.';
  if( IPvalue == ""  && aBlankOK != "1" )
    errorString = errorString + theName + ' \"BLANK\" cannot be used here.';
  else if( IPvalue == ""  && aBlankOK == "1" )
  {
      okToApply = true;
      return true;   // It's BLANK - just exit
  }

  if( errorString == "" )
  {
     var ipArray = IPvalue.match(ipPattern); 
     if (ipArray == null)
          errorString = errorString + theName + ' "'+IPvalue+'" is not a valid IP address.';
     else 
     {
       for (i = 1; i < 5; i++) 
       {
         thisSegment = ipArray[i];
         if (thisSegment > 255) 
         {
           errorString = errorString + theName + ' "'+IPvalue+'" is not a valid IP address.';
           break;
         }
         if ((i == 0) && (thisSegment > 255)) 
         {
           errorString = errorString + theName + ' "'+IPvalue+'" is a special IP address and cannot be used here.';
           break;
         }
        }
     }
  }
  
  if( errorString != "" )
  {
    // Display the error and return the focus to the field.
    alert (errorString);
    window.status = errorString;

    /********************************************************
     * Note: the setting of the focus DOES NOT WORK like
     * aField.focus();
     * You must call the focus function after the KEY
     * that made the user leave the field gets processed, 
     * so you MUST use a timer.
     ********************************************************/
    okToApply = false;
    focusField = aField;
    setTimeout( setTheFocus, 10 );
    return false;
  }
  else
    okToApply = true;
  
  return true;
}

//============================================================================================================

// Set this to true to suppress alerts in IPV6.  You can then read the resultMsgIpv6 to get the
// error(s)
var suppressAlertsInIPV6 = false;

/****************************************************************
 * Verify that the data in the input field passed is a valid 
 * IPv6 address.
 * If aBlankOK is true then Blank IPs are OK
 * Also sets the Global Var okToApply according to the 
 * validation of the field.
 ****************************************************************/
function verifyIPv6( aField, aBlankOK ) 
{
   var IPvalue = aField.value;
   var errorString = "";
   var ret;
       
   theName = "Entered IP address";

   // See if the user passed a 0::0 in in any format:
   // First was there a net prefix on the Address
   tmp = IPvalue.split("/");
   if( tmp.length == 2 )
   {
      addr   = tmp[0];
      prefix = tmp[1];
   }
   else
   {
      addr   = tmp[0];
      prefix = "";
   }
   
   if(prefix != "") return false;
   
   // Now check for the 0 address
   var hexList;
   var iTmp = 0;
   hexList = IPvalue.split(":");
   for( i = 0; i < hexList.length; ++i )
      iTmp += hexList[i];
   if (iTmp == 0 && aBlankOK != "1")
      errorString = errorString + theName + ' "'+IPvalue+'" is a special IP address and cannot be used here.';
   
   // Now check for just a blank
   if( IPvalue == ""  && aBlankOK != "1" )
      errorString = errorString + theName + ' \"BLANK\" cannot be used here.';
   
   if( errorString == "" )
   {
      // The validateIPv6 function will display any errors.
      ret = validateIPv6( IPvalue )
   }
   
   if( errorString != "" || ret == false)
   {
   // Display the error and return the focus to the field.
      if( errorString != "" )
      {
         alert (errorString);
         window.status = errorString;
      }
      
      /********************************************************
      * Note: the setting of the focus DOES NOT WORK like
      * aField.focus();
      * You must call the focus function after the KEY
      * that made the user leave the field gets processed, 
      * so you MUST use a timer.
      ********************************************************/
      okToApply = false;
      focusField = aField;
      setTimeout( setTheFocus, 10 );
      return false;
   }
   else
      okToApply = true;
   
   return true;
}

//============================================================================================================

function verifyPrefixIPv6( aPrefixObj )
{
   number = Number(aPrefixObj.value);
   if( number < 1 || number > 128 )
   {
      alert("Invalid network prefix. It must be between 1 and 128.");
      /********************************************************
      * Note: the setting of the focus DOES NOT WORK like
      * aField.focus();
      * You must call the focus function after the KEY
      * that made the user leave the field gets processed, 
      * so you MUST use a timer.
      ********************************************************/
      okToApply = false;
      focusField = aPrefixObj;
      setTimeout( setTheFocus, 10 );
      return false;
   }
   
   return true;
}
   
//============================================================================================================   
   
function verifyGatewayIPv6( aGwObj, aIp, aPrefix )
{
   resultMsgIpv6 = "";   // Clear out each call.
   if( !verifyGatewayIPv6_( aGwObj.value, aIp, aPrefix ) )
   {
      alert( resultMsgIpv6 );
      
      /********************************************************
      * Note: the setting of the focus DOES NOT WORK like
      * aField.focus();
      * You must call the focus function after the KEY
      * that made the user leave the field gets processed, 
      * so you MUST use a timer.
      ********************************************************/
      okToApply = false;
      focusField = aGwObj;
      setTimeout( setTheFocus, 10 );
      return false;
   }
   return true;
}

/**************************************************************************
   IPv6 Address Space
   ---------------------------------------------------------------------
    IPv6 Prefix           Allocation              Reference      Note
   -----------           ----------              ---------      ----
   0000::/8              Reserved by IETF        [RFC4291]      [1] [5] 
   0100::/8              Reserved by IETF        [RFC4291]
   0200::/7              Reserved by IETF        [RFC4048]      [2]
   0400::/6              Reserved by IETF        [RFC4291]
   0800::/5              Reserved by IETF        [RFC4291]
   1000::/4              Reserved by IETF        [RFC4291]
   2000::/3              Global Unicast          [RFC4291]      [3]
   4000::/3              Reserved by IETF        [RFC4291]
   6000::/3              Reserved by IETF        [RFC4291]
   8000::/3              Reserved by IETF        [RFC4291]
   A000::/3              Reserved by IETF        [RFC4291]
   C000::/3              Reserved by IETF        [RFC4291]
   E000::/4              Reserved by IETF        [RFC4291]
   F000::/5              Reserved by IETF        [RFC4291]
   F800::/6              Reserved by IETF        [RFC4291]
   FC00::/7              Unique Local Unicast    [RFC4193]
   FE00::/9              Reserved by IETF        [RFC4291]
   FE80::/10             Link Local Unicast      [RFC4291]
   FEC0::/10             Reserved by IETF        [RFC3879]      [4]
   FF00::/8              Multicast               [RFC4291]
   
   Notes:

   [0]  The IPv6 address management function was formally delegated to
        IANA in December 1995 [RFC1881].
   
   [1]  The "unspecified address", the "loopback address", and the IPv6
        Addresses with Embedded IPv4 Addresses are assigned out of the
        0000::/8 address block.
   
   [2]  0200::/7 was previously defined as an OSI NSAP-mapped prefix set
        [RFC-gray-rfc1888bis-03.txt]. This definition has been deprecated
        as of December 2004 [RFC4048].
   
   [3]  The IPv6 Unicast space encompasses the entire IPv6 address range
        with the exception of FF00::/8. [RFC4291] IANA unicast address
        assignments are currently limited to the IPv6 unicast address
        range of 2000::/3. IANA assignments from this block are registered
        in the IANA registry: iana-ipv6-unicast-address-assignments.
   
   [4]  FEC0::/10 was previously defined as a Site-Local scoped address
        prefix. This definition has been deprecated as of September 2004
        [RFC3879].
   
   [5]  0000::/96 was previously defined as the "IPv4-compatible IPv6
        address" prefix.  This definition has been deprecated by [RFC4291].
*****************************************************************************/
   
var resultMsgIpv6 = "";   // Global used in the IPv6 validation functions.

//============================================================================================================

function verifyIPv6NoAlert( addr )
{
   var IPvalue = addr;
   var errorString = "";
   var ret;
   
   resultMsgIpv6 = "";
   theName = "Entered IP address";

   // See if the user passed a 0::0 in in any format:
   // First was there a net prefix on the Address
   tmp = IPvalue.split("/");
   if( tmp.length == 2 )
   {
      addr   = tmp[0];
      prefix = tmp[1];
   }
   else
   {
      addr   = tmp[0];
      prefix = "";
   }
   
   if(prefix != "") return false;
   
   // Now check for the 0 address
   var hexList;
   var iTmp = 0;
   hexList = IPvalue.split(":");
   for( i = 0; i < hexList.length; ++i )
      iTmp += hexList[i];
   if (iTmp == 0)
      errorString = errorString + theName + ' "'+IPvalue+'" is a special IP address and cannot be used here.';
   
   if( errorString == "" )
   {
      // The validateIPv6 function will display any errors.
      ret = validateIPv6( IPvalue )
   }
   
   if( errorString != "" || ret == false)
   {
   // Display the error and return the focus to the field.
      if( errorString != "" )
      {
         resultMsgIpv6 = resultMsgIpv6 + "\n" + errorString;
      }
      return false;
   }
   else
      okToApply = true;
   
   return true;
}

//============================================================================================================

function validateIPv6( aAddr )
{
   var prefix;
   var tmp;
   var addr;
   var ret = false;
   
   resultMsgIpv6 = "";   // Clear out each call.
   
   // First was there a net prefix on the Address
   tmp = aAddr.split("/");
   if( tmp.length == 2 )
   {
      addr   = tmp[0];
      prefix = tmp[1];
   }
   else
   {
      addr   = tmp[0];
      prefix = "";
   }

   ///////////////////////////////////////////
   // If the Address is all 0's ignore it.
   ///////////////////////////////////////////
   var hexList;
   var iTmp = 0;
   hexList = aAddr.split(":");
   for( i = 0; i < hexList.length; ++i )
      iTmp += hexList[i];
   if( iTmp == 0 )
      return true;

   if( checkFormatIPv6( addr ) )
   {
      var pattern = /[^a-fA-F0-9]/
      // Now Check each hextet
      hexList = addr.split(":");
      for( i = 0; i < hexList.length; ++i )
      {
         if( hexList[i].length > 4 )
            resultMsgIpv6 = ("Segment is to large in address segment " + (i+1) + " '" + hexList[i] + "'.");
         else if( hexList[i].match(pattern) )
            resultMsgIpv6 = ("Invalid character found in address segment " + (i+1) + " '" + hexList[i] + "'.");
         //else
            //resultMsgIpv6 = ("Match succedded " + hexList[i]);
      }
     // CR 70553 - Take out IPv6 address Range checking
     ret = true;   // So the code below will run.
      //if( resultMsgIpv6 == "" )
         //ret = checkAddressTypeIPv6( addr );
   }
   else
   {
        ret = false;
   }
   
   // Now check the prefix if one was passed in.
   if( ret != false )
      if( prefix.length > 0 )
         ret = verifyPrefixIPv6( prefix );
   
   if( resultMsgIpv6 != "" )
   {
      if(!suppressAlertsInIPV6)
      {
         alert( resultMsgIpv6 );
      }
      return false;
   }
   
   if( ret == false )
      return false;

   return true;
}

//============================================================================================================

function checkFormatIPv6( aAddr )
{   
   var hexList;
   var blank = 0;
   
   hexList = aAddr.split(":");
   if( hexList.length > 8 )
   {
      resultMsgIpv6 = ("To many segments in address " + aAddr + ".");
      return false;
   }
   else if( hexList.length < 3 )   // At least 2001::2
   {
      resultMsgIpv6 = ("Not enough segments in address " + aAddr + ".");
      return false;
   }
   
   if( aAddr[0] == ":" )
   {
      // !?! Not sure about this
      // The spec stated IPv4 address can be writtin as ::ffff:0:0/96
      // and ::1/128 is the loopback address - would this be valid anywhere??????
      resultMsgIpv6 = ("IP Address started with the delimiter in address " + aAddr + ".");
      return false;
   }
   
   for( i = 0; i < hexList.length; ++i )
   {
      if( hexList[i] == "" )
      {
         blank++;
         if( blank > 1 )
         {
            resultMsgIpv6 = ("Address contains more than one \"BLANK\" segment.");
            return false;
         }
      }
   }

   // If the list is smaller than 8, make sure they entered at least one blank segment.
   if( hexList.length < 8 && blank == 0 )
   {
      resultMsgIpv6 = ("There are not enough segments in the address " + aAddr + ".");
      return false;
   }
   return true;
}

//============================================================================================================

// CR 70553 - Take out IPv6 address Range checking
//            I got rid of calls to this function.
//            Search for 70553 to find the commented out code.
function checkAddressTypeIPv6( aAddr )
{
   var unicastMin   = 0x2000;
   var unicastMax   = 0x3FFF;
   var linkMin      = 0xFE80;
   var linkMax      = 0xFEBF;
   var siteMin      = 0xFEC0;
   var siteMax      = 0xFEFF;
   var num          = 0;
   
   hexList = aAddr.split(":");
   
   tmp = "0x" + hexList[0];
   number = Number(tmp);
   //alert("Hextet 0 = " + num + " | unicastMin = " + unicastMin);
   
   if( number >= unicastMin && number <= unicastMax )
      AddrType = "global unicast";
   else if( number >= linkMin && number <= linkMax )
      AddrType = "link-local unicast";
   else if( number >= siteMin && number <= siteMax )
      AddrType = "site-local unicast";
   else
   {
      resultMsgIpv6 = "Address is not a valid type of either:\n'global unicast', 'link-local unicast', or 'site-local unicast'.";
      AddrType = "";
      return false;
   }
   return true;
}

//============================================================================================================

function verifyGatewayIPv6_( aGw, aIp, aPrefix )
{
   var prefixNumber;
   var shiftbits;
   var mask;
   var network16bitFields;
   var ip16bitField;
   var gw16bitField;
   
   // First convert the address to the FULL version. Uncompress any ::
   aGw = uncompressIPv6( aGw );
   aIp = uncompressIPv6( aIp );

   prefixNumber = Number(aPrefix);
   network16bitFields = prefixNumber / 16;
   shiftbits = prefixNumber % 16;

   GW = aGw.split(":");
   IP = aIp.split(":");
   // The piece of the network addres that fits nicely into the 16bit fields
   for( i=0; i< network16bitFields; i++ )
   {   
      theGW = "0x"+ (GW[i]=="" ? "0" : GW[i]);
      theIP = "0x"+ (IP[i]=="" ? "0" : IP[i]);

      gw16bitField = parseInt(theGW);
      ip16bitField = parseInt(theIP);
      //alert( GW[i] +" | "+ theGW +" | "+ gw16bitField +"\n"+ IP[i] +" | "+ theIP +" | "+ ip16bitField );
      
      if( ip16bitField != gw16bitField )
      {
         resultMsgIpv6 = "Gateway and static IP address with current network prefix is not valid.";
         //resultMsgIpv6 = "Gateway and static IP address with current network prefix is not valid. "+ theGW +" - "+ theIP +" | "+ ip16bitField +" != "+ gw16bitField;
         return false;
      }
   }

   // The network piece of addres that does not fit nicely into 16bit field bounds(16,32,48,64,80,96,112,128)
   if( shiftbits > 0 )
   {
      // The part of the address that somewhere inside the 16bit field.
      ip16bitField = Number(IP[network16bitFields]);
      gw16bitField = Number(GW[network16bitFields]);

      // Create mask to use to compare gateway address with ip address. If
      // prefix was 37, this would be 5 bits past 32, so we shift 5, and do
      // an exclusive-or to create the following mask "1111100000000000"
      mask = 0xffff >> shiftbits;
      mask = mask ^ 0xFFFF;

      if( (ip16bitField & mask) != (gw16bitField & mask) )
      {
         resultMsgIpv6 = "Static IP address and Gateway with current network prefix is not valid.";
         return false;
      }
   }
   return true;
}

//============================================================================================================

function uncompressIPv6( aAddr )
{
   // First split the hextets into individual items
   hexList = aAddr.split(":");
   
   // Load the first one so we don;t have to deal with the ":" being first in the for loop
   var theRet = hexList[0];
   
   // Uncompress the passed address
   for( i=1; i < hexList.length; ++i )
   {
      if( hexList[i] == "" )
      {
         // Must be the one we want to uncompress
         for( j=0; j<(9-hexList.length); j++ )
         {
            theRet += (":" + "0");
         }
      }
      else
         theRet += (":" + hexList[i]);
   }
      
   //alert( "uncompressIPv6 = " + theRet );
   
   return theRet;
}

//============================================================================================================
/****************************************************************
 * Convert the string of octets passed in, into an int.
 * Note: This function can return a negitive number in the 1st 
 * octect.
 * bytes - An Array of octets
 * start - Whihc element in the array ios the first octet we are 
 *         concered about. (This is here becaeu the .match funtion
 *         puts the original string in element 0)
 ****************************************************************/
function OctetToInt(bytes, start)
{
   var result = 0;
   for (i = start; i < start+4; ++i)
   {
      result <<= 8;
      result |= parseInt(bytes[i]);
   }
   return parseInt(result);
}


//============================================================================================================
//
// Validate the entered text is a valid port number
//
function checkPort( field )
{
   if( !parseInt(field.value) )
   {
      alert('Please enter a valid number for the port');
      return false;
   }
   if( (field.value >= 65535) || (field.value <= 0) )
   {
      alert('Please enter a valid port number: 1-65535');
      return false;
   }

   return true;
}

//============================================================================================================

// If there is only one Partition do not bring up the partition select page.
function OnlyOnePartition( aLibCount, aFunc, aSelDiv )
{
   //alert("The data passed was " + aLibCount + ", " + aFunc + ", " + aSelDiv );
   if( aLibCount == 1 )
   {
      // Switch the Div to the new one automaticly
      aFunc();
   }
   else
   {
      // Make sure the SelectDiv is visable.
      if (getStyleObject(aSelDiv))
        {
         changeObjectVisibility(aSelDiv, "visible");
         changeObjectVisibility(aSelDiv+"_background", "visible");
      }
   }
   return true;
}

//============================================================================================================

//============================================================================================================

/****************************************************************
 * Verify that the data in the input field passed is a valid 
 * IPv4 address.
 * If aBlankOK is true then Blank IPs are OK
 * Also sets the Global Var okToApply according to the 
 * validation of the field.
 ****************************************************************/
function isValidIPv4_( aField, aBlankOK ) 
{
  var IPvalue = aField.value;
  
  // alert("IPv4 validating " + IPvalue);
  
  okToApply = false;  
  
  var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
  if (IPvalue == "0.0.0.0" && aBlankOK != "1")
     return false;
  if (IPvalue == "255.255.255.255")
     return false;
  if( IPvalue == ""  && aBlankOK != "1" )
     return false;
  else if( IPvalue == ""  && aBlankOK == "1" )
  {
     return true;
  }        

  var ipArray = IPvalue.match(ipPattern); 
  if (ipArray == null) 
     return false;
  else 
  {
    for (i = 1; i < 5; i++) 
    {
      thisSegment = ipArray[i];
      if (thisSegment > 255) 
      {
        return false;
        break;
      }
      if ((i == 0) && (thisSegment > 255)) 
      {
        return false;
        break;
      }
     }
  }

  okToApply = true;  
  return true;
}

//============================================================================================================

/****************************************************************
 * Verify that the data in the input field passed is a valid 
 * IPv6 address.
 * If aBlankOK is true then Blank IPs are OK
 * Also sets the Global Var okToApply according to the 
 * validation of the field.
 ****************************************************************/
function isValidIPv6_( aField, aBlankOK ) 
{
   var IPvalue = aField.value;
       
//   alert("IPv6 validating " + IPvalue);       
       
   okToApply = false;       
       
   // See if the user passed a 0::0 in in any format:
   // First was there a net prefix on the Address
   tmp = IPvalue.split("/");
   if( tmp.length == 2 )
   {
      addr   = tmp[0];
      prefix = tmp[1];
   }
   else
   {
      addr   = tmp[0];
      prefix = "";
   }

   if(prefix != "")
   {
      return false;
   }

   // Now check for the 0 address
   var hexList;
   var iTmp = 0;
   hexList = IPvalue.split(":");
   for( i = 0; i < hexList.length; ++i )
      iTmp += hexList[i];
   if (iTmp == 0 && aBlankOK != "1")
      return false
   
   // Now check for just a blank
   if( IPvalue == ""  && aBlankOK != "1" )
      return false;
   
   if( errorString == "" )
   {
      // The validateIPv6 function will display any errors.
      ret = validateIPv6( IPvalue )
      if(!ret)
      {
         return false;
      }
   }

   okToApply = true;   
   return true;
}

//============================================================================================================
//
// Ensure that the entered characters are either an IP or host name
//

function getIPEntryType(aField)
{
   var pattern = /[^\.:0-9_A-Za-z-]/;
   var patternV4 = /[^\.0-9]/;
   var string = aField.value;

   // alert("<"+string+">");

   // Now determine if we need to validate IPv6 or IPv4
   if( aField.value.search(":") != -1 )
   {
      if(isValidIPv6_( aField, false))
         return "IPV6";
      else
         return "INVALID";         
   }
   else 
   {
      tmp = aField.value.split(".");
      if( tmp.length >= 1 )   // Is it a HOSTNAME or IPv4 address
      {
         // if each section is a number it's an IPv4 address. Else assume a Valid Hostname and just exit
         if(! aField.value.match( patternV4 ) )
         {
            if(isValidIPv4_(aField, false))
            {
               return "IPV4";
            }
            else
               return "INVALID";         
         }
         else
            return "HOSTNAME";            
      }
      else
         return "INVALID";            
   }
   
   return "INVALID";   
}

//============================================================================================================
//
// Implementation of Array.indexOf for browsers that don't support it natively
//

if(!Array.indexOf)
{
    Array.prototype.indexOf = function(obj)
    {
        for(var i=0; i<this.length; i++)
        {
            if(this[i]==obj)
            {
                return i;
            }
        }
        return -1;
    }
}


//============================================================================================================
//
// A function to dump JavaScrip objects for debugging.
//
var MAX_DUMP_DEPTH = 10;
function dumpObj(obj, name, indent, depth)
{
    if (depth > MAX_DUMP_DEPTH)
    {
        return indent + name + ": <Maximum Depth Reached>\n";
    }
    if (typeof obj == "object") 
    {
        var child = null;
        var output = indent + name + "\n";
        indent += "\t";
        for (var item in obj)
        {
            try 
            {
                child = obj[item];
            } 
            catch (e) 
            {
                child = "<Unable to Evaluate>";
            }
            if (typeof child == "object") 
            {
                output += dumpObj(child, item, indent, depth + 1);
            } 
            else 
            {
                output += indent + item + ": " + child + "\n";
            }
        }
        return output;
    }
    else 
    {
        return obj;
    }
}

function RGB2HTML(red, green, blue)
{
    var decColor = red + 256 * green + 65536 * blue;
    return "#" + decColor.toString(16);
}
