
/******************************************************************************
* Copyright 1991-2008 by Quantum, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* Quantum, Inc.
*******************************************************************************/

// Name: ekm.js
//
// Purpose: Common JavaScript functions for Scalar i500 EKM-related UI pages
//
// $Id
//
// ##################################################################

// Globally defined port numbers
var SSLPORT = "443";
var STDPORT = "3801";

// Returns true if the given value matches either 443 or 3801
function checkPortValueStandard( port )
{
    return (port == SSLPORT || port == STDPORT)
}

// Determine if either of the current port values are non-standard.  If they
// are not either 443 or 3801, we will leave them alone.  Otherwise, we will
// toggle them to the correct default for the SSL selection.
function updatePortsForSSLToggle( sslChk, primPortTxt, secPortTxt )
{
    var useSSL = sslChk.checked;

    var isPrimStandard = checkPortValueStandard(primPortTxt.value);
    var isSecStandard = checkPortValueStandard(secPortTxt.value);

    // update primary port if necessary
    if( isPrimStandard && useSSL )
    {
        primPortTxt.value = SSLPORT;
    }
    else if( isPrimStandard && !useSSL )
    {
        primPortTxt.value = STDPORT;
    }

    // update secondary port if necessary
    if( isSecStandard && useSSL )
    {
        secPortTxt.value = SSLPORT;
    }
    else if( isSecStandard && !useSSL )
    {
        secPortTxt.value = STDPORT;
    }
}
