/****************************************************************************** 
 * Copyright 1991-2006 by Quantum, Inc.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * Quantum, Inc.
 *******************************************************************************/
/****************************************************************************** 
 * Name:  emailSetup.js
 * Purpose: Javascript functions for setting up the email system 
 * $Id: emailSetup.js 1.14 2007/06/05 16:48:48MDT Bill Gray (bgray) dev  $
 *******************************************************************************/

function applyEmailSetup()
{
   var setupForm = document.forms['SetupEmailForm'];
   var smtpAddress = setupForm.hostname;
   var acctname= setupForm.acctname;
   var pass= setupForm.acctpassword;
   var pass1= setupForm.acctpassword1;
   var email= setupForm.email;

   var res = true;

   var isvalidIP;
   var isValidDNS;
   /*##############################################################
    # Note: Some of this stuff is also being checked when the user
    # leaves the field, but it dosn't hurt to check twice.
    ##############################################################*/

   if( smtpAddress.value && smtpAddress.value.length > 0 && !checkHostOrIP(smtpAddress,1) )
   {
      res = false;
      // No need to alert here the verifyIP function does it for you
   }

   if( !checkValidEmailLoginAccount(acctname) )
   {
      res = false;
      alert("Invalid Login Account");
   }

   if( !checkEmailAddress(email, true) )
   {
      res = false;
   }

   if( setupForm.useAuth.checked )
   {
      /*
        if authorization is enabled, require a username be entered
      */
      if( acctname.value.length <= 0 )
      {
         res = false;
         alert("A \'Login Account\' must be entered when using Authentication");
         return;
      }

      /*##############################################################
       # Note: We are not checking password length here becasue this
       # is not our password. it's the password to the email server
       # the user is using and we have no control over what they
       # allow.
       ##############################################################*/

      if( pass.value != pass1.value )
      {
         res = false;
         alert("Password and confirmation must match");
      }
   }

   if( res )
   {
      var action = "Applying E-mail Settings ...";

      openProgressWindow(action, 0);
   }
   else
   {
      return;
   }
}


/****************************************************************
 * Check for a Valid email account name in the INPUT field passed.
 ****************************************************************/
function checkValidEmailLoginAccount(account)
{
   var pattern = /[^A-Za-z0-9_#@\.\\\/]/;
   var string = account.value;

   if( account.value.match(pattern) )
   {
      alert("Only A-Z, a-z, 0-9, '_', '@', '#', '/', '\\' and '.', are allowed in the account name.");
      // remove the invalid character and put focus on the input field
      string = string.slice(0,-1);
      account.value = string;
      account.focus();
      return(false);
   }
   return(true);
}


/****************************************************************
 * Check for a Valid IP Address in the INPUT field passed.
 ****************************************************************/
function checkIPAddrChar( aField )
{
  var pattern = /[^\.0-9_]/;
  var string = aField.value;

  if( string.match(pattern) )
  {
  /*##############################################################
   # NOTE: !?! You cannot POP up a dialog here or the OnChange
   # or OnBlur will also get ran.
   ##############################################################*/
    //alert("Only numbers, and periods are allowed in the IP Address string.");
    window.status = "Only numbers, and periods are allowed in the IP Address string!"

    // remove the invalid character and put focus on the input field
    string = string.slice(0,-1);
    aField.value = string;
    beep();
    return false;
  }
  else
   window.status = "";  // Clear any OLD errors

  return true;
}

/****************************************************************
 * Verify that the data in the input field passed is a valid
 * IP address.
 ****************************************************************/
function verifyIP_USETHEONEINCOMMON( aField )
{
  var IPvalue = aField.value;

  var errorString = "";
  theName = "IPaddress";

  var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
  if (IPvalue == "0.0.0.0")
    errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
  else if (IPvalue == "255.255.255.255")
    errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';

  var ipArray = IPvalue.match(ipPattern);
  if (ipArray == null)
    errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
  else
  {
    for (i = 1; i < 5; i++)
    {
      thisSegment = ipArray[i];
      if (thisSegment > 255)
      {
        errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
        break;
      }
      if ((i == 0) && (thisSegment > 255))
      {
        errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
        break;
      }
     }
  }

  if (errorString != "")
  {
    errorString = errorString + "\n\nPlease enter a valid IP Address in the form of 10.10.100.10";

    // Display the error and return the focus to the field.
    alert (errorString);
    window.status = errorString;

    /********************************************************
     * Note: the setting of the focus DOES NOT WORK like
     * aField.focus();
     * You must call the focus function after the KEY
     * that made the user leave the field gets processed,
     * so you MUST use a timer.
     ********************************************************/
    focusField = aField;
    setTimeout( setTheFocus, 10 );
    return false;
  }
  return true;
}
