/******************************************************************************
 * Copyright 1991-2009 by ADIC, Inc.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * ADIC, Inc.
 *******************************************************************************/
/******************************************************************************
 * Name:  menuDiagnosticslayout.js
 * Purpose: menu structure for admin diagnostics layout in Managed system
 *******************************************************************************/

var NoOffFirstLineMenus=4;      // Number of first level items

var LowBgColor='transparent';      // Background color when mouse is not over
var HighBgColor='#BCCBD1';      // Background color when mouse is over

var LowSubBgColor='transparent';    // Background color when mouse is not over on subs
var HighSubBgColor='#627A83';      // Background color when mouse is over on subs

var FontLowColor='black';      // Font color when mouse is not over
var FontHighColor='black';      // Font color when mouse is over

var FontSubLowColor='black';      // Font color subs when mouse is not over
var FontSubHighColor='#E6EBED';      // Font color subs when mouse is over

var FontSubLowGrey='#809CA6';      // Font color subs mouse not over (greyed out)
var FontSubHighGrey='#809CA6';      // Font color subs mouse over (greyed out)

var BorderColor='transparent';            // Border color

var BorderSubColor='#BCCBD1';      // Border color for subs
var BorderWidth=1;        // Border width
var BorderBtwnElmnts=0;        // Border between elements 1 or 0
var FontFamily="arial,helvetica"    // Font family menu items
var FontSize=10;          // Font size menu items
var FontBold=1;          // Bold menu items 1 or 0
var FontItalic=0;        // Italic menu items 1 or 0
var MenuTextCentered='left';      // Item text position 'left', 'center' or 'right'
var TopMenuTextCentered='center';    // Main Menu Tree, text position 'left', 'center' or 'right'
var MenuCentered='left';      // Menu horizontal position 'left', 'center' or 'right'
var MenuVerticalCentered='static';            // Menu vertical position 'top', 'middle','bottom' or static
var ChildOverlap=.1;        // horizontal overlap child/ parent
var ChildVerticalOverlap=.2;      // vertical overlap child/ parent
var StartTop=0;          // Menu offset x coordinate
var StartLeft=0;        // Menu offset y coordinate
var VerCorrect=0;        // Multiple frames y correction
var HorCorrect=1;        // Multiple frames x correction
var LeftPaddng=5;        // Left padding
var TopPaddng=5;        // Top padding
var FirstLineHorizontal=1;      // SET TO 1 FOR HORIZONTAL MENU, 0 FOR VERTICAL
var MenuFramesVertical=0;      // Frames in cols or rows 1 or 0
var DissapearDelay=400;       // delay before menu folds in
var TakeOverBgColor=1;        // Menu frame takes over background color subitem frame
var FirstLineFrame='topFrame';      // Frame where first level appears
var SecLineFrame='contentFrame';    // Frame where sub levels appear
var DocTargetFrame='contentFrame';    // Frame where target documents appear
var TargetLoc='';      // span id for relative positioning
var HideTop=0;          // Hide first level when loading new document 1 or 0
var MenuWrap=0;          // enables/ disables menu wrap 1 or 0
var RightToLeft=0;        // enables/ disables right to left unfold 1 or 0
var UnfoldsOnClick=0;        // Level 1 unfolds onclick/ onmouseover
var WebMasterCheck=0;        // menu tree checking on or off 1 or 0
var ShowArrow=1;        // Uses arrow gifs when 1
var KeepHilite=1;        // Keep selected path highligthed
var Arrws=['images/arrow.gif',5,10,'images/arrowdown.gif',5,10];  // Arrow source, width and height

function BeforeStart(){return}
function AfterBuild(){return}
function BeforeFirstOpen(){return}
function AfterCloseAll(){return}


// Menu tree
// MenuX=new Array(Text to show, Link, background image (optional), number of sub elements, height, width);
// For rollover images set "Text to show" to:  "rollover:Image1.jpg:Image2.jpg"
Menu1=new Array("EKM","","",1,24,70);
    Menu1_1=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
Menu2=new Array("Drives","","",2,24,70);
   Menu2_1=new Array("Drive Tests","","",1,24,190);
      Menu2_1_1=new Array("Drive Reset...",diagnosticsDriveResetDo,"",0,24,190);
   Menu2_2=new Array("Media Tests","","",4,24,190);
      Menu2_2_1=new Array("Drive Self Test...",diagnosticsDriveTestDo,"",0,24,190);
      Menu2_2_2=new Array("Read/Write Test...",diagnosticsDriveRWTestDo,"",0,24,190);
      Menu2_2_3=new Array("Fast Read/Write Test...",diagnosticsDriveFastRWTestDo,"",0,24,190);
      Menu2_2_4=new Array("Media Test...",diagnosticsDriveMediaTestDo,"",0,24,190);
Menu3=new Array("Robotics","","",1,24,70);
   Menu3_1=new Array("Robotics Get/Put Test...",roboticsGetPutTestDo,"",0,24,190);
Menu4=new Array("Exit","javascript:doExitDiagnostics();","",0,24,70);
