/****************************************************************************** 
 * Copyright 1991-2009 by Quantum Corporation.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * Quantum Corporation.
 *******************************************************************************/
/******************************************************************************
 * Name:  vpMenuAdminLayoutManaged.js
 * Purpose: menu structure for admin layout in Managed system
 * $Id: menuServiceLayout.js 1.85 2007/11/15 16:07:11MST Jim Boyd (jboyd) dev  $
 *******************************************************************************/

var NoOffFirstLineMenus=5;         // Number of first level items

var LowBgColor='transparent';      // Background color when mouse is not over
var HighBgColor='#BCCBD1';         // Background color when mouse is over

var LowSubBgColor='transparent';   // Background color when mouse is not over on subs
var HighSubBgColor='#627A83';      // Background color when mouse is over on subs

var FontLowColor='black';          // Font color when mouse is not over
var FontHighColor='black';         // Font color when mouse is over

var FontSubLowColor='black';       // Font color subs when mouse is not over
var FontSubHighColor='#E6EBED';    // Font color subs when mouse is over

var FontSubLowGrey='#809CA6';      // Font color subs mouse not over (greyed out)
var FontSubHighGrey='#809CA6';     // Font color subs mouse over (greyed out)

var BorderColor='transparent';     // Border color

var BorderSubColor='#BCCBD1';      // Border color for subs
var BorderWidth=1;                 // Border width
var BorderBtwnElmnts=0;            // Border between elements 1 or 0
var FontFamily="arial,helvetica"   // Font family menu items
var FontSize=10;                   // Font size menu items
var FontBold=1;                    // Bold menu items 1 or 0
var FontItalic=0;                  // Italic menu items 1 or 0
var MenuTextCentered='left';       // Item text position 'left', 'center' or 'right'
var TopMenuTextCentered='center';  // Main Menu Tree, text position 'left', 'center' or 'right'
var MenuCentered='left';           // Menu horizontal position 'left', 'center' or 'right'
var MenuVerticalCentered='static'; // Menu vertical position 'top', 'middle','bottom' or static
var ChildOverlap=.1;               // horizontal overlap child/ parent
var ChildVerticalOverlap=.2;       // vertical overlap child/ parent
var StartTop=0;                    // Menu offset x coordinate
var StartLeft=0;                   // Menu offset y coordinate
var VerCorrect=0;                  // Multiple frames y correction
var HorCorrect=1;                  // Multiple frames x correction
var LeftPaddng=5;                  // Left padding
var TopPaddng=5;                   // Top padding
var FirstLineHorizontal=1;         // SET TO 1 FOR HORIZONTAL MENU, 0 FOR VERTICAL
var MenuFramesVertical=0;          // Frames in cols or rows 1 or 0
var DissapearDelay=400;            // delay before menu folds in
var TakeOverBgColor=1;             // Menu frame takes over background color subitem frame
var FirstLineFrame='topFrame';     // Frame where first level appears
var SecLineFrame='contentFrame';   // Frame where sub levels appear
var DocTargetFrame='contentFrame'; // Frame where target documents appear
var TargetLoc='';                  // span id for relative positioning
var HideTop=0;                     // Hide first level when loading new document 1 or 0
var MenuWrap=0;                    // enables/ disables menu wrap 1 or 0
var RightToLeft=0;                 // enables/ disables right to left unfold 1 or 0
var UnfoldsOnClick=0;              // Level 1 unfolds onclick/ onmouseover
var WebMasterCheck=0;              // menu tree checking on or off 1 or 0
var ShowArrow=1;                   // Uses arrow gifs when 1
var KeepHilite=1;                  // Keep selected path highligthed
var Arrws=['images/arrow.gif',5,10,'images/arrowdown.gif',5,10];  // Arrow source, width and height

function BeforeStart(){return}
function AfterBuild(){return}
function BeforeFirstOpen(){return}
function AfterCloseAll(){return}


// Menu tree
//  MenuX=new Array(Text to show, Link, background image (optional), number of sub elements, height, width);
//  For rollover images set "Text to show" to:  "rollover:Image1.jpg:Image2.jpg"
if( hasBladeMenu )
{
   // With Blade Menus
   if( brand == 'dell' || brand == 'tandberg' )
   {
      Menu1=new Array("Setup","","",14,24,50);
      Menu1_1=new Array("Setup Wizard...",setupWizardDo,"",0,24,190);
      Menu1_2=new Array("Partitions...",logicalLibraryDo,"",0,24,190);
      Menu1_3=new Array("Cleaning Slots...",cleaningSlotsDo,"",0,24,190);
      Menu1_4=new Array("I/E Station Slots...",mailboxSlotsDo,"",0,24,190);
      Menu1_5=new Array("Drive Settings...",driveDo,"",0,24,190);
      Menu1_6=new Array("Control Path...",controlPathDo,"",0,24,190);
      Menu1_7=new Array("License...",licenseDo,"",0,24,190);
      Menu1_8=new Array("Notifications","","",3,24,190);
         Menu1_8_1=new Array("E-Mail Configuration...",emailSetupDo,"",0,24,180);
         Menu1_8_2=new Array("Advanced Reporting","","",1,24,180);
            //Menu1_8_2_1=new Array("Receiver Addresses...",arReceiverDo,"",0,24,180);
            Menu1_8_2_1=new Array("Media Security...",arMediaSecurityDo,"",0,24,180);
         Menu1_8_3=new Array("RAS","","",2,24,180);
            Menu1_8_3_1=new Array("Receiver Addresses...",notificationDo,"",0,24,180);
            Menu1_8_3_2=new Array("Contact Information...",contactSetupDo,"",0,24,180);
      Menu1_9=new Array("Network Management","","",3,24,210);
         Menu1_9_1=new Array("Network...",networkDo,"",0,24,210);
         Menu1_9_2=new Array("SNMP...",snmpDo,"",0,24,210);
         Menu1_9_3=new Array("SNMP Trap Registrations...",snmpTrapsDo,"",0,24,210);
      Menu1_10=new Array("User Management","","",2,24,190);
         Menu1_10_1=new Array("User Accounts...",usersDo,"",0,24,200);
         Menu1_10_2=new Array("Remote Authentication...",ldapDo,"",0,24,200);
      Menu1_11=new Array("I/O Blades","","",7,24,190);
         Menu1_11_1=new Array("Port Configuration...",IOBPortConfigDo,"",0,24,200);
         Menu1_11_2=new Array("Channel Zoning...",IOBChannelZoningDo,"",0,24,200);
         Menu1_11_3=new Array("Host Mapping...",IOBHostMappingDo,"",0,24,200);
         Menu1_11_4=new Array("Host Management...",IOBHostManagmentDo,"",0,24,200);
         Menu1_11_5=new Array("Host Port Failover...",IOBPortFailoverDo,"",0,24,200);
         Menu1_11_6=new Array("Data Path Conditioning...",IOBDataPathConDo,"",0,24,200);
         Menu1_11_7=new Array("I/O Blade Control...",IOBBladeControlDo,"",0,24,200);    //!?! Should this be called Blade Management
      Menu1_12=new Array("Encryption","","",2,24,190);
         Menu1_12_1=new Array("System Configuration...",ekmDo,"",0,24,200);
         Menu1_12_2=new Array("Partition Configuration...",ekmPartDELLDo,"",0,24,200);
      Menu1_13=new Array("System Settings...",sysSetDo,"",0,24,190);
      Menu1_14=new Array("Date & Time...",dateTimeDo,"",0,24,190);
   }
   else
   {
      Menu1=new Array("Setup","","",15,24,50);
      Menu1_1=new Array("Setup Wizard...",setupWizardDo,"",0,24,190);
      Menu1_2=new Array("Partitions...",logicalLibraryDo,"",0,24,190);
      Menu1_3=new Array("Cleaning Slots...",cleaningSlotsDo,"",0,24,190);
      Menu1_4=new Array("I/E Station Slots...",mailboxSlotsDo,"",0,24,190);
      Menu1_5=new Array("Drive Settings...",driveDo,"",0,24,190);
      Menu1_6=new Array("Control Path...",controlPathDo,"",0,24,190);
      Menu1_7=new Array("License...",licenseDo,"",0,24,190);
      Menu1_8=new Array("Notifications","","",3,24,190);
         Menu1_8_1=new Array("E-Mail Configuration...",emailSetupDo,"",0,24,180);
         Menu1_8_2=new Array("Advanced Reporting","","",1,24,180);
            //Menu1_8_2_1=new Array("Receiver Addresses...",arReceiverDo,"",0,24,180);
            Menu1_8_2_1=new Array("Media Security...",arMediaSecurityDo,"",0,24,180);
         Menu1_8_3=new Array("RAS","","",2,24,180);
            Menu1_8_3_1=new Array("Receiver Addresses...",notificationDo,"",0,24,180);
            Menu1_8_3_2=new Array("Contact Information...",contactSetupDo,"",0,24,180);
      Menu1_9=new Array("Network Management","","",3,24,210);
         Menu1_9_1=new Array("Network...",networkDo,"",0,24,210);
         Menu1_9_2=new Array("SNMP...",snmpDo,"",0,24,210);
         Menu1_9_3=new Array("SNMP Trap Registrations...",snmpTrapsDo,"",0,24,210);
      Menu1_10=new Array("User Management","","",2,24,190);
         Menu1_10_1=new Array("User Accounts...",usersDo,"",0,24,200);
         Menu1_10_2=new Array("Remote Authentication...",ldapDo,"",0,24,200);
      Menu1_11=new Array("I/O Blades","","",7,24,190);
         Menu1_11_1=new Array("Port Configuration...",IOBPortConfigDo,"",0,24,200);
         Menu1_11_2=new Array("Channel Zoning...",IOBChannelZoningDo,"",0,24,200);
         Menu1_11_3=new Array("Host Mapping...",IOBHostMappingDo,"",0,24,200);
         Menu1_11_4=new Array("Host Management...",IOBHostManagmentDo,"",0,24,200);
         Menu1_11_5=new Array("Host Port Failover...",IOBPortFailoverDo,"",0,24,200);
         Menu1_11_6=new Array("Data Path Conditioning...",IOBDataPathConDo,"",0,24,200);
         Menu1_11_7=new Array("I/O Blade Control...",IOBBladeControlDo,"",0,24,200);    //!?! Should this be called Blade Management
      Menu1_12=new Array("Encryption","","",2,24,190);
         Menu1_12_1=new Array("System Configuration...",ekmDo,"",0,24,200);
         Menu1_12_2=new Array("Partition Configuration...",ekmPartDo,"",0,24,200);
      Menu1_13=new Array("System Settings...",sysSetDo,"",0,24,190);
      Menu1_14=new Array("Date & Time...",dateTimeDo,"",0,24,190);
      Menu1_15=new Array("Register Library","javascript:doRegistration();","",0,24,190);
   }
}
else
{
   // Without Blade menus    
   if( brand == 'dell' || brand == 'tandberg' )
   {
      Menu1=new Array("Setup","","",13,24,50);
      Menu1_1=new Array("Setup Wizard...",setupWizardDo,"",0,24,190);
      Menu1_2=new Array("Partitions...",logicalLibraryDo,"",0,24,190);
      Menu1_3=new Array("Cleaning Slots...",cleaningSlotsDo,"",0,24,190);
      Menu1_4=new Array("I/E Station Slots...",mailboxSlotsDo,"",0,24,190);
      Menu1_5=new Array("Drive Settings...",driveDo,"",0,24,190);
      Menu1_6=new Array("Control Path...",controlPathDo,"",0,24,190);
      Menu1_7=new Array("License...",licenseDo,"",0,24,190);
      Menu1_8=new Array("Notifications","","",3,24,190);
         Menu1_8_1=new Array("E-Mail Configuration...",emailSetupDo,"",0,24,180);
         Menu1_8_2=new Array("Advanced Reporting","","",1,24,180);
            //Menu1_8_2_1=new Array("Receiver Addresses...",arReceiverDo,"",0,24,180);
            Menu1_8_2_1=new Array("Media Security...",arMediaSecurityDo,"",0,24,180);
         Menu1_8_3=new Array("RAS","","",2,24,180);
            Menu1_8_3_1=new Array("Receiver Addresses...",notificationDo,"",0,24,180);
            Menu1_8_3_2=new Array("Contact Information...",contactSetupDo,"",0,24,180);
      Menu1_9=new Array("Network Management","","",3,24,210);
         Menu1_9_1=new Array("Network...",networkDo,"",0,24,210);
         Menu1_9_2=new Array("SNMP...",snmpDo,"",0,24,210);
         Menu1_9_3=new Array("SNMP Trap Registrations...",snmpTrapsDo,"",0,24,210);
      Menu1_10=new Array("User Management","","",2,24,190);
         Menu1_10_1=new Array("User Accounts...",usersDo,"",0,24,200);
         Menu1_10_2=new Array("Remote Authentication...",ldapDo,"",0,24,200);
      Menu1_11=new Array("Encryption","","",2,24,190);
         Menu1_11_1=new Array("System Configuration...",ekmDo,"",0,24,200);
         Menu1_11_2=new Array("Partition Configuration...",ekmPartDELLDo,"",0,24,200);
      Menu1_12=new Array("System Settings...",sysSetDo,"",0,24,190);
      Menu1_13=new Array("Date & Time...",dateTimeDo,"",0,24,190);
   }
   else
   {
      Menu1=new Array("Setup","","",14,24,50);
      Menu1_1=new Array("Setup Wizard...",setupWizardDo,"",0,24,190);
      Menu1_2=new Array("Partitions...",logicalLibraryDo,"",0,24,190);
      Menu1_3=new Array("Cleaning Slots...",cleaningSlotsDo,"",0,24,190);
      Menu1_4=new Array("I/E Station Slots...",mailboxSlotsDo,"",0,24,190);
      Menu1_5=new Array("Drive Settings...",driveDo,"",0,24,190);
      Menu1_6=new Array("Control Path...",controlPathDo,"",0,24,190);
      Menu1_7=new Array("License...",licenseDo,"",0,24,190);
      Menu1_8=new Array("Notifications","","",3,24,190);
         Menu1_8_1=new Array("E-Mail Configuration...",emailSetupDo,"",0,24,180);
         Menu1_8_2=new Array("Advanced Reporting","","",1,24,180);
            //Menu1_8_2_1=new Array("Receiver Addresses...",arReceiverDo,"",0,24,180);
            Menu1_8_2_1=new Array("Media Security...",arMediaSecurityDo,"",0,24,180);
         Menu1_8_3=new Array("RAS","","",2,24,180);
            Menu1_8_3_1=new Array("Receiver Addresses...",notificationDo,"",0,24,180);
            Menu1_8_3_2=new Array("Contact Information...",contactSetupDo,"",0,24,180);
      Menu1_9=new Array("Network Management","","",3,24,210);
         Menu1_9_1=new Array("Network...",networkDo,"",0,24,210);
         Menu1_9_2=new Array("SNMP...",snmpDo,"",0,24,210);
         Menu1_9_3=new Array("SNMP Trap Registrations...",snmpTrapsDo,"",0,24,210);
      Menu1_10=new Array("User Management","","",2,24,190);
         Menu1_10_1=new Array("User Accounts...",usersDo,"",0,24,200);
         Menu1_10_2=new Array("Remote Authentication...",ldapDo,"",0,24,200);
      Menu1_11=new Array("Encryption","","",2,24,190);
         Menu1_11_1=new Array("System Configuration...",ekmDo,"",0,24,200);
         Menu1_11_2=new Array("Partition Configuration...",ekmPartDo,"",0,24,200);
      Menu1_12=new Array("System Settings...",sysSetDo,"",0,24,190);
      Menu1_13=new Array("Date & Time...",dateTimeDo,"",0,24,190);
      Menu1_14=new Array("Register Library","javascript:doRegistration();","",0,24,190);
   }
}

Menu2=new Array("Operations","","",7,24,80);
Menu2_1=new Array("Media","","",3,24,200);
   Menu2_1_1=new Array("Move...",moveMediaDo,"",0,24,190);
   Menu2_1_2=new Array("Import...",importMediaDo,"",0,24,190);
   Menu2_1_3=new Array("Export...",exportMediaDo,"",0,24,190);
Menu2_2=new Array("Cleaning Media","","",2,24,190);
   Menu2_2_1=new Array("Import...",importCleaningMediaDo,"",0,24,190);
   Menu2_2_2=new Array("Export...",exportCleaningMediaDo,"",0,24,190);
Menu2_3=new Array("Partitions","","",1,24,190);
   Menu2_3_1=new Array("Change Mode...",libraryModeDo,"",0,24,190);
Menu2_4=new Array("Drive","","",3,24,190);
   Menu2_4_1=new Array("Load...",driveLoadDo,"",0,24,190);
   Menu2_4_2=new Array("Unload...",driveUnloadDo,"",0,24,190);
   Menu2_4_3=new Array("Change Mode...",driveModeDo,"",0,24,190);
Menu2_5=new Array("I/E Station Lock/Unlock....",ieDoorDo,"",0,24,190);
Menu2_6=new Array("System Shutdown...",shutdownDo,"",0,24,190);
Menu2_7=new Array("Log Out","javascript:confirmLogOut();","",0,24,190);

   /*########################################################################################################################
    # NOTE: DELL and !ekmLicensed have the same menus in service but to keep the code consistant between admin & service 
    # I added the extra logic here too. Before I did this the "Reset Defaults" was mistakenly being shown in admin. 
    # Since this menu code is soo hacked I figured it would be easier for the programmer to have the same ifs in both files.
    ########################################################################################################################*/

if( hasBladeMenu )
{
   // With Blade Menus
   if( brand == 'dell' )
       Menu3=new Array("Tools","","",13,24,50);
   else if( !ekmLicensed ) 
       Menu3=new Array("Tools","","",13,24,50);
   else
       Menu3=new Array("Tools","","",14,24,50);
   Menu3_1=new Array("All RAS Tickets...",systemStatusDo,"",0,24,225);
   Menu3_2=new Array("Capture Snapshot...",captureStateDo,"",0,24,225);
   Menu3_3=new Array("Save/Restore Configuration...",saveRestoreDo,"",0,24,225);
   Menu3_4=new Array("E-mail Configuration Record...",configRecordDo,"",0,24,225);
   Menu3_5=new Array("Save Configuration Record...",configRecordSaveDo,"",0,24,225);
   Menu3_6=new Array("Identify Drives...",identifyPortsDo,"",0,24,205);
   Menu3_7=new Array("Drive Operations...",updateFirmwareDo,"",0,24,225);
   Menu3_8=new Array("Download SNMP MIB...",downloadMIBDo,"",0,24,130);
   Menu3_9=new Array("I/O Blade Info",IOBBladeInfoDo,"",0,24,225);
   Menu3_10=new Array("I/O Blade Port Info",IOBPortStatusDo,"",0,24,225);
   if( brand == 'dell' )
   {
       Menu3_11=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
       Menu3_12=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
       Menu3_13=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
   else if( !ekmLicensed )
   {
       Menu3_11=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
       Menu3_12=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
       Menu3_13=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
   else
   {
       Menu3_11=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
       Menu3_12=new Array("QKM Management","","",3,24,190);
          Menu3_12_1=new Array("Encryption Certificate","","",2,24,220);
              Menu3_12_1_1=new Array("Import...",qkmCertImportDo,"",0,24,100);
              Menu3_12_1_2=new Array("Export...",qkmCertExportDo,"",0,24,100);
          Menu3_12_2=new Array("Encryption Key","","",2,24,190);
              Menu3_12_2_1=new Array("Import...",qkmKeyImportDo,"",0,24,100);
              Menu3_12_2_2=new Array("Export...",qkmKeyExportDo,"",0,24,100);
          Menu3_12_3=new Array("Retrieve QKM Logs...",qkmRetrieveLogsDo,"",0,24,190);
       Menu3_13=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
       Menu3_14=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
}
else
{
   // Without Blade Menus
   if( brand == 'dell' )
       Menu3=new Array("Tools","","",11,24,50);
   else if( !ekmLicensed )
       Menu3=new Array("Tools","","",11,24,50);
   else
       Menu3=new Array("Tools","","",12,24,50);
   Menu3_1=new Array("All RAS Tickets...",systemStatusDo,"",0,24,225);
   Menu3_2=new Array("Capture Snapshot...",captureStateDo,"",0,24,225);
   Menu3_3=new Array("Save/Restore Configuration...",saveRestoreDo,"",0,24,225);
   Menu3_4=new Array("E-mail Configuration Record...",configRecordDo,"",0,24,225);
   Menu3_5=new Array("Save Configuration Record...",configRecordSaveDo,"",0,24,225);
   Menu3_6=new Array("Identify Drives...",identifyPortsDo,"",0,24,205);
   Menu3_7=new Array("Drive Operations...",updateFirmwareDo,"",0,24,225);
   Menu3_8=new Array("Download SNMP MIB...",downloadMIBDo,"",0,24,130);
   if( brand == 'dell')
   {
       Menu3_9=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
       Menu3_10=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
       Menu3_11=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
   else if( !ekmLicensed )
   {
       Menu3_9=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
       Menu3_10=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
       Menu3_11=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
   else
   {
      Menu3_9=new Array("EKM Path Diagnostics...",ekmTestDo,"",0,24,225);
      Menu3_10=new Array("QKM Management","","",3,24,190);
         Menu3_10_1=new Array("Encryption Certificate","","",2,24,220);
             Menu3_10_1_1=new Array("Import...",qkmCertImportDo,"",0,24,100);
             Menu3_10_1_2=new Array("Export...",qkmCertExportDo,"",0,24,100);
         Menu3_10_2=new Array("Encryption Key","","",2,24,190);
             Menu3_10_2_1=new Array("Import...",qkmKeyImportDo,"",0,24,100);
             Menu3_10_2_2=new Array("Export...",qkmKeyExportDo,"",0,24,100);
         Menu3_10_3=new Array("Retrieve QKM Logs...",qkmRetrieveLogsDo,"",0,24,190);
      Menu3_11=new Array("Update Library Firmware...",updateSoftwareDo,"",0,24,225);
      Menu3_12=new Array("Reset Factory Defaults",resetDefaultsDo,"",0,24,225);
   }
}

    Menu4=new Array("Reports","","",8,24,70);
  if( brand == 'dell' )
    Menu4_1=new Array("System Information","javascript:showSystemInfoReport(systemConfigurationDELLDo)","",0,24,200);
  else
    Menu4_1=new Array("System Information","javascript:showSystemInfoReport(systemConfigurationDo)","",0,24,200);

    Menu4_2=new Array("Library Configuration","javascript:showConfigReportLarge('libConfig.htm?showLoc=1')","",0,24,200);
    Menu4_3=new Array("Network Settings","javascript:showNetworkReport('reportNetwork.htm?showLoc=1')","",0,24,200);
    Menu4_4=new Array("Logged In Users","javascript:showUserLoginsReport(reportUserLoginDo);","",0,24,200);
    Menu4_5=new Array("All Slots","javascript:showMediaReport('reportAllSlotsAndMailbox.htm');","",0,24,200);
    Menu4_6=new Array("Log Viewer...",logSelectDo,"",0,24,225);
    Menu4_7=new Array("Advanced Reporting","","",2,24,225);
        Menu4_7_1=new Array("Drive Resource Utilization...",reportdriveUtilDo,"",0,24,225);
        Menu4_7_2=new Array("Media Integrity Analysis...",reportMediaIntegrityDo,"",0,24,225);
    Menu4_8=new Array("About","","",2,24,200);
        Menu4_8_1=new Array(jsLIBTYPE_NAME,"javascript:showToolsAbout('about.htm');","",0,24,200);
        Menu4_8_2=new Array("Open Source Licenses","javascript:launchOemLicense();","",0,24,200);
Menu5=new Array("Service","","",1,24,60);
Menu5_1=new Array("Start Service Wizard",serviceMenuDo,"",0,24,150);

