/****************************************************************************** 
 * Copyright 1991-2009 by Quantum, Inc.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * Quantum, Inc.
 *******************************************************************************//******************************************************************************
* Name:  menuUserLayout.js
* Purpose: menu structure for admin layout in Managed system
* $Id: menuUserLayout.js 1.31 2007/03/15 14:54:54MDT Bill Gray (bgray) dev  $
*******************************************************************************/
  var NoOffFirstLineMenus=2;         // Number of first level items

  var LowBgColor='transparent';      // Background color when mouse is not over
  var HighBgColor='#BCCBD1';         // Background color when mouse is over

  var LowSubBgColor='transparent';   // Background color when mouse is not over on subs
  var HighSubBgColor='#627A83';      // Background color when mouse is over on subs

  var FontLowColor='black';          // Font color when mouse is not over
  var FontHighColor='black';         // Font color when mouse is over

  var FontSubLowColor='black';       // Font color subs when mouse is not over
  var FontSubHighColor='#E6EBED';    // Font color subs when mouse is over

  var FontSubLowGrey='#809CA6';      // Font color subs mouse not over (greyed out)
  var FontSubHighGrey='#809CA6';     // Font color subs mouse over (greyed out)

  var BorderColor='transparent';     // Border color

  var BorderSubColor='#BCCBD1';      // Border color for subs
  var BorderWidth=1;                 // Border width
  var BorderBtwnElmnts=0;            // Border between elements 1 or 0
  var FontFamily="arial,helvetica"   // Font family menu items
  var FontSize=10;                   // Font size menu items
  var FontBold=1;                    // Bold menu items 1 or 0
  var FontItalic=0;                  // Italic menu items 1 or 0
  var MenuTextCentered='left';       // Item text position 'left', 'center' or 'right'
  var TopMenuTextCentered='center';  // Main Menu Tree, text position 'left', 'center' or 'right'
  var MenuCentered='left';           // Menu horizontal position 'left', 'center' or 'right'
  var MenuVerticalCentered='static'; // Menu vertical position 'top', 'middle','bottom' or static
  var ChildOverlap=.1;               // horizontal overlap child/ parent
  var ChildVerticalOverlap=.2;       // vertical overlap child/ parent
  var StartTop=0;                    // Menu offset x coordinate
  var StartLeft=0;                   // Menu offset y coordinate
  var VerCorrect=0;                  // Multiple frames y correction
  var HorCorrect=1;                  // Multiple frames x correction
  var LeftPaddng=5;                  // Left padding
  var TopPaddng=3;                   // Top padding
  var FirstLineHorizontal=1;         // SET TO 1 FOR HORIZONTAL MENU, 0 FOR VERTICAL
  var MenuFramesVertical=0;          // Frames in cols or rows 1 or 0
  var DissapearDelay=400;            // delay before menu folds in
  var TakeOverBgColor=1;             // Menu frame takes over background color subitem frame
  var FirstLineFrame='topFrame';     // Frame where first level appears
  var SecLineFrame='contentFrame';   // Frame where sub levels appear
  var DocTargetFrame='contentFrame'; // Frame where target documents appear
  var TargetLoc='';                  // span id for relative positioning
  var HideTop=0;                     // Hide first level when loading new document 1 or 0
  var MenuWrap=0;                    // enables/ disables menu wrap 1 or 0
  var RightToLeft=0;                 // enables/ disables right to left unfold 1 or 0
  var UnfoldsOnClick=0;              // Level 1 unfolds onclick/ onmouseover
  var WebMasterCheck=0;              // menu tree checking on or off 1 or 0
  var ShowArrow=1;                   // Uses arrow gifs when 1
  var KeepHilite=1;                  // Keep selected path highligthed
  var Arrws=['images/arrow.gif',5,10,'images/arrowdown.gif',5,10];  // Arrow source, width and height

    function BeforeStart(){return}
    function AfterBuild(){return}
    function BeforeFirstOpen(){return}
    function AfterCloseAll(){return}


// Menu tree
// MenuX=new Array(Text to show, Link, background image (optional), number of sub elements, height, width);
// For rollover images set "Text to show" to:  "rollover:Image1.jpg:Image2.jpg"
    Menu1=new Array("Operations","","",5,24,80);
        Menu1_1=new Array("Media","","",3,24,175);
            Menu1_1_1=new Array("Move...",moveMediaDo,"",0,24,100);
            Menu1_1_2=new Array("Import...",importMediaDo,"",0,24,100);
            Menu1_1_3=new Array("Export...",exportMediaDo,"",0,24,100);
        Menu1_2=new Array("Cleaning Media","","",2,24,175);
            Menu1_2_1=new Array("Import...",importCleaningMediaDo,"",0,24,100);
            Menu1_2_2=new Array("Export...",exportCleaningMediaDo,"",0,24,100);
        Menu1_3=new Array("Partitions","","",1,24,175);
            Menu1_3_1=new Array("Change Mode...",libraryModeDo,"",0,24,135);
        Menu1_4=new Array("Drive","","",3,24,175);
            Menu1_4_1=new Array("Load...",driveLoadDo,"",0,24,135);
            Menu1_4_2=new Array("Unload...",driveUnloadDo,"",0,24,135);
            Menu1_4_3=new Array("Change Mode...",driveModeDo,"",0,24,135);
//          Menu1_4_4=new Array("Clean",driveCleanDo,"",0,24,135);
        Menu1_5=new Array("Log Out","javascript:confirmLogOut();","",0,24,175);

    Menu2=new Array("Reports","","",5,24,70);
      if( brand == 'dell' )
        Menu2_1=new Array("System Information","javascript:showSystemInfoReport(systemConfigurationDELLDo)","",0,24,180);
      else
        Menu2_1=new Array("System Information","javascript:showSystemInfoReport(systemConfigurationDo)","",0,24,180);

        Menu2_2=new Array("Library Configuration","javascript:showConfigReportLarge('libConfig.htm?showLoc=1')","",0,24,180);
        Menu2_3=new Array("Network Settings","javascript:showNetworkReport('reportNetwork.htm?showLoc=1')","",0,24,180);
//      Menu2_5=new Array("Logged in Users","javascript:showUserLoginsReport('reportUserLogins.htm');","",0,24,180);
        Menu2_4=new Array("All Slots","javascript:showMediaReport('reportAllSlotsAndMailbox.htm');","",0,24,180);
        Menu2_5=new Array("About","","",2,24,190);
        Menu2_5_1=new Array(jsLIBTYPE_NAME,"javascript:showToolsAbout('about.htm');","",0,24,180);
        Menu2_5_2=new Array("Open Source Licenses","javascript:launchOemLicense();","",0,24,180);



