/****************************************************************************** 
*
* Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* ADIC, Inc.
*******************************************************************************/
/****************************************************************************** 
* Name: moveMedia.js
* Purpose: Javascript functions creating, modifying, and deleting libraries
* $Id: moveMedia.js 1.19 2007/04/18 16:46:29MDT Bill Gray (bgray) dev  $
*******************************************************************************/

// This function checks to make sure a user was selected
// and then asks for confimation from the operator whether
// or not he wants to delete the user.

// global variables
var libAvailable;
var globalNumberMedia;

// These are global for modify Library summary
var g_libraryName;
var g_libraryType;
var g_emulationType;


function mediaSelected(aRb)
{
   if( aRb.checked )
   {
      setSourceMediaValue(aRb);
      return;
   }
   alert("No barcodes have been selected");
}

function setSourceMediaValue(aRb)
{
   if( aRb != null )
   {
      var valueList = aRb.value.split(":");
   
      var sourceGUID = valueList[0];
      var mediaTypeCode = valueList[1];
      var libraryGUID = parent.document.forms['resultForm'].libraryGUID.value;
   
      parent.document.forms['resultForm'].sourceGUID.value = sourceGUID;
   
      // only resubmit if media type is different
      if( (mediaTypeCode != "") && (sourceGUID != "") && 
        (mediaTypeCode != parent.document.forms['resultForm'].mediaTypeCode.value))
      {
         
         parent.document.forms['resultForm'].mediaTypeCode.value = mediaTypeCode;
         parent.document.forms['destForm'].mediaTypeCode.value = mediaTypeCode;
   
         parent.document.getElementById('destList').src = 
             "moveMediaDestList.htm?libraryGUID=" + libraryGUID + 
             "&mediaTypeCode=" + mediaTypeCode;
      }
      else
         return;   // Do not show the clock below.
   }
   else
   {
      parent.document.getElementById('destList').src = 
             "moveMediaDestList.htm?libraryGUID=0"+ 
             "&mediaTypeCode=0";
   }

   var bg = parent.frames['destList'].getStyleObject('LoadingBG');
   var bgC = parent.frames['destList'].getStyleObject('LoadingClock');
      // Note - these are not valid on the first load becaseu the page is still blamk.htm
   if( bg )
      bg.visibility = 'visible';
   if( bgC )
      bgC.visibility = 'visible';

}


function selectInitialMedia()
{
   var gotone = 0;
   var radioList = document.getElementsByTagName('input');

   parent.document.forms['resultForm'].mediaTypeCode.value = "";

   for (i=0; i<radioList.length; i++) 
   {
      if( radioList[i].type == 'radio' )
      {
         radioList[i].checked = 1;
         setSourceMediaValue(radioList[i]);
         gotone = 1;
         break;
      }
   }
   if( !gotone )
        setSourceMediaValue(null);
}

function doMoveMedia()
{
   // 
   // Insure there is a valid source media and valid destination selected
   //
   var gotone = 0;
   var radioList = self.frames["sourceList"].document.forms[0].getElementsByTagName('input');

   for (i=0; i<radioList.length; i++)
   {
      if( (radioList[i].type == 'radio') && (radioList[i].checked) )
      {
         gotone = 1;
         break;
      }
   }

   if( !gotone )
   {
      alert('Please select media to move');
      return;
   }

   gotone = 0;
   var radioList = self.frames["destList"].document.forms[0].getElementsByTagName('input');

   for (i=0; i<radioList.length; i++)
   {
      if( (radioList[i].type == 'radio') && (radioList[i].checked) )
      {

         document.forms['resultForm'].destGUID.value = radioList[i].value;
         gotone = 1;
         break;
      }
   }

   if( !gotone )
   {
      alert('Please select a destination location');
      return;
   }

   // Caution the user the Lib will be taken Offline
   if( !cautionLibOffline() )
      return;

   var action = "Moving Media";

   openProgressWindow(action, 3);
}


function next()
{
   var libs = document.forms['libraryForm'].getElementsByTagName('input');

   for (i = 0; i < libs.length; i++)
   {
      if( (libs[i].type == "radio") && (libs[i].checked) )
      {
         var lib = libs[i].value;
         var litems = lib.split(":");

         document.getElementById('libraryNameMedia').innerHTML = 
           "<b>" + litems[0] + " (" + litems[2] + ")" + "</b>";

         document.forms['resultForm'].libraryGUID.value = litems[1];
         document.forms['sourceForm'].libraryGUID.value = litems[1];
         document.forms['destForm'].libraryGUID.value = litems[1];

         document.getElementById('sourceList').src = "moveMediaSourceList.htm?libraryGUID=" + litems[1];

         switchDiv('header','selectLocations');
         return;
      }
   }
   alert("Please select a partition.");
}
