/****************************************************************************** 
*
* Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* ADIC, Inc.
*******************************************************************************/
/****************************************************************************** 
* Name:  setupDateTime.js
* Purpose: Javascript functions for setting system date and time
* $Id: setupDateTime.js 1.8 2007/07/25 09:38:18MDT Bill Gray (bgray) dev Bill Gray (bgray)(2007/11/16 09:21:51MST) $
*******************************************************************************/

var MONTHS = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
var DAYS = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
var NEED_REBOOT=false;

//==================================================================================================================


function TZSwitch()
{
//  alert("TZSwitch() Called");

  var theForm = document.forms.dateTimeForm;

  if( theForm.chkUseCustomTZ.checked )
  {
    changeObjectVisibility("TZCustomDiv", "visible");
    changeObjectVisibility("TZSelectFromListDiv", "hidden");
    theForm.chkUseCustomDST.disabled = false;
    changeObjectVisibility("lblUseCustomDST", "hidden");
    document.getElementById("useCustomTZCurrentSetting").innerHTML = 'Enabled';    
  }
  else
  {
    changeObjectVisibility("TZCustomDiv", "hidden");
    changeObjectVisibility("TZSelectFromListDiv", "visible");
    theForm.chkUseCustomDST.disabled = true;
    changeObjectVisibility("lblUseCustomDST", "visible");
    theForm.chkUseCustomDST.checked = false;
    document.getElementById("useCustomTZCurrentSetting").innerHTML = 'Disabled';
    DSTCustomSwitch();        
  }
}   

//==================================================================================================================

function DSTCustomSwitch()
{
//  alert("DSTCustomSwitch() Called");

  var theForm = document.forms.dateTimeForm;
  
  if(!theForm.chkUseCustomTZ.checked)
  {
     theForm.chkUseCustomDST.checked = false;
  }

  if (theForm.chkUseCustomDST.checked && theForm.chkUseCustomTZ.checked)
  {
    changeObjectVisibility("DSTCustomDiv", "visible");
    document.getElementById("useCustomDSTCurrentSetting").innerHTML = 'Enabled';
    DSTCustomTypeSwitch();    
  }
  else
  {
    changeObjectVisibility("DSTCustomDiv", "hidden");
    document.getElementById("useCustomDSTCurrentSetting").innerHTML = 'Disabled';
    hideDSTCustomType();    
  }
}   

//==================================================================================================================

function DSTCustomTypeSwitch()
{

//  alert("DSTCustomTypeSwitch() Called");

  var theForm = document.forms.dateTimeForm;

  if(theForm.rbCustomDST[0].checked == true)
  {
    changeObjectVisibility("DSTExactDiv", "visible");
    changeObjectVisibility("DSTMWDDiv", "hidden");
    document.getElementById("useCustomDSTSettingMethod").innerHTML = 'Set Exact Date';    
  }
  else
  {
    changeObjectVisibility("DSTExactDiv", "hidden");
    changeObjectVisibility("DSTMWDDiv", "visible");
    document.getElementById("useCustomDSTSettingMethod").innerHTML = 'Set Month/Week/Day';    
  }
}   

//==================================================================================================================
function hideDSTCustomType()
{
   changeObjectVisibility("DSTExactDiv", "hidden");
   changeObjectVisibility("DSTMWDDiv", "hidden");
}
//==================================================================================================================

function NTPSwitch()
{
  var theForm = document.forms.dateTimeForm;

  if( theForm.useNTP.checked )
  {
    changeObjectVisibility("NTPDiv", "visible");
    changeObjectVisibility("ManualDiv", "hidden");
    document.getElementById("ntp1").novalidate = false;
    document.getElementById("ntp2").novalidate = false;
    document.getElementById("useNTPEnabled").innerHTML = 'Enabled';
  }
  else
  {
    changeObjectVisibility("NTPDiv", "hidden");
    changeObjectVisibility("ManualDiv", "visible");
    document.getElementById("ntp1").novalidate = true;
    document.getElementById("ntp2").novalidate = true;
    document.getElementById("useNTPEnabled").innerHTML = 'Disabled';
  }

}   


//==================================================================================================================
// checks to make sure valid numbers are entered in 
// the hour field if not the current letter is removed.
function checkValidHour(number)
{
   var pattern = /\D/;
   var string = number.value;

   if( number.value.match(pattern) )
   {
      string = string.slice(0,-1);
      number.value = string;
      number.focus();
      return(1);
   }
   if (string.length > 0 && string > 23) 
   {
      alert("Invalid value for hour.");
      number.value = "";
      number.focus();
      return(1);
   }
   if (string.length > 0 && string < 0) 
   {
      alert("Invalid value for hour.");
      number.value = "";
      number.focus();
      return(1);
   }
   return(0);
}

//==================================================================================================================

function checkValidDayNumber(number)
{
   var pattern = /\D/;
   var string = number.value;

   if( number.value.match(pattern) )
   {
      string = string.slice(0,-1);
      number.value = string;
      number.focus();
      return(1);
   }
   if (string.length > 0 && string > 365) 
   {
      alert("Invalid value for day number.");
      number.value = "";
      number.focus();
      return(1);
   }
   if (string.length > 0 && string < 1) 
   {
      alert("Invalid value for day number.");
      number.value = "";
      number.focus();
      return(1);
   }
   return(0);
}

//==================================================================================================================
// checks to make sure valid numbers are entered in 
// the minute field if not the current letter is removed.
function checkValidMinute(number)
{
   var pattern = /\D/;
   var string = number.value;

   if( number.value.match(pattern) )
   {
      string = string.slice(0,-1);
      number.value = string;
      number.focus();
      return(1);
   }
   if (string.length > 0 && string > 59) 
   {
      alert("Invalid value for minute.");
      number.value = "";
      number.focus();
      return(1);
   }
   if (string.length > 0 && string < 0) 
   {
      alert("Invalid value for minute.");
      number.value = "";
      number.focus();
      return(1);
   }
   return(0);
}

//==================================================================================================================
// check to make sure time fields have been filled
// in before submiting the form
function confirmValidTime()
{

   var f = document.forms[0];

   if ((f.hour.value == "") || (f.minute.value == ""))
   {
     alert("Please complete the time fields.");
     return;
   }

   var useNTP = 0;
   if (f.useNTP.checked)
      useNTP = 1;

   var bCustomTZDSTChanged = customTZ_DST_Changed(); 

   // See if there were any changes
   if(  (f.org_timeZone.value == f.timeZone.value ) &&
        (parseInt(f.org_hour.value,10) == parseInt(f.hour.value,10 )) &&
        (parseInt(f.org_minute.value,10) == parseInt(f.minute.value,10) ) &&
        (f.org_useNTP.value == useNTP) &&
        (f.org_NTP_1.value == f.NTP_1.value) &&
        (f.org_NTP_2.value == f.NTP_2.value) &&
        (f.calChanged.value == 0 ) &&
        (bCustomTZDSTChanged == false) 
     )
   {
         alert("No changes were made" );
         return;
   }
   
   if(bCustomTZDSTChanged)
      NEED_REBOOT = true;

   if(isDateSame())
   {
      alert("Cannot use same value for start and stop dates." );
      return;
   }

   // If NTP is enable verify the IP Addresses also.
   var doIt = true;
   if( document.forms[0].useNTP.checked )
   {
      //doIt = false;
      //if( checkHostOrIP( document.forms[0].NTP_1, 0 ) )
      //   if( checkHostOrIP( document.forms[0].NTP_2, 1 ) )
      //      doIt = true;
      ;
   }
   else
   {
      // Clear the ntp IPs incase they are bad
      document.forms[0].NTP_1.value = "";
      document.forms[0].NTP_2.value = "";
   }
   

   if( doIt == true )   // launch progress window
   {
      rebootLib();
      openProgressWindow("Modifying Date & Time", "0");
   }  
}

//==================================================================================================================

function getNumberOfDays(iMonth)
{
   var iRetVal=0;
   if(iMonth == 1 || iMonth == 3 || 
      iMonth == 5 || iMonth == 7 || 
      iMonth == 8 || iMonth == 10 || 
      iMonth == 12)
      iRetVal = 31;

   if(iMonth == 4 || iMonth == 6 || 
      iMonth == 9 || iMonth == 11) 
      iRetVal = 30;
      
   if(iMonth == 2 && isLeapYear() == false)
      iRetVal = 28;
   else if (iMonth == 2)
      iRetVal = 29;   
      
//   alert("getNumberOfDays() Called\nActual Parameter(s)= " + iMonth + "\nReturn Value= " + iRetVal );
   return iRetVal;       
}

//==================================================================================================================

function setDays(selMonth,selDays)
{
  var frm = document.forms.dateTimeForm;
  var iMonthSelected = frm.elements[selMonth].selectedIndex+1;
  var iNumDays = getNumberOfDays(iMonthSelected);
  var iLenList = selDays.length;
  
  for(idx=iLenList-1;idx>=0;idx--)
  {
     frm.elements[selDays][idx] = null;
  }
  
  for (idx=1;idx<=iNumDays;idx++)
  {
     frm.elements[selDays][idx-1] = new Option(idx,idx);  
  }
  
//  alert("setDays() Called\nActual Parameter(s)= " + selMonth + "," + selDays);  
}

//==================================================================================================================

function JDayToMonth(iDay)
{
   var iRetVal = 0;
   
   if(iDay <    1 || iDay > 366) iRetVal=0;

   if(iDay >=   1 && iDay <= 31) iRetVal=1;
   
   if(isLeapYear())
   {
      if(iDay >=  32 && iDay <=  60) iRetVal=2;   
      if(iDay >=  61 && iDay <=  91) iRetVal=3;   
      if(iDay >=  92 && iDay <= 121) iRetVal=4;   
      if(iDay >= 122 && iDay <= 152) iRetVal=5;   
      if(iDay >= 153 && iDay <= 183) iRetVal=6;   
      if(iDay >= 184 && iDay <= 214) iRetVal=7;   
      if(iDay >= 215 && iDay <= 244) iRetVal=8;   
      if(iDay >= 245 && iDay <= 274) iRetVal=9;   
      if(iDay >= 276 && iDay <= 305) iRetVal=10;   
      if(iDay >= 306 && iDay <= 336) iRetVal=11;   
      if(iDay >= 337 && iDay <= 366) iRetVal=12;
   }
   else
   {
      if(iDay >=  31 && iDay <=  59) iRetVal=2;   
      if(iDay >=  60 && iDay <=  90) iRetVal=3;   
      if(iDay >=  91 && iDay <= 120) iRetVal=4;   
      if(iDay >= 121 && iDay <= 151) iRetVal=5;   
      if(iDay >= 152 && iDay <= 181) iRetVal=6;   
      if(iDay >= 182 && iDay <= 212) iRetVal=7;   
      if(iDay >= 213 && iDay <= 243) iRetVal=8;   
      if(iDay >= 244 && iDay <= 273) iRetVal=9;   
      if(iDay >= 274 && iDay <= 304) iRetVal=10;   
      if(iDay >= 305 && iDay <= 334) iRetVal=11;   
      if(iDay >= 335 && iDay <= 365) iRetVal=12;
   }
//   alert("JDayToMonth() Called\nActual Parameter(s)= " + iDay + "\nReturn Value= " + iRetVal );   
   return iRetVal;   
}

//==================================================================================================================

function JDayToMonthDay(iDay)
{
   if(iDay < 1 || iDay > 366) return "";

   var sRetVal="";   
   var iMonth = JDayToMonth(iDay);
   var iNumDays = 0;
   for(idx=1;idx<=iMonth-1;idx++)
   {
      iNumDays = iNumDays + getNumberOfDays(idx);
   }
   
   var iCalDay = iDay-iNumDays;
   
   sRetVal = MONTHS[iMonth-1] + ":" + iCalDay;
   
//   alert("JDayToMonthDay() Called\nActual Parameter(s)= " + iDay + "\nReturn Value= " + sRetVal );   
   return sRetVal;
}

//==================================================================================================================
function JDayToDay(iDay)
{
   if(iDay < 1 || iDay > 366) return "";  // 366 takes leap years into account

   var sRetVal="";   
   var iMonth = JDayToMonth(iDay);
   var iNumDays = 0;
   for(idx=1;idx<iMonth;idx++)
   {
      iNumDays = iNumDays + getNumberOfDays(idx);
   }
   
   var iCalDay = iDay-iNumDays;
   
   sRetVal = iCalDay;
   
//   alert("JDayToDay() Called\nActual Parameter(s)= " + iDay + "\nReturn Value= " + sRetVal );   
   return sRetVal;
}

//==================================================================================================================
function rebootLib()
{
   if (NEED_REBOOT == false) return;
   
   var theForm = document.forms.dateTimeForm;

   ret = confirm("Changes have been saved, but are not activated until the next library reboot.\n\n" +
         		 "Select OK to reboot now.\nSelect CANCEL to defer the reboot.");
   if( !ret )
   {
      theForm.txtReboot.value = "false";
      NEED_REBOOT = false;
      return;
   }
      
   theForm.txtReboot.value = "true";   
}
//==================================================================================================================

function customTZ_DST_Changed()
{

   var f = document.forms[0];
   var retVal = false;
   var temp;
   NEED_REBOOT = false;

   temp="";
   if (f.chkUseCustomTZ.checked)
      temp = 1;
      
   if (f.org_useCustomTZ.value != temp) return true;

   if(!retVal && f.chkUseCustomTZ.checked)
   {
      if (f.org_CustomTZUTCOffestHH.value != f.txtTZCustomHH.value) return true;
      if (f.org_CustomTZUTCOffestMM.value != f.txtTZCustomMM.value) return true;

      temp = "+";
      if (f.rbUTCOffset[0].checked)
         temp = "-";
      if (f.org_CustomTZUTCOffestDir.value != temp) return true;
   
   }  
   
   temp="";
   if (f.chkUseCustomDST.checked)
      temp = 1;

   if (f.org_useCustomDST.value != temp)
   {
      return true;
   }
   else if (retVal == false)
   {
      temp = "DISABLED";
      if (f.rbCustomDST[0].checked) temp = "EXACT";
      else if (f.rbCustomDST[1].checked) temp = "APPROX";

      if (temp == "DISABLED") return retVal;
           
      if(f.org_CustomDSTSelMethod.value != temp)
      {
         return true;   
      }
      else
      {
         if (f.rbCustomDST[0].checked)  // Check for any EXACT selection changes
         {
            var iSelectedIndex = JDayToMonth(f.org_CustomDSTEStartDay.value)-1;         
            if (iSelectedIndex != f.DSTEStartMonth.selectedIndex) return true;
                  
            iSelectedIndex = JDayToDay(f.org_CustomDSTEStartDay.value)-1;        
            if (iSelectedIndex != f.DSTEStartDay.selectedIndex) return true;
                  
            if (f.org_CustomDSTEStartTimeHH.value != f.txtDSTECustomHHStart.value) return true;
            if (f.org_CustomDSTEStartTimeMM.value != f.txtDSTECustomMMStart.value) return true;
            
            iSelectedIndex = JDayToMonth(f.org_CustomDSTEStopDay.value)-1;
            if (iSelectedIndex != f.DSTEStopMonth.selectedIndex) return true;      

            iSelectedIndex = JDayToDay(f.org_CustomDSTEStopDay.value)-1;        
            if (iSelectedIndex != f.DSTEStopDay.selectedIndex) return true;

            if (f.org_CustomDSTEStopTimeHH.value != f.txtDSTECustomHHStop.value) return true;
            if (f.org_CustomDSTEStopTimeMM.value != f.txtDSTECustomMMStop.value) return true;
         }
         else if (f.rbCustomDST[1].checked) // Check for any APPROX selection changes
         {
            if (f.org_CustomDSTAStartMonth.value-1  != f.DSTAStartMonth.selectedIndex) return true;
            if (f.org_CustomDSTAStartWeek.value-1   != f.DSTAStartWeek.selectedIndex) return true;      
            if (f.org_CustomDSTAStartDay.value      != f.DSTAStartDay.selectedIndex) return true; 
            if (f.org_CustomDSTAStartTimeHH.value   != f.txtDSTACustomHHStart.value) return true;
            if (f.org_CustomDSTAStartTimeMM.value   != f.txtDSTACustomMMStart.value) return true;
      
            if (f.org_CustomDSTAStopMonth.value-1   != f.DSTAStopMonth.selectedIndex) return true;
            if (f.org_CustomDSTAStopWeek.value-1    != f.DSTAStopWeek.selectedIndex) return true;      
            if (f.org_CustomDSTAStopDay.value       != f.DSTAStopDay.selectedIndex) return true;      
            if (f.org_CustomDSTAStopTimeHH.value    != f.txtDSTACustomHHStop.value) return true;
            if (f.org_CustomDSTAStopTimeMM.value    != f.txtDSTACustomMMStop.value) return true;
         }
      }
   
   }

   return false;
}
//==================================================================================================================
function isDateSame()
{
   var f = document.forms[0];

   temp = "DISABLED";
   if (f.rbCustomDST[0].checked) temp = "EXACT";
   else if (f.rbCustomDST[1].checked) temp = "APPROX";

   if (temp == "DISABLED") return false;
           
   if (temp == "EXACT")  // EXACT
   {
      if(f.DSTEStartMonth.selectedIndex != f.DSTEStopMonth.selectedIndex) return false;
      if(f.DSTEStartDay.selectedIndex != f.DSTEStopDay.selectedIndex) return false;
   }
   else if (temp == "APPROX") // APPROX
   {

      if(f.DSTAStartMonth.selectedIndex != f.DSTAStopMonth.selectedIndex) return false; 
      if(f.DSTAStartWeek.selectedIndex  != f.DSTAStopWeek.selectedIndex) return false; 
      if(f.DSTAStartDay.selectedIndex   != f.DSTAStopDay.selectedIndex) return false; 
   }
   return true;
}
//==================================================================================================================
function isLeapYear()
{

   var d = new Date(); 
   var iYear = d.getFullYear();
//   alert("isLeapYear() Called with year: " + iYear);   

   if (iYear%4 == 0) 
   {
      if(iYear%100 == 0)
      {
        if(iYear%400 == 0)
           return true;
        else
           return false;                      
      }
      else
         return true;         
   }
   else
      return false; 
}