/****************************************************************************** 
*
* Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* ADIC, Inc.
*******************************************************************************/
/****************************************************************************** 
* Name:  setupFCHost.js
* Purpose: Javascript functions setting up the connected FC host
* $Id: setupFCHost.js 1.2 2006/12/10 15:44:06MST Bill Gray (bgray) dev  $
*******************************************************************************/

var g_checked  = false;
var g_index    = 0;
var g_fc_index = 0;

// sorts the luns
function compareNumbers(a,b)
{
  return a-b;
}

// object for handling LUN info
function lun( hide, mapped, port )
{
    this.hide   = hide;
    this.mapped = mapped;
    this.port   = port;
}

// checks if host has been selected and takes you to the modify page
function fchostModify()
{
    if (!g_checked) {
        alert( "Must select a host to modify." );
        return;
    }
    switchDiv( 'header_div', 'modify_div' );
}

// checks if host has been selected and takes you to the configure page
function fchostConfigure()
{
    if (!g_checked) {
        alert( "Must select a host to configure." );
        return;
    }
    if (g_devices == "")
    {
       alert("There are no devices to configure");
       return;
    }
    switchDiv( 'header_div', 'configure_div' );
}

// Get the color of the rows displayed
function getFieldClass(cnt)
{
    if ((cnt % 2) == 0)
        return "dataRowLight";
    else
        return "dataRowDark";
}

// set all the modify values of the selected host
function setModifyValues( h_name, h_type, h_connection, h_wwn, index, fc_index )
{
    g_checked = true;
    g_index = index;
    g_fc_index = fc_index;
    if (h_connection == "null" ) h_connection = "";


    var modifyform = document.forms[1];
    var configureform = document.forms[2];
    var devices_array = new Array();
    modifyform.hostname.value       = h_name;
    modifyform.hostType.value       = h_type;
    modifyform.hostWWN.value        = h_wwn;
    modifyform.hostIndex.value      = index;
    modifyform.fcIndex.value        = fc_index;
    configureform.hostIndex.value   = index;
    configureform.fcIndex.value     = fc_index;

    document.getElementById('modifyHostname').innerHTML   = h_name;
    document.getElementById('configHostname').innerHTML   = h_name;
    document.getElementById('currentHostname').innerHTML   = h_name;
    document.getElementById('currentHostType').innerHTML   = h_type;
    document.getElementById('currentHostWWN').innerHTML    = h_wwn;

    var options = modifyform.hostType.options;
    var found_one = false;
    for( i = 0; i < options.length; ++i ) {
        if (options[i].value.toUpperCase( ) == h_type.toUpperCase( ) ) {
            options[i].selected = true;
            found_one = true;
            break;
        }
    }
    if (!found_one){
        modifyform.hostType.value = h_type;
    }

    // no need to populate the configuration page because
    // no devices exist.
    if (g_devices == "")
    {
       return;
    }

    // get the list of valid devices
    var reg = / /;
    if (reg.test(g_devices))
    {
      devices_array = g_devices.split(" ");
    }
    else
    {
      devices_array[0] = g_devices;
    }

    var valid_array = new Array();
    var count = 0;
    var mapped;
    var i,p,j=0;
    var gotDevice = 0;

    for (j=0; j< devices_array.length; j++)
    {
       // clear all the values before they are set again
       document.getElementById("mapped_lun_" + devices_array[j]).value = 0;
    }	 

    for( i = 1; i < max_luns; i++ ) 
    {
       mapped = g_luns[index][fc_index][i].mapped;
       port = g_luns[index][fc_index][i].port;

       // check to see if the lun mapped or if a valid device
       if (mapped == 65535)
       {
          for (p=0; p<devices_array.length; p++)
	  {
	     // the current lun is a valid device so continue forward
	     if ( i == devices_array[p])
	     {
	         gotDevice = 1;
                 break;   
             }
          }
	  // if the lun is not a valid device goback to the for loop
	  if (gotDevice == 0)
	  {
             continue;
          }
	  gotDevice = 0;
       }

       // add the mapped port if one is assigned
       if (g_luns[index][fc_index][i].hide) {
          document.getElementById("mapped_lun_" + mapped).value  = port;
       }
       
       // go ahead and add the string information for the devices
       if (g_lun_descs[index][i].indexOf("Serial Number") > -1) {
          document.getElementById("lun_tr_" + i).className  = getFieldClass( count++ );
          document.getElementById("lun_str_" + i).innerHTML = g_lun_descs[index][i];
       }
    }
}

//Apply the modify information
function fchostModifyApply()
{
    openProgressWindow("Modifying Host",1);
}

//Apply the configured mapping information
function fchostConfigureApply()
{
    var configure_form = document.forms[2];
    var i,j,k = 0;
    var maxLuns = 31;
    var valid_array = new Array();
    var devices_array = new Array();

    // get the list of valid devices
    var reg = / /;
    if (reg.test(g_devices))
    {
      devices_array = g_devices.split(" ");
    }
    else
    {
      devices_array[0] = g_devices;
    }

    var arr = new Array();
    var aluns_array = g_assigned_luns[g_index][g_fc_index].split( "::" );
    var value;
    var mapped;

    // don't set any devices that don't have a lun selected
    for( i = 0; i < maxLuns; ++i ) { arr[i] = 65535; } // don't set
    arr[0] = 65534;
    for( j = 0; j < devices_array.length; ++j ) {
       k = devices_array[j];
       arr[eval( "configure_form.mapped_lun_" + k + ".value" )] = k;
    }
    configure_form.mappedLuns.value = arr.join( "::" );
    openProgressWindow("Configuring Host",2);
}

// hide a div tag
function hideDiv(this_div)
{
    this_div.className = "hiddenDiv";
    this_div.style.visibility = "hidden";
}

// show a div tag
function showDiv(this_div)
{
    this_div.className = "visiblePlain";
    this_div.style.visibility = "visible";
}

// check for duplicate LUNS that are already mapped
function checkForDuplicates(this_select) {
   var gotOne = false;
   var f = document.forms[2];
   newVal = this_select.value;
   var aluns_array = g_assigned_luns[g_index][g_fc_index].split( "::" );
   var valid_array = new Array();
   var devices_array = new Array();

   // get the list of valid devices
   var reg = / /;
   if (reg.test(g_devices))
   {
     var devices_array = g_devices.split(" ");
   }
   else
   {
     var devices_array = g_devices;
   }
   var j;

    for (i=0; i<= aluns_array.length; i++)
    {
       if (aluns_array[i] > 0)
       {
         valid_array[i] = aluns_array[i];
       }
    }
    var aluns = valid_array.sort(compareNumbers);

   if (newVal == 0)
      return;

   //check for duplicate
   for (i = 0; i < devices_array.length; ++i) {
      j = devices_array[i];
      oldVal = eval("f.mapped_lun_" + j + ".value");
      if (oldVal == newVal) {
         if (gotOne == false) {
            gotOne = true;
         }
         else {
            alert("Another device is already mapped to this LUN.");
            this_select.value = 0;
            return;
         }
      }
   }
}

