/******************************************************************************
 * Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * ADIC, Inc.
 *******************************************************************************/
/******************************************************************************
 * Name:  setupNotification.js
 * Purpose: Javascript functions for setting up email addresses for notification
 * $Id: setupNotification.js 1.18 2007/08/15 12:52:30MDT Bill Gray (bgray) dev  $
 *******************************************************************************/

/* check to see if the entered email address is value */
function isValidEmailAddress(addr)
{
   var filter  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
   if (filter.test(addr))
      return true;
   else
      return false;
}

// This function gets all of the info for the defined notifications.
// With this information the appropriate info is populated on modify
function getInfo(task)
{
   var headerform = document.forms['SetupNotificationForm'];
   var createform = document.forms['CreateNotificationForm'];
   var modform = document.forms['ModifyNotificationForm'];
   var modSupportForm = document.forms['Modify1_NotificationForm'];
   var gotNotification = 0;
   var length;
   var value;

   if (task == "create")
   {
      if( parseInt(headerform.activeCount.value) >= headerform.maxEmailAddresses.value )
      {
         alert("The maximum number of e-mail addresses ("+ headerform.maxEmailAddresses.value + ") have been defined.");
         return;
      }
      createform.emailAddress.value="";
      createform.comment.value="";
      switchDiv('header','createNotification');
   }
   else if (task == "modify")
   {
      // check to see if 0 or 1 notifications exist
      // Goofy fix for radio buttons that only have one element in the array.
      // input type radio will return undefined if only one element in
      // the array.
      // below: no items in the list
      if (!headerform.addresses)
      {
         alert("No notifications exist to modify.");
         return;
      }
      // one notification in the list
      else if (!headerform.addresses.length)
      {
         length = 1;
      }
      else // more then 1 notification in the list
      {
         length = headerform.addresses.length;
      }

      for (i=0; i<length; i++)
      {
         if (length <= 1)
         {
            checked = headerform.addresses.checked;
            if (checked)
            {
                gotNotification = 1;
                value = headerform.addresses.value;
                break;
            }
         }
         else
         {
            checked = headerform.addresses[i].checked;
            if (checked)
            {
                gotNotification = 1;
                value = headerform.addresses[i].value;
                break;
            }
         }
      }

      if (gotNotification == 0)
      {
         alert("Please select a notification to modify.");
         return;
      }
      // split out the selected values
      var notInfo   = value.split(":");
      var email     = notInfo[0];
      var levelDesc = notInfo[1];
      var levelNum  = notInfo[2];
      var notRef    = notInfo[3];
      var enabled   = notInfo[4] > 0;
      var guid		  = notInfo[5];
      var buildIn   = notInfo[6] > 0;
      var name      = notInfo[7];
		var comment   = notInfo[8];

      //!?! I'm not sure what's going on HERE when the page reloads with the submit - this will ALL be overwritten!!!!
      // populate the current values on the modifyNotification div
      document.getElementById('currentEmailAddress').innerHTML = email;
      document.getElementById('currentStatus').innerHTML = enabled?"Enabled":"Disabled";
      document.getElementById('currentSupStatus').innerHTML = enabled?"Enabled":"Disabled";
      document.getElementById('currentAlertLevel').innerHTML = levelDesc;

      modform.modEmailAddress.value = email;
      modform.notificationRef.value = notRef;
      modform.currentGuid.value = guid;
      modform.modStatus.checked = enabled;
      modform.modComment.value = comment;
		

      // to check for modifications from the current value
      modform.originalEmailAddress.value = email;
      modSupportForm.originalEnableSetting.value = enabled;
      modSupportForm.emailAddress.value=email;
      modSupportForm.notificationRef.value = notRef;
      modSupportForm.currentGuid.value = guid;

		if( modSupportForm.modStatus )
	      modSupportForm.modStatus.checked = enabled?true:false;
		if( modSupportForm.modStatus1 )
	      modSupportForm.modStatus1.checked = enabled?true:false;

		modSupportForm.accountName.value = name;
      modSupportForm.comment1.value = comment;

      // modifySupportNotification div
      //       document.getElementById('currentAlertLevel1').innerHTML = "<b>" + levelDesc + "</b>";
      //       document.getElementById('currentAlertLevel2').innerHTML = "<b>" + levelDesc + "</b>";
      if( name && name.length > 0 )
         document.getElementById('supportEmailAddress1').innerHTML = "<b>" + name + "(" + email + ")</b>";
      else
         document.getElementById('supportEmailAddress1').innerHTML = "<b>" + email + "</b>";

      document.getElementById("currentAlertLevel1").innerHTML = "<b>" + levelDesc + "</b>";
      for (i=0; i<modSupportForm.modEmailAddress1.options.length; i++)
      {
         var fields = modSupportForm.modEmailAddress1.options[i].value.split(":");
         if (fields[1] == email)
         {
            modSupportForm.modEmailAddress1.options[i].selected = true;
            break;
         }
      }

      // highlight the current configured alertLevel
      if( buildIn )
      {
         for (i=0; i<modSupportForm.modAlertLevel.options.length; i++)
         {
            if (modSupportForm.modAlertLevel.options[i].value == levelNum)
            {
               modSupportForm.modAlertLevel.options[i].selected = true;
               break;
            }
         }
      }
      else
      {
         for (i=0; i<modform.modAlertLevel.options.length; i++)
         {
            if (modform.modAlertLevel.options[i].value == levelNum)
            {
               modform.modAlertLevel.options[i].selected = true;
               break;
            }
         }
      }

      // set the 'Enabled' checkbox appropriately
/*    if (enabled)
         modSupportForm.modStatus.checked = false;
      else
         modSupportForm.modStatus.checked = true;
*/
      if ( buildIn )
         switchDiv('header','modifySupportNotification');
      else
         switchDiv('header','modifyNotification');
   }
}


// Checks to make sure the form has been filled out correctly
function checkNotificationForm(formNumber)
{
   var f = document.forms[formNumber];
   var headerform = document.forms[0];

   // create
   if (formNumber == 1)
   {
      // has the email address been filled in
      if (f.emailAddress.value == "")
      {
         alert("Please enter an e-mail address.");
         return;
      }
      if (!isValidEmailAddress(f.emailAddress.value))
      {
         alert(f.emailAddress.value + " is not a valid e-mail address.");
         f.emailAddress.focus();
         return;
      }
      if (headerform.emailAddrList.value != "")
      {
         emailListValue = headerform.emailAddrList.value;
         emailListArray = emailListValue.split(":");
         // Check to see if email address already exists
         for (i=0; i<emailListArray.length; i++)
         {
            if (emailListArray[i].toUpperCase() == f.emailAddress.value.toUpperCase())
            {
               alert("The e-mail address you have entered [" + f.emailAddress.value + "] already exists.");
               f.emailAddress.focus();
               return;
            }
         }
      }
      // Post the INFO back to the form so PHP can save the data.
      openProgressWindow("Creating E-mail Notification For "+f.emailAddress.value, formNumber);
   }
   // modify
   else if (formNumber == 2)
   {
      // has the e-mail address been filled in
      if (f.modEmailAddress.value == "")
      {
         alert("Please enter an e-mail address.");
         return;
      }
      if (!isValidEmailAddress(f.modEmailAddress.value))
      {
         alert(f.modEmailAddress.value + " is not a valid e-mail address.");
         f.modEmailAddress.focus();
         return;
      }
      var inputList;

      inputlist = document.getElementsByName('addresses');

      for (i=0; i<inputlist.length; i++)
      {
            var addressAttr;
            addressAttr = inputlist[i].value.split(":");
            if( (addressAttr[0].toUpperCase() == f.modEmailAddress.value.toUpperCase()) &&
                (f.currentGuid.value != addressAttr[5]) )
            {
               alert("The e-mail address you have entered [" + f.modEmailAddress.value + "] already exists.");
               f.modEmailAddress.focus();
               return;
            }

      }

      f.emailAddress.value=f.modEmailAddress.value;
      f.alertLevel.value=f.modAlertLevel.value;
      // launch status window and pass in form number form submission
      openProgressWindow("Modifying E-mail Notification For "+f.emailAddress.value, formNumber);
   }
   // modify support@adic.com properties
   else if (formNumber == 3)
   {
/*
   NOTE: The normal user code does not check that changes have been made. I was unable to easily find the old value for the severity setting
         if (f.modStatus.checked != f.originalEnableSetting.value ) )
      {
         alert("No modifications have been made. " + f.modStatus.checked + " | " + f.originalEnableSetting.value + " * " + f.modAlertLevel.value );
         f.modStatus.focus();
         return;
      }
      if (!f.modStatus.checked && f.originalEnableSetting.value == 'false')
      {
         alert("No modifications have been made.");
         f.modStatus.focus();
         return;
      }
*/
		
      if (f.modStatus)
		{
			if (f.modStatus.checked)
				f.enabled.value = 'true';
			else
				f.enabled.value = 'false';
		}
		
      if (f.modStatus1)
		{
			if (f.modStatus1.checked)
				f.enabled.value = 'true';
			else
				f.enabled.value = 'false';
		}

      // CR 46191 Said to let them modify alertLevel also
         // f.alertLevel.value = 1; // high for now
         f.alertLevel.value=f.modAlertLevel.value;

      var fields = f.modEmailAddress1.options[f.modEmailAddress1.selectedIndex].value.split(":");
      // launch status window and pass in form number form submission
      openProgressWindow("Modifying E-mail Notification For " + fields[1], formNumber);
   }
}

// This function confirms the deletion of a notification
function confirmDelete()
{
   var headerform = document.forms[0];
   var formNumber = "0";
   var gotNotification = 0;
   var length;
   var value;

   // check to see if 0 or 1 notifications exist
   // Goofy fix for radio buttons that only have one element in the array.
   // input type radio will return undefined if only one element in
   // the array.
   // below: no items in the list
   if (!headerform.addresses)
   {
      alert("No notifications exist to modify.");
      return;
   }
   // one notification in the list
   else if (!headerform.addresses.length)
   {
      length = 1;
   }
   else // more then 1 notification in the list
   {
      length = headerform.addresses.length;
   }

   for (i=0; i<length; i++)
   {
      if (length <= 1)
      {
         checked = headerform.addresses.checked;
         if (checked)
         {
            gotNotification = 1;
            value = headerform.addresses.value;
            break;
         }
      }
      else
      {
         checked = headerform.addresses[i].checked;
         if (checked)
         {
            gotNotification = 1;
            value = headerform.addresses[i].value;
            break;
         }
      }
   }

   // no notification was selected
   if (gotNotification == 0)
   {
      alert("No notification has been selected for deletion.");
      return;
   }

   // need to split all attributes
   var notInfo   = value.split(":");
   var email     = notInfo[0];
   var levelDesc = notInfo[1];
   var levelNum  = notInfo[2];
   var notRef    = notInfo[3];
   var enabled   = notInfo[4] > 0;
   var guid		  = notInfo[5];
   var buildIn   = notInfo[6] > 0;
   var name      = notInfo[7];

   if (buildIn)
   {
      alert("This notification cannot be deleted.\nIf you wish to disable it, please select 'Modify'.");
      return;
   }

   if (confirm("Are you sure you want to delete notification [ " + email + " ]?"))
   {
      // pass back the notification reference
      headerform.notificationRef.value = notRef;
      headerform.originalEmailAddress.value = email;
      headerform.originalGuid.value = guid;

      // launch status window and pass in form number form submission
      openProgressWindow("Deleting E-mail Notification For "+email, formNumber);
   }
   else
   {
      return;
   }
}

function testEmailConfiguration()
{
   // see if the email config is done
   if( document.getElementById('isEmailConfigured').value == 'false' )
   {
      alert('To send a Capture Snapshot e-mail, the E-mail Account must be set up.  The E-mail Account may be set up using Setup->Notifications->E-mail Configuration.');
		// Disable the email field.
		document.forms['ToolsCaptureStateForm'].emailAddress.disabled = true;
      // select the browser download
      var opList = document.forms['ToolsCaptureStateForm'].getElementsByTagName('input');
      for(i=0; i<opList.length; i++)
      {
        if( opList[i].value == 'browser' )
        {
           opList[i].checked = true;
           break;
        }
      }
      return false;
   }
   else
   {
		// Enable the email field.
		document.forms['ToolsCaptureStateForm'].emailAddress.disabled = false;
      return true;
   }
}

function keyPressed(e, formNumber)
{
   var key = e.keyCode;
   if( key == 13 )
   {
      checkNotificationForm(formNumber);
   }

}
