/******************************************************************************
*
* Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* ADIC, Inc.
*******************************************************************************/
/******************************************************************************
* Name:  setupUser.js
* Purpose: Javascript functions for creating,modifying, and deleting users
* $Id: setupUser.js 1.20 2007/11/13 15:50:11MST Jim Boyd (jboyd) dev  $
*******************************************************************************/

// This function will call the given action to create or modify a user.
// role= "Admin or User"
// task= "Create or Modify"

var nameOfUser = "";
var nameOfRole = "";
var listOfUserLibs = "";

// This function checks to make sure a user was selected
// and then asks for confimation from the operator whether
// or not he want to delete the user.
function confirmDelete()
{
   var headerform = document.forms[0];
   var formNumber = 0;
   var username = "";
   var value;
   var userlength;
   var gotuser=0;

   // check to see if 0 or 1 users exist
   // Goofy fix for radio buttons that only have one element in the array.
   // input type radio will return undefined if only one element in
   // the array.
   // below: no users in the list
   if (!headerform.username_)
   {
     alert("No users exist to delete.");
     return false;
   }
   // one user in the list
   else if (!headerform.username_.length)
   {
      userlength = 1;
   }
   else // more then 1 user in the list
   {
      userlength = headerform.username_.length;
   }

   // Loop through the users and get the select user
   for (i=0; i < userlength; i++)
   {
      if (userlength <=1)
      {
         if (headerform.username_.checked)
    {
            value = headerform.username_.value;
       gotuser = 1;
       break;
         }
      }
      else
      {
         if (headerform.username_[i].checked)
    {
            value = headerform.username_[i].value;
       gotuser = 1;
       break;
         }
      }
   }

   // no user was selected
   if (gotuser == 0)
   {
      alert("No user has been selected for deletion.");
      return;
   }

   // the username comes in the form (admin:name)
   // need to split the two to get the username
   value = value.split(":");
   username = value[2];

   if (username == "admin")
   {
      alert("The default user 'admin' cannot be deleted.");
      return;
   }
   if ( username == top.frames[0].LOGGED_IN_USER_NAME )
   {
      alert("You cannot delete youself.");
      return;
   }

   if (confirm("Are you sure you want to delete user [ " + username + " ]?"))
   {
      openProgressWindow("Deleting User", formNumber);
   }
   else
   {
      return;
   }
}

// This function makes sure a library has been selected for current user.
// It also bundles up hte list of libraries to send back in the submit.
function validateLib(formNumber)
{
   var f = document.forms[formNumber];
   var i;
   var inputlist;
   var list = "";
   var action = "Creating User";
   var listCurrentLibs = "";
   var listNewLibs = "";

   if (formNumber == 2)
   {
      action = "Modifying User";
   }

   inputlist = f.getElementsByTagName('input');

   // go through all the input fields in the frame and
   // see if any checkboxes are selected
   for (i=0; i<inputlist.length; i++)
   {
      if (inputlist[i].type == "checkbox")
      {

         if (eval("f." + inputlist[i].name + ".checked"))
         {
            if (list == "")
            {
               list = inputlist[i].value;
            }
            else
            {
               list += ":" + inputlist[i].value;
            }
         }
      }
   }
   if (list != "")
   {
      // verify libraries have changed
      listNewLibs = list.split(":"); 
      listCurrentLibs = listOfUserLibs.split(":");
      if((formNumber == 2) && (listNewLibs.length == listCurrentLibs.length)) // Modifying and the length is the same, check the librarys
      {
         for(i=0; i<listNewLibs.length; i++)
         {
            if(listNewLibs[i] != listCurrentLibs[i]) 
            {
               break; 
            }
         }
         if(i == listNewLibs.length)
         {
           // No libraries changed, check the password
           if ((f.password.value == "") && (f.confirmpassword.value == ""))
           {
              alert("No changes have been made");
              return;
           }
         }
         
      } // end if formNumber 2 (Modify) && no change in list lengths
      
      // send list back during submition
      f.libraries.value = list;
      if( f.adminPassword && f.adminPassword.value == "" )
      {
         alert("Please enter your Admin password on previous page.");
         return;
      }
      openProgressWindow(action, formNumber);
   }
   else
   {
      alert("Please select one or more libraries.");
      return;
   }
}

// This function is called when creating an admin user
// it checks what the role is, makes sure everything has
// been filled in and the password is verified.
function validateUserForm(formNumber)
{
   var f = document.forms[formNumber];
   var win;
   var action;

   if (formNumber == 1)
   {
      action = "Creating User";
   }
   else
   {
      action = "Modifying User";
   }

   // This is if a "User" role is being added and the apply
   // button is clicked before moving to the next page and selecting
   // virtual libraries to map to the "User".  Just Return because
   // this button is greyed out.
   if (f.role[1].checked)
   {
      return;
   }
   // Make sure all form elements are filled in
   // pass in the form number because the name doesn't work
   // when using struts.
   if (formNumber == 1)
   {
      if (checkForm(formNumber) && (formNumber == 1))
      {
         return;
      }
   }


   // check to make sure password and confirmation are the same
   if (validatePassword(formNumber))
   {
      return;
   }
   if( action != "Creating User" && f.adminPassword.value == "" )
   {
      alert("Please enter your Admin password.");
      return;
   }
   openProgressWindow(action, formNumber);
}


// This function checks to see that the user being created does not already exist.
function CheckUserDup(formNumber)
{
   var f = document.forms[formNumber];

   for( myCnt = 0; myCnt < cnt; myCnt++ )
   {
//		alert( "myCnt =" + myCnt + " | UserNames[myCnt] = " + UserNames[myCnt] + " f.username_.value = " + f.username_.value );
      if( f.username_.value == UserNames[myCnt] )
      {
         alert( "The user name \"" + f.username_.value + "\" already exists!\nplease try again with another name." );
         return false;
      }
   }
   return true;
}


// This function returns if the next button is greyed out.
// It also updates each page with the username that is being
// modified or created.
function goNext(formNumber)
{
   var f = document.forms[formNumber];
   var username;
   var inputlist;
   var liblist;

   // return if admin button is selected (next button will be greyed out
   if (f.role[0].checked)
   {
      return 1;
   }
   else
   {
      if (formNumber == 1) //create
      {
         // check to make sure all form elements are filled in.
         if (checkForm(formNumber))
         {
            return false;
         }
         // check to make sure password and confirmation are the same
         if (validatePassword(formNumber))
         {
            return false;
         }
    // edit the username on the next page.
         document.getElementById('accountNameCreate').innerHTML = "<b>" + f.username_.value + "</b>";
         switchDiv('createuser','createvlib');
      }
      else //modify
      {
         if (f.password.value != "")
    {
            // check to make sure password and confirmation are the same
            if (validatePassword(formNumber))
            {
               return false;
            }
    }

         // username is formatted as guid:role:name
         var userinfo = f.username_.value.split(":");

    // edit the username on the next page.
         document.getElementById('accountNameMod').innerHTML = "<b>" + userinfo[2] + "</b>";
         switchDiv('modifyuser','modvlib');
      }
   }
}


// This function checks to see if the password and confirmation password
// match, if not return with an error alert.
function validatePassword(formNumber)
{
   var f = document.forms[formNumber];

   // If this a modify the password may be blank
   if (f.password.value == "" && f.confirmpassword.value == "" && formNumber == 2)
   {
      if(nameOfRole == "Admin")
      {
         alert("No changes have been made");
         return 1;
      }
      else
      {
         return 0;
      }
   }

   if (f.password.value.length < 6)
   {
      alert("Password is too short. Minimum password length is 6 characters.");
      f.password.value="";
      f.confirmpassword.value="";
      f.password.focus();
      return 1;
   }

   // Validate passwords
   if (f.password.value != f.confirmpassword.value)
   {
      alert("Invalid password confirmation. Please try again.");
      f.password.value="";
      f.confirmpassword.value="";
      f.password.focus();
      return 1;
   }
}

// This function gets all of the info for the defined users.
// With this information the username is populated on modify
// and the correct libraries are selected.
// this is ran twice, the button arguement is saying whether or
// not the radio button was checked or the modify button.
function getUserInfo(task, button)
{
  var headerform = document.forms[0];
  var createform = document.forms[1];
  var modform = document.forms[2];
  var gotUser = 0;
  var uservalue;
  var role;
  var userinfo;
  var name;
  var inputlist;
  var liblist;
  var value;
  var currentImage;
  
  // Initialize globals  
  nameOfRole = "";
  listOfUserLibs = "";

  if (task == "create")
  {
     createform.username_.value = "";
     createform.password.value = "";
     createform.confirmpassword.value = "";
     switchDiv('header','createuser');
  }
  else if (task == "modify")
  {
     // check to see if 0 or 1 users exist
     // Goofy fix for radio buttons that only have one element in the array.
     // input type radio will return undefined if only one element in
     // the array.
     // below: no users in the list
     if (!headerform.username_)
     {
       alert("No users exist to modify.");
       return false;
     }
     // one user in the list
     else if (!headerform.username_.length)
     {
        userlength = 1;
     }
     else // more then 1 user in the list
     {
        userlength = headerform.username_.length;
     }

     for (i=0; i<userlength; i++)
     {
        if (userlength <= 1)
            {
               checked = headerform.username_.checked;
           if (checked)
               {
              gotUser = 1;
              uservalue = headerform.username_.value;
                  break;
            }
        }
            else
            {
               checked = headerform.username_[i].checked;
           if (checked)
               {
              gotUser = 1;
              uservalue = headerform.username_[i].value;
                  break;
            }
         }
      }

      if (gotUser == 0)
      {
         alert("Please select a user to modify.");
         return false;
      }

      if (button == "radio" || button == "modify")
      {
      // split out the role and the username
      userinfo = uservalue.split(":");
      guid = userinfo[0];
      role = userinfo[1];
      name = userinfo[2];

      nameOfUser = name;
      nameOfRole = role;
      
      // get list of input fields
      inputlist = modform.getElementsByTagName('input');

      // this is the image that changes between finish and next
      currentImage = document.images['next1'].src;

      // select the libraries the user currently has permission
      // to manage.
      if ((role == "User") && eval("modform." + name))
      {
         modform.role[1].checked = true;
         value = eval("modform." + name + ".value");
         liblist = value.split(":");

         // first uncheck all resourse assignments in
         // case this isn't the first view after 
         // page reload
         for (i=0; i<inputlist.length; i++)
         {
            if (inputlist[i].type == "checkbox")
            {
               inputlist[i].checked = false;
            }
         }

         for (i=0; i<inputlist.length; i++)
         {
            if (inputlist[i].type == "checkbox")
            {
               for (j=0; j<liblist.length; j++)
               {
                  if (inputlist[i].value == liblist[j])
                  {
                     inputlist[i].checked = true;
                     // build the user lib list;
                     if (listOfUserLibs == "")
                     {
                        listOfUserLibs = inputlist[i].value;
                     }
                     else
                     {
                        listOfUserLibs += ":" + inputlist[i].value;
                     }
                  }
               }
            }
         }
         if (currentImage.search("next") == -1)
         {
            changeFinishNextButton('3','2','next');
         }
      }
      else //Admin
      {
         modform.role[0].checked = true;
         if (currentImage.search("finish") == -1)
         {
            changeFinishNextButton('3','2','apply');
         }
      }

      if (uservalue != modform.username_.value)
      {
         modform.password.value = "";
             modform.confirmpassword.value = "";
      }

      document.getElementById('selectedUser').innerHTML = "<b>" + name + "</b>";
      modform.username_.value = uservalue;
    }

    if (button == "modify")
    {
       // split out the role and the username
       // We need the username to display at the top of the modify page.
       userinfo = uservalue.split(":");
       guid = userinfo[0];
       role = userinfo[1];
       name = userinfo[2];
       document.getElementById('selectedUser').innerHTML = "<b>" + name + "</b>";
       modform.username_.value = uservalue;

       modform.password.value = "";
       modform.confirmpassword.value = "";
       switchDiv('header','modifyuser');
    }
  }
}

// This function checks to see if the user is an admin.  The admin
// user cannot be modified to become a user.
function checkUser()
{
   if (nameOfUser == "admin")
   {
      document.forms[2].role[0].checked = true;
      alert("You cannot change the privilege of the user 'admin'.");
      return false;
   }
   else
   {
      if( nameOfUser == top.frames[0].LOGGED_IN_USER_NAME )
      {
         document.forms[2].role[0].checked = true;
         alert("You cannot change your own privilege.");
      }
      else
      {
         // change the finish button to the next button
         changeFinishNextButton('3','2','next');
      }
   }
}

// This function changes the next or finish button
// depeding upon which user is selected for modification
// or which user is selected during creation.
function changeFinishNextButton(state, page, imageName)
{
   var img_name;
   // page is 1 for create page and 2 is for modify
   // 3 toggles the buttons between next and finish

   // first find out what button is visible
   if (page == 1)
   {
      img_name = "next";
   }
   else
   {
      img_name = "next1";
   }
   current_image = document.images[img_name].src;

   // the image is changing depeding on if the radio button Admin or User
   // was checked
   if (state == 3)
   {
      document.images[img_name].src = "images/buttons/" + imageName + ".gif";
      return;
   }

   if (state == 0)
   {
      if (current_image.search("next") != -1)
      {
         // next button is up
         document.images[img_name].src =  "images/buttons/next.gif";
      }
      else
      {
         //finish button is up
         document.images[img_name].src =  "images/buttons/apply.gif";
      }
   }
   else if (state == 1)
   {
      if (current_image.search("next") != -1)
      {
         // next button is down
         document.images[img_name].src =  "images/buttons/next_down.gif";
      }
      else
      {
         //finish button is down
         document.images[img_name].src =  "images/buttons/apply_down.gif";
      }
   }
}

// this function takes care of moving between pages depending on which
// button is currently visible.
function handleFinishNext(imageName, page)
{
   // first find out what button is visible
   var current_image = document.images[imageName].src;

    if( !CheckUserDup(page) )
        return;

   if (current_image.search("next") != -1)
   {
         goNext(page);
      return;
   }
   else
   {
      validateUserForm(page);
      return;
   }
}

function checkValidPasswordString(name)
{
   var pattern = /[^a-z0-9_@\.\-\*]/;
   var string = name.value;

   if( name.value.match(pattern) )
   {
      alert("Only lowercase letters, numbers, underscores, @, *, ., and - are allowed in the password string.");
      // remove the invalid character and put focus on the input field
      string = string.replace(/[^a-z0-9_@\.\-\*]/g, "");
      alert("New Password: " + string);
      name.value = string;
      focusField = name;
      setTimeout(setTheFocus, 10);
      return(1);
   }
   return(0);
}
