/****************************************************************************** 
 * Copyright 1991-2009 by Quantum, Inc.  All rights reserved.
 * No part of this work may be reproduced or transmitted in any
 * form or by any means, electronic or mechanical, including
 * photocopying and recording, or by any information storage
 * or retrieval system, except as may be expressly permitted by
 * the 17 U.S.C. section 101, et. seq., or in writing by
 * ADIC, Inc.
 *******************************************************************************/

   var changesMade = false;

   function onCancel()
   {
      if(changesMade == false || confirm("Are you sure you wish to cancel the current Setup Wizard?\n" +
         "You will lose your changes and return to the homepage."))
      {
       loadHomePage();
      }
   }

   function applyLicense()
   {
      var f = document.forms['licenseKeyForm'];
      if (f.licenseKey.value == "")
      {
         if (confirm("No license key was entered, do you want to skip entering a license?"))
         {
            showDateTime();
            switchDiv( 'licensekey', 'datetime'); 
         }
         return;
      }
      else if (f.licenseKey.value.length <= 0 )
      {
         alert("Please enter a valid license key.");
         return;
      }
      f.submit();
   }

   function applyLicenseComplete(success, newLicensed, newUnlicensed)
   {
      if (success)
      {
         if (newLicensed > licensedSlots)
         {
            var diff = newLicensed - licensedSlots;
            licensedSlots = newLicensed;
            availableSlots += diff;
         }
         window.frames['updatedLicensedList'].document.location.reload();
         window.frames['currentLicensedList'].document.location.reload();
         switchDiv( 'licensekey', 'licensekeysummary'); 
      }
      else
      {
         alert("Could not apply license.  Verify that the license was entered correctly.");
      }
   }

   function updateDateTime()
   {
      var f = document.forms['dateTimeForm']; 
      if ((f.hour.value == "") || (f.minute.value == ""))
      {
         alert("Please complete the time fields.");
         return;
      }

      var newTime = f.timeZone.value + ":" + f.txtDate.value + ":" + f.hour.value + 
          ":" + f.minute.value;

      // If NTP is enable verify the IP Addresses also.
      var doIt = true;
      if( f.useNTP.checked )
      {
         doIt = false;
         if( verifyIP( f.NTP_1, 0 ) )
            if( verifyIP( f.NTP_2, 1 ) )
               doIt = true;
      }
      else
      {
         // Clear the ntp IPs incase they are bad
         f.NTP_1.value = "";
         f.NTP_2.value = "";
      }
      
      if( doIt == true )
      {
         if (newTime != f.currentTime.value)
         {
            document.forms['dateTimeForm'].submit();
         }
         else 
         {
            updateDateTimeComplete(true);
         }
      }
   }
  
   function updateDateTimeComplete(success)
   {
      var f = document.forms['dateTimeForm']; 
      if (!success) 
      {
         alert("Could not update date and time, continuing with Setup.");
         // Reset the current time
         var origTime = f.currentTime.value;
         var fields = origTime.split(":");
         f.timeZone.value = fields[0];
         f.txtDate.value = fields[1];
         f.hour.value = fields[2];
         f.minute.value = fields[3];
         f.ampm.value = fields[4];
      }
      else
      {
         // Update the new current time
         var newTime = f.timeZone.value + ":" + f.txtDate.value + ":" + f.hour.value + 
          ":" + f.minute.value;
         f.currentTime.value = newTime;
      }
      hideDateTime();
      switchDiv( 'datetime', 'cleaningQuest'); 
   }

   function showDateTime()
   {
      var theForm = document.forms.dateTimeForm;
      
      if( theForm.useNTP.checked )
      {
       changeObjectVisibility("NTPDiv", "visible");
       changeObjectVisibility("ManualDiv", "hidden");
      }
      else
      {
       changeObjectVisibility("NTPDiv", "hidden");
       changeObjectVisibility("ManualDiv", "visible");
      }

   }
   
   function hideDateTime()
   {
       changeObjectVisibility("ManualDiv", "hidden");
       changeObjectVisibility("NTPDiv", "hidden");
   }
   
   function updateConfirmationPage()
   {
      var f = document.forms['updateLibraryForm'];
      var numPartitionsRequested = f.partitionCount.value;
      var numMailboxRequested = 0;
      var configuredMailboxSize = f.configuredMailboxSize.value;
      var numCleaningRequested = 0;
      var configuredCleaningSize = f.configuredCleaningSize.value;

         // Default this to the configured size. If we are changeing the mailbox size this will get reset below.
         numMailboxRequested = configuredMailboxSize;

      for (var i = 0; i < f.numMailboxSlots.length; i++)
      {
         if (f.numMailboxSlots[i].checked == true)
         {
            numMailboxRequested = f.numMailboxSlots[i].value;
            break;
         }
      }
      for (var i = 0; i < f.numCleaningSlots.length; i++)
      {
         if (f.numCleaningSlots[i].checked == true)
         {
            numCleaningRequested = f.numCleaningSlots[i].value;
            break;
         }
      }

      changesMade = false;
      if (numPartitionsRequested > 0)
      {
         changesMade = true;
         document.getElementById('requestedPartitions').innerHTML = 
               "<tr><td width='60%'><b>Number of partitions to auto create: " + 
               numPartitionsRequested + "</b> </td> \n";
      } 
      else
      {
         document.getElementById('requestedPartitions').innerHTML = 
               "<tr><td width='60%'><b>No new partitions will be created.</b></td></tr> \n";
      }
      if (numMailboxRequested != configuredMailboxSize)
      {
         changesMade = true;
         document.getElementById('requestedMailbox').innerHTML = 
               "<tr><td width='60%'><b>I/E Station Slots: " + numMailboxRequested + "</b></td>\n";
      } 
      else
      {
         document.getElementById('requestedMailbox').innerHTML = 
               "<tr><td width='60%'><b>No changes made to the I/E Station configuration.</b></td></tr> \n";
      }
      if (numCleaningRequested != configuredCleaningSize)
      {
         changesMade = true;
         document.getElementById('requestedCleaning').innerHTML = 
               "<tr><td width='60%'><b>Cleaning Slots: " + numCleaningRequested + "</b></td>\n";
      } 
      else
      {
         document.getElementById('requestedCleaning').innerHTML = 
               "<tr><td width='60%'><b>No changes made to the Cleaning Slot configuration.</b></td></tr> \n";
      }
         
         
       if (checkLibraryNames('updateLibraryForm'))
       {
           switchDiv('automatic_confirm','confirm'); 
       }
   }

   function setupAutoPartition(setup, autoMinCount)
   {
      if (setup)
      {
         updateAutoPartitionSelect(autoMinCount);
         switchDiv('partition','automatic'); 
      } 
      else
      {
         document.forms['updateLibraryForm'].partitionCount[0].value = AvalibleInterfaceType;
         document.forms['updateLibraryForm'].partitionCount[0].selected = true;
         updateConfirmationPage();
         switchDiv('partition','confirm'); 
      }
   }

   function updateLibrary()
   {
      if (!changesMade)
      { 
         alert("No changes have been requested.");
         return;
      }
      openProgressWindow("Updating Library", "updateLibraryForm");
   }

   function setupMailboxSize(setupMailbox, nextPage)
   {
      if (setupMailbox)
      {
         switchDiv('mailboxQuest','mailbox'); 
      } 
      else
      {
         // The user selected no on the configure question, so we 
         // reset the value to the original value when setup started
         var f = document.forms['updateLibraryForm'];
         selectButton(f.numMailboxSlots, f.configuredMailboxSize.value);
         switchDiv('mailboxQuest', nextPage); 
      }
   }

   function updateMailboxSize(size)
   {
/*   
      if (maxMailboxSize < size)
      {
         alert("There are currently only " + maxMailboxSize + " I/E Station slots available.");
         var mailboxButtons = document.forms['updateLibraryForm'].numMailboxSlots;
         selectButton(document.forms['updateLibraryForm'].numMailboxSlots, mailboxSize);
         return false;
      }
      if (currentPartitionCount > 1 && size == 0)
      {
         alert("You cannot select zero I/E Station slots if more than one partition currently exists.");
         var mailboxButtons = document.forms['updateLibraryForm'].numMailboxSlots;
         selectButton(document.forms['updateLibraryForm'].numMailboxSlots, mailboxSize);
         return false;
      }
*/      
      availableSlots = availableSlots - size + mailboxSize;
      mailboxSize = size;
      document.getElementById('availableSlots').innerHTML = availableSlots;
      document.getElementById('cleaningCount').innerHTML = cleaningSize;
      document.getElementById('mailboxCount').innerHTML = mailboxSize;
   }

   function setupCleaningSlotSize(setupCleaningSlots)
   {
      if (setupCleaningSlots)
      {
         switchDiv('cleaningQuest','cleaning'); 
      } 
      else
      {
         // The user selected no on the configure question, so we 
         // reset the value to the original value when setup started
         var f = document.forms['updateLibraryForm'];
         selectButton(f.numCleaningSlots, f.configuredCleaningSize.value);
         switchDiv('cleaningQuest','mailboxQuest'); 
      }
   }

   function updateCleaningSlotSize(size)
   {
      var availableForCleaning = availableSlots + cleaningSize;
      if (availableForCleaning < size)
      {
         alert("There are currently only " + availableForCleaning + " slots available for cleaning.");
         selectButton(document.forms['updateLibraryForm'].numCleaningSlots, cleaningSize);
         return;
      }
      availableSlots = availableSlots - size + cleaningSize;
      cleaningSize = size;
      document.getElementById('availableSlots').innerHTML = availableSlots;
      document.getElementById('cleaningCount').innerHTML = cleaningSize;
      document.getElementById('mailboxCount').innerHTML = mailboxSize;
   }

   function operationInProgressComplete(action, success)
   {
      parent.frames.contentFrame.location = '/setupWizardLibConfig.htm';
   }

   /**
    * Select the button with the given value from the given list
    */ 
   function selectButton(buttons, value)
   {
      for (var i = 0; i < buttons.length; i++)
      {
         if (buttons[i].value == value)
         {
            buttons[i].checked = true;
            break;
         }
      }
   }
   
   function updateAutoPartitionSelect(autoMinCount)
   {
      var index;
      while (document.updateLibraryForm.partitionCount.options.length > 0)
      {
         index = document.updateLibraryForm.partitionCount.options.length - 1;
         document.updateLibraryForm.partitionCount.options[index] = null;
      }

      // The number of partitions allowed is the lessor of available slots, drives 
      var max = Math.min(availableSlots, availableDrives);

      // If there are NO partitions - Don't have 0 in the list.
      // The user MUST create a partition
      if( document.updateLibraryForm.lib_count.value == 0 )
         index = 1;
      else
         index = 0;
//      index = autoMinCount; //!?!PCR 22679 this was 1;
//      alert("Min count was " + autoMinCount);

      var numDrives = 0;
      for (index; index <= max; index++)
      {
         // Skip the numbers between 1 and the number of Avalible Interface Types
         // We desided not to strip these out. I left the code inbecaseu I bet we will in the future
         //if( index != 1 && index < AvalibleInterfaceType )
         //   continue;
         if( index != 0 && index < autoMinCount )
            continue;
         numDrives++;
         opt = new Option();
         opt.text = "" + index;
         opt.value = "" + index;

         insertIndex = document.updateLibraryForm.partitionCount.options.length;
         document.updateLibraryForm.partitionCount.options[insertIndex] = opt;
      }
      // set the default
//      document.forms['updateLibraryForm'].partitionCount[AvalibleInterfaceType].selected = true;
         for( i = 0; i < numDrives; i++ )
         {
            if( document.forms['updateLibraryForm'].partitionCount[i].value == AvalibleInterfaceType )
               document.forms['updateLibraryForm'].partitionCount[i].selected = true;
         }
   }

    function PartitionPreConfirm()
    {
       // First see if we need to being up the Partition Name Confirm Page
       if( document.forms['updateLibraryForm'].partitionCount.value != 0 )
       {
          // Have the page reload it self so the correct number of partitions come up.
          frames.PartitionNameList.reloadMe();
          // Now show the page
          switchDiv('automatic','automatic_confirm');
       }
       else
       {
            updateConfirmationPage();
            switchDiv('automatic','confirm');
       }
    }

/*
 * Check the library name in the given form, this will check
 * against currently known library names
 */
   function checkLibraryNames(formName)
   {

     var fp = self.frames["PartitionNameList"].document.forms['partList'];         //.getElementsByTagName('input');
      var f = document.forms[formName];

      libraryListValue = f.libNames.value;
      libraryListArray = libraryListValue.split(":");

      // Loop though all the names that were entered.
      for( pNum = 1; ; pNum++)
      {
         ll = 'Part' + pNum;
         if( ! fp[ll] )
         {
            break;
         }
         
         if (fp[ll].value == "")
         {
            alert("Please enter a library name");
            return false;
         }
         else
         {
            // Loop though all the existing partitions
            for (i=0; i<libraryListArray.length; i++)
            {
               if (libraryListArray[i] == fp[ll].value)
               {
                  alert("The library name you have entered [" + fp[ll].value + "] already exists.");
                  return false;
               }
            }
            // Loop through the names the user just entered and make sure there are no dups
            
            for(i=1; fp['Part'+(i)]; i++)
            {
               if( i == pNum )
                  continue;   // Don't compare aginst itself
                  
//               alert( fp['Part' + i].value  + " == " + fp[ll].value  );
               if( fp['Part' + i].value  == fp[ll].value  )
               {
                  alert("The library name you have entered [" + fp[ll].value + "] is already in your new list.");
                  return false;
               }
            }
         }
         // Load this name into the var
         f.partitionNames.value += ((pNum==1? '' : ':') + fp[ll].value);
         
      }
      return true;
   }
