/****************************************************************************** 
*
* Copyright 1991-2003 by ADIC, Inc.  All rights reserved.
* No part of this work may be reproduced or transmitted in any
* form or by any means, electronic or mechanical, including
* photocopying and recording, or by any information storage
* or retrieval system, except as may be expressly permitted by
* the 17 U.S.C. section 101, et. seq., or in writing by
* ADIC, Inc.
*******************************************************************************/
/****************************************************************************** 
* Name:  toolsCaptureState.js
* Purpose: Javascript functions capturing the system state logs
* $Id: toolsCaptureState.js 1.1 2004/02/02 18:21:34MST Michael Jones (mjones) dev  $
*******************************************************************************/

// file: toolsCaptureState.js

// This function captures the current state of the system
function captureState()
{
   document.forms[0].action = '/toolsCaptureStateActions.do?method=captureState';
   openProgressWindow("Capturing System State", 0);
}

// Sets the href to download whatever file is selected
function setHREF(file)
{
   var f=document.forms[0];
   document.links[1].href="http://" + f.hostname.value +"/ui/downloads/" + file.value;
}


// This function checks to make sure a captured state was selected
// and then asks for confimation from the operator whether
// or not he want to delete it
function confirmDelete()
{
   var headerform = document.forms[0];
   var value;
   var length;
   var formNumber = "0";
   var gotState = 0;

   // check to see if 0 or 1 captured states exist
   // Goofy fix for radio buttons that only have one element in the array.
   // input type radio will return undefined if only one element in 
   // the array.

   // No captured States in the list
   if (!headerform.stateValues)
   {
      alert("No captured states exist to delete.");
      return;
   }
   // one lock in the list
   else if (!headerform.stateValues.length)
   {
      length = 1;
   }
   else // more then 1 lock in the list
   {
      length = headerform.stateValues.length;
   }

   // Loop through the locks and get the selected one 
   for (i=0; i < length; i++)
   {
      if (length <=1)
      {
         if (headerform.stateValues.checked)
         {
            value = headerform.stateValues.value;
            gotState = 1;
            break;
         }
      }
      else 
      {
         if (headerform.stateValues[i].checked)
         {
            value = headerform.stateValues[i].value;
            gotState = 1;
            break;
         }
      }
   }    

   // no captured state was selected
   if (gotState == 0)
   {
      alert("No captured state has been selected for deletion.");
      return;
   }


   if (confirm("Are you sure you want to delete captured state:\n[  " + value + " ]?")) 
   {
      headerform.captureState.value = value;
      openProgressWindow("Deleting Captured State", formNumber);
   }
   else
   {
      return;
   }
}

// This function checks to see if a file was selected
function checkDownloadFile()
{
   var headerform = document.forms[0];
   var length;
   var gotState = 0;

   // check to see if 0 or 1 captured states exist
   // Goofy fix for radio buttons that only have one element in the array.
   // input type radio will return undefined if only one element in 
   // the array.

   // No captured States in the list
   if (!headerform.stateValues)
   {
      alert("No captured states exist to download.");
      return;
   }
   // one lock in the list
   else if (!headerform.stateValues.length)
   {
      length = 1;
   }
   else // more then 1 lock in the list
   {
      length = headerform.stateValues.length;
   }

   // Loop through the locks and get the selected one 
   for (i=0; i < length; i++)
   {
      if (length <=1)
      {
         if (headerform.stateValues.checked)
         {
            gotState = 1;
            break;
         }
      }
      else 
      {
         if (headerform.stateValues[i].checked)
         {
            gotState = 1;
            break;
         }
      }
   }    

   // no captured state was selected
   if (gotState == 0)
   {
      alert("No captured state has been selected for download.");
      return false;
   }
}
