<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class DateTimeInfoXML extends InfoXML
{
   var $currentDate;
   var $currentTime;
   var $currentTimeZone;
   var $EX_currentTimeInfo = null;
   var $user = null;

   function DateTimeInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->initializeVariables();
      $this->getData();
   }

   function initializeVariables()
   {
      $this->currentDate = $this->INTERFACE_ERROR_STRING;
      $this->currentTime = $this->INTERFACE_ERROR_STRING;
      $this->currentTimeZone = $this->INTERFACE_ERROR_STRING;
   }

   function getData()
   {
      $start = gettimeofday();
      $this->EX_currentTimeInfo = @get_date_and_time( $this->user );
      @$this->checkError( $this->EX_currentTimeInfo, "get_date_and_time", $start );
      $this->getCurrentDate();
   }

   function getCurrentDate()
   {
      $out = shell_exec('/usr/bin/date "+%A, %B %e, %Y"');
      $this->currentDate = trim($out);
      $this->currentTime = date('H\:i\:s');
      $this->currentTimeZone = isset( $this->EX_currentTimeInfo ) ? $this->EX_currentTimeInfo->timezone : $this->INTERFACE_ERROR_STRING;
   }

   function toXML()
   {
      $out = $this->tab1 . "<DateTimeInfo>\n";
      $out .= $this->tab2 . "<CurrentDate>" . $this->currentDate . "</CurrentDate>\n";
      $out .= $this->tab2 . "<CurrentTime>" . $this->currentTime . "</CurrentTime>\n";
      $this->createTag( $out, $this->tab2, "TimeZone", $this->currentTimeZone );
      $out .= $this->tab2 . "<NTP>\n";
      if( isset( $this->EX_currentTimeInfo ) && $this->EX_currentTimeInfo->ntp )
      {
         $out .= $this->tab3 . "<State>Enabled</State>\n";
         $out .= $this->tab3 . "<IPAddress>" . $this->EX_currentTimeInfo->ntp_1 . "</IPAddress>\n";
         if( $this->EX_currentTimeInfo->ntp_2 != "" )
            $out .= $this->tab3 . "<IPAddress>" . $this->EX_currentTimeInfo->ntp_2 . "</IPAddress>\n";
      }
      else if( ! isset( $this->EX_currentTimeInfo ) )
      {
         $this->createTag( $out, $this->tab3, "State", $this->INTERFACE_ERROR_STRING );
      }
      else
      {
         $out .= $this->tab3 . "<State>Disabled</State>\n";
      }
      $out .= $this->tab2 . "</NTP>\n";
      $out .= $this->tab1 . "</DateTimeInfo>\n";
      return $out;
   }
}
?>
