<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */

$INTERFACE_ERROR_STRING = "UNKNOWN";

class InfoXML
{
   var $tab = "";
   var $tab1 = "";
   var $tab2 = "";
   var $tab3 = "";
   var $tab4 = "";
   var $tab5 = "";

   var $INTERFACE_ERROR_STRING = "UNKNOWN";
   var $INTERFACE_NOT_SUPPORTED = "NOT AVAILABLE";
   var $INTERFACE_ERROR_INT = -666;
   var $INTERFACE_NOT_SUPPORTED_INT = -555;

   function InfoXML()
   {
      $this->initializeTabs();
   }

   function initializeTabs()
   {
      $this->tab = "   ";
      $this->tab1 = $this->tab . $this->tab;
      $this->tab2 = $this->tab . $this->tab1;
      $this->tab3 = $this->tab . $this->tab2;
      $this->tab4 = $this->tab . $this->tab3;
      $this->tab5 = $this->tab . $this->tab4;
      $this->tab6 = $this->tab . $this->tab5;
   }

   function checkError( $obj, $extension, $start = null )
   {
      global $DEBUG;
      $stop = gettimeofday();
      $formatted = "";
      if( ! isset($obj) )
      {
         if( $extension != "login" )
           echo "$this->tab<Error>InterfaceFailure</Error>\n";
         error_log("XML: Call to $extension failed.");
      }
      else
      {
         if( $DEBUG )
         {
            if( isset( $start ) )
               $elapsed = $this->timeit( $start, $stop );
            print_r( "<DEBUGMODE>\n ------------------------------- BEGIN OUTPUT $extension ------------------------------- \n");
            print_r( $obj );
            print_r( " ------------------------------- END OUTPUT $extension ELAPSED TIME: $elapsed ------------------------------- \n</DEBUGMODE>\n");
         }
      }
   }

   function timeit( $start, $stop )
   {
      return sprintf("[%3.6f]", ( $stop[sec] - $start[sec] ) + ( ( $stop[usec] - $start[usec] ) / 1000000 ) );
   }

   function showExecutionTime( $start = 0 )
   {
      $stop = gettimeofday();
      $elapsed = sprintf("[%3.6f]", ( $stop[sec] - $start[sec] ) + ( ( $stop[usec] - $start[usec] ) / 1000000 ) );
      print_r("\n\n<DEBUGMODE>\n ............................. EXECUTION TIME: $elapsed ............................. \n</DEBUGMODE>\n");
   }

   function createTag( &$buffer, $spaces, $tagName, $value )
   {
      $buffer .= $spaces . "<" . $tagName;
      if( is_string( $value ) )
      {
         if( $value == $this->INTERFACE_ERROR_STRING )
         {
            $buffer .= " state=\"UNKNOWN\"></" . $tagName . ">\n";
         }
         else if( $value == $this->INTERFACE_NOT_SUPPORTED  )
         {
            $buffer .= " state=\"NOT_AVAILABLE\"></" . $tagName . ">\n";
         }
         else
         {
            $buffer .= ">" . $value . "</" . $tagName . ">\n";
         }
      }
      else if( is_int( $value ) )
      {
         if( $value == $this->INTERFACE_ERROR_INT )
         {
            $buffer .= " state=\"UNKNOWN\">0</" . $tagName . ">\n";
         }
         else if( $value == $this->INTERFACE_NOT_SUPPORTED_INT )
         {
            $buffer .= " state=\"NOT_AVAILABLE\">0</" . $tagName . ">\n";
         }
         else
         {
            $buffer .= ">" . $value . "</" . $tagName . ">\n";
         }
      }
      else
      {
         $buffer .= ">" . $value . "</" . $tagName . ">\n";
      }
   }
}

class SortCriteria
{
   var $sortColumn;
   var $ascending;
   var $filterPattern;

   function SortCriteria($sortColumn = 0, $ascending = true, $filterPattern = "")
   {
      $this->sortColumn = $sortColumn;
      $this->ascending = $ascending;
      $this->filterPattern = $filterPattern;
   }
}
?>
