<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class LicenseInfoXML extends InfoXML
{
   var $list = array();
   var $user = null;
   var $licenseFeature = array( "AR" => "Advanced Reporting", "EKM" => "Library Managed Encryption", "COD" => "Capacity On Demand" );
   var $EX_licenseInfo = null;

   function LicenseInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->getData();
   }

   function getData()
   {
      $start = gettimeofday();
      $this->EX_licenseInfo = @get_licensable_features( $this->user );
      @$this->checkError( $this->EX_licenseInfo, "get_licensed_features", $start );
      if( isset( $this->EX_licenseInfo ) )
      {
         foreach( $this->EX_licenseInfo as $item )
         {
            $lic = new License( $this->licenseFeature["$item->Descriptor"], $item->Value );
            $this->list[] = $lic;
         }
      }
      else
      {
         $lic = new License( $this->INTERFACE_ERROR_STRING, $this->INTERFACE_ERROR_STRING );
         $this->list[] = $lic;
      }
   }

   function toXML()
   {
      $count = count($this->list);
      if( $count != 0 )
      {
         $out = $this->tab1 . "<LicenseInfo>\n";
         for( $i = 0; $i < $count; $i++ )
            $out .= $this->list[$i]->toXML();
         $out .= $this->tab1 . "</LicenseInfo>\n";
         return $out;
      }
   }
}

class License extends InfoXML
{
   var $l_name;
   var $quantity = 0;

   function License( $l_name="", $quantity="" )
   {
      parent::InfoXML();
      $this->l_name = $l_name;
      if( $quantity != "N/A" )
         $this->quantity = $quantity;
   }

   function toXML()
   {
      $out = $this->tab2 . "<Feature>\n";
      $this->createTag( $out, $this->tab3, "Name", $this->l_name );
      $this->createTag( $out, $this->tab3, "Quantity", $this->quantity );
      $out .= $this->tab2 . "</Feature>\n";
      return $out;
   }
}
?>
