<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class ModuleInfoXML extends InfoXML
{
   var $list = array();
   var $user = null;
   var $EX_chassis = null;

   function ModuleInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->getData();
   }

   function getData()
   {
      $start = gettimeofday();
      $this->EX_chassis = @get_chassis( $this->user );
      @$this->checkError( $this->EX_chassis, "get_chassis", $start );

      if( isset( $this->EX_chassis ) )
      {
         foreach( $this->EX_chassis as $item )
         {
            $mod = new Module( $item->location, $item->model, $item->serial );
            $this->list[] = $mod;
         }
      }
      else ## We had a problem getting the module data
      {
         $mod = new Module( $this->INTERFACE_ERROR_STRING, $this->INTERFACE_ERROR_STRING, $this->INTERFACE_ERROR_STRING );
         $this->list[] = $mod;
      }
   }

   function toXML()
   {
      $out = $this->tab1 . "<ModuleInfo>\n";
      $count = count($this->list);
      for( $i = 0; $i < $count; $i++ )
         $out .= $this->list[$i]->toXML();
      $out .= $this->tab1 . "</ModuleInfo>\n";
      return $out;
   }
}

class Module extends InfoXML
{
   var $location = 0;
   var $m_type = "Control Module";
   var $serialNumber = "Not Available";

   function Module( $location=0, $m_type="", $serialNumber="" )
   {
      parent::InfoXML();
      $this->location = $location;
      $this->m_type = $m_type;
      $this->serialNumber = $serialNumber;
   }

   function toXML()
   {
      $out = $this->tab2 . "<Module>\n";
      $this->createTag( $out, $this->tab3, "Location", $this->location );
      $this->createTag( $out, $this->tab3, "Type", $this->m_type );
      $this->createTag( $out, $this->tab3, "SerialNumber", $this->serialNumber );
      $out .= $this->tab2 . "</Module>\n";
      return $out;
   }
}
?>
