<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class ProductInfoXML extends InfoXML
{
   var $user;
   var $model;
   var $vendor;
   var $serialNumber;
   var $installDate;
   var $firmwareVersion;
   var $libraryName;
   var $roboticsState;
   var $roboticsModel;
   var $systemUpTime;
   var $moduleCount;
   var $ioBladeCount;
   var $storageSlotCount;
   var $driveCount;
   var $ieSlotCount;
   var $mediaCount;
   var $partitionCount;
   var $cleaningSlotCount;
   var $cleaningMediaCount;

   var $moduleinfoXML = null; 
   var $networkInfoXML = null;
   var $licenseInfoXML = null;
   var $dateTimeInfoXML = null;

   var $EX_hostname = null;
   var $EX_productInfo = null;
   var $EX_librarySummary = null;
   var $EX_bladeInfo = null;
   var $EX_libraryState = null;

   function ProductInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->initializeVariables();
      $this->getData();
   }

   function initializeVariables()
   {
      $this->model = "Scalar i500";
      $this->vendor = "Quantum";
      $this->serialNumber = $this->INTERFACE_ERROR_STRING;
      $this->installDate = $this->INTERFACE_NOT_SUPPORTED;
      $this->firmwareVersion = $this->INTERFACE_ERROR_STRING;
      $this->libraryName = $this->INTERFACE_ERROR_STRING;
      $this->roboticsState = $this->INTERFACE_ERROR_STRING;
      $this->roboticsModel = $this->INTERFACE_ERROR_STRING;
      $this->systemUpTime = $this->INTERFACE_ERROR_STRING;
      $this->moduleCount = $this->INTERFACE_ERROR_INT;
      $this->ioBladeCount = $this->INTERFACE_ERROR_INT;
      $this->storageSlotCount = $this->INTERFACE_ERROR_INT;
      $this->driveCount = $this->INTERFACE_ERROR_INT;
      $this->ieSlotCount = $this->INTERFACE_ERROR_INT;
      $this->mediaCount = $this->INTERFACE_ERROR_INT;
      $this->partitionCount = $this->INTERFACE_ERROR_INT;
      $this->cleaningSlotCount = $this->INTERFACE_ERROR_INT;
      $this->cleaningMediaCount = $this->INTERFACE_NOT_SUPPORTED_INT;
   }

   function getData()
   {
      $start = gettimeofday();
      $this->EX_hostname = @get_network_hostname( $this->user );
      @$this->checkError( $this->EX_hostname, "get_network_hostname", $start );
      $start = gettimeofday();
      $this->EX_productInfo = @get_product_info( $this->user );
      @$this->checkError( $this->EX_productInfo, "get_product_info", $start );
      $start = gettimeofday();
      $this->EX_librarySummary = @get_library_summary_info( $this->user );
      @$this->checkError( $this->EX_librarySummary, "get_library_summary_info", $start );
      $start = gettimeofday();
      $this->EX_bladeInfo = @get_blades( $this->user );
      @$this->checkError( $this->EX_bladeInfo, "get_blades", $start );
      $start = gettimeofday();
      $this->EX_libraryState = @get_library_state( $this->user );
      @$this->checkError( $this->EX_libraryState, "get_library_state", $start );

      $this->serialNumber = isset( $this->EX_productInfo ) ? $this->EX_productInfo->serialnumber : $this->INTERFACE_ERROR_STRING;
      $this->firmwareVersion = isset( $this->EX_productInfo ) ? $this->EX_productInfo->productversion : $this->INTERFACE_ERROR_STRING;
      $this->libraryName = isset( $this->EX_hostname ) ? $this->EX_hostname : $this->INTERFACE_ERROR_STRING;
      $this->systemUpTime = $this->getSystemUptime();
      if( isset( $this->EX_libraryState ) )
      {
         if( $this->EX_libraryState == 1 )
            $this->roboticsState = "Enabled";
         else
            $this->roboticsState = "Disabled";
      }
      $this->roboticsModel = $this->getRobotModel();
      $this->storageSlotCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->slot_count : $this->INTERFACE_ERROR_STRING;
      $this->driveCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->drive_count : $this->INTERFACE_ERROR_STRING;
      $this->mediaCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->media_count : $this->INTERFACE_ERROR_STRING;
      $this->ieSlotCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->mailbox_count : $this->INTERFACE_ERROR_STRING;
      $this->partitionCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->partition_count : $this->INTERFACE_ERROR_STRING;
      $this->ioBladeCount = isset( $this->EX_bladeInfo ) ? count( $this->EX_bladeInfo ) : $this->INTERFACE_ERROR_STRING;
      $this->moduleinfoXML = new ModuleInfoXML( $this->user );
      $this->cleaningSlotCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->cleaning_count : $this->INTERFACE_ERROR_STRING;
      $this->mediaCount = isset( $this->EX_librarySummary ) ? $this->EX_librarySummary->media_count : $this->INTERFACE_ERROR_STRING;

      $this->networkInfoXML = new NetworkInfoXML( $this->user );
      $this->licenseInfoXML = new LicenseInfoXML( $this->user );
      $this->dateTimeInfoXML = new DateTimeInfoXML( $this->user );
      if( isset($this->moduleinfoXML->EX_chassis) )
      {
         $this->moduleCount = count( $this->moduleinfoXML->EX_chassis );
      }
   }

   function toXML()
   {
      $out = $this->tab . "<ProductInfo>\n";
      $this->createTag( $out, $this->tab1, "Model", $this->model );
      $this->createTag( $out, $this->tab1, "Vendor", $this->vendor );
      $this->createTag( $out, $this->tab1, "SerialNumber", $this->serialNumber );
      $this->createTag( $out, $this->tab1, "InstallDate", $this->installDate );
      $this->createTag( $out, $this->tab1, "FirmwareVersion", $this->firmwareVersion );
      $this->createTag( $out, $this->tab1, "LibraryName", $this->libraryName );
      $this->createTag( $out, $this->tab1, "RoboticsState", $this->roboticsState );
      $this->createTag( $out, $this->tab1, "RoboticsModel", $this->roboticsModel );
      $this->createTag( $out, $this->tab1, "SystemUpTime", $this->systemUpTime );
      $this->createTag( $out, $this->tab1, "ModuleCount", $this->moduleCount );
      $this->createTag( $out, $this->tab1, "IOBladeCount", $this->ioBladeCount );
      $this->createTag( $out, $this->tab1, "StorageSlotCount", $this->storageSlotCount );
      $this->createTag( $out, $this->tab1, "DriveCount", $this->driveCount );
      $this->createTag( $out, $this->tab1, "IESlotCount", $this->ieSlotCount );
      $this->createTag( $out, $this->tab1, "MediaCount", $this->mediaCount );
      $this->createTag( $out, $this->tab1, "PartitionCount", $this->partitionCount );
      $this->createTag( $out, $this->tab1, "CleaningSlotCount", $this->cleaningSlotCount );
      $this->createTag( $out, $this->tab1, "CleaningMediaCount", $this->cleaningMediaCount );
      $out .= $this->moduleinfoXML->toXML();
      $out .= $this->networkInfoXML->toXML();
      $out .= $this->licenseInfoXML->toXML();
      $out .= $this->dateTimeInfoXML->toXML();
      $out .= $this->tab . "</ProductInfo>\n";
      return $out;
   }

   function getRobotModel()
   {
      $versions = null;
      $start = gettimeofday();
      $versions = @get_firmware_versions( $this->user );
      @$this->checkError( $versions, "get_firmware_versions", $start );
      if( isset( $versions ) )
      {
         foreach( $versions as $item )
         {
            if( $item->component == "Imager Firmware" )
               return "Model2";
         }
      }
      else
      {
         return "Unknown";
      }
      return "Model1";
   }

   function getSystemUptime()
   {
      $days = "0";
      $hour = "0";
      $minute = "0";

      $out = shell_exec('/usr/bin/uptime');
      $list = explode(',', $out);
      if( count($list) > 5 )
      {
         $tmp = explode(" ", $list[0]);
         $days = $tmp[3];

         if( preg_match( '/min/', $list[1] ) )                                                                                                                      
         {                                                                                                                                                          
            $tmp1 = explode( 'min', $list[1] );                                                                                                                     
            $hour = 0;                                                                                                                                              
            $minute = trim($tmp1[0]);                                                                                                                               
         }                                                                                                                                                          
         else                                                                                                                                                       
         {                                                                                                                                                          
            $time = explode(":", $list[1] );                                                                                                                        
            $hour = $time[0];                                                                                                                                       
            $minute = $time[1];                                                                                                                                     
         }
      }
      else
      {
         if( preg_match( '/min/', $list[0] ) )                                                                                                                      
         {                                                                                                                                                          
            $tmp1 = explode( 'up', $list[0] );                                                                                                                      
            $hour = 0;                                                                                                                                              
            $tmp1 = explode( 'min', $tmp1[1] );                                                                                                                     
            $minute = trim($tmp1[0]);                                                                                                                               
         }                                                                                                                                                          
         else                                                                                                                                                       
         {                                                                                                                                                          
            $tmp = explode(' up ', $list[0]);                                                                                                                       
            $time = explode(":", $tmp[1] );                                                                                                                         
            $hour = $time[0];                                                                                                                                       
            $minute = $time[1];                                                                                                                                     
         }
      }
      return "$days days, ${hour}h:${minute}m:00s";
   }
}
?>
