<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class RASInfoXML extends InfoXML
{
   var $componentStatus = array( "Unknown", "Good", "Degraded", "Failed" );
   var $libraryStatus;
   var $driveStatus;
   var $mediaStatus;

   var $user = null;
   var $EX_rasStatus = null;

   function RASInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->initializeVariables();
      $this->getData();
   }

   function initializeVariables()
   {
      $this->libraryStatus = $this->INTERFACE_ERROR_STRING;
      $this->driveStatus = $this->INTERFACE_ERROR_STRING;
      $this->mediaStatus = $this->INTERFACE_ERROR_STRING;
   }

   function getData()
   {
      $start = gettimeofday();
      $this->EX_rasStatus = @get_subsystem_status( $this->user );
      @$this->checkError( $this->EX_rasStatus, "get_subsystem_status", $start );
      if( isset( $this->EX_rasStatus ) )
      {
         $this->libraryStatus =  $this->componentStatus[ $this->getLibraryStatus() % 4 ];
         $this->driveStatus = $this->componentStatus[ $this->EX_rasStatus->drives % 4 ];
         $this->mediaStatus = $this->componentStatus[ $this->EX_rasStatus->media % 4 ];
      }
   }

   function toXML()
   {
      $out = $this->tab . "<RASInfo>\n";
      $out .= $this->tab1 . "<RASStatus>\n";
      $out .= $this->tab2 . "<Subsystem>Library</Subsystem>\n";
      $this->createTag( $out, $this->tab2, "Status", $this->libraryStatus );
      $out .= $this->tab1 . "</RASStatus>\n";
      $out .= $this->tab1 . "<RASStatus>\n";
      $out .= $this->tab2 . "<Subsystem>Drives</Subsystem>\n";
      $this->createTag( $out, $this->tab2, "Status", $this->driveStatus );
      $out .= $this->tab1 . "</RASStatus>\n";
      $out .= $this->tab1 . "<RASStatus>\n";
      $out .= $this->tab2 . "<Subsystem>Media</Subsystem>\n";
      $this->createTag( $out, $this->tab2, "Status", $this->mediaStatus );
      $out .= $this->tab1 . "</RASStatus>\n";
      $out .= $this->tab . "</RASInfo>\n";
      return $out;
   }

   function getLibraryStatus()
   {
      $status = 0;
      if( isset( $this->EX_rasStatus ) )
      {
         if( $this->EX_rasStatus->power > $status )
            $status = $this->EX_rasStatus->power;
         if( $this->EX_rasStatus->connectivity > $status )
            $status = $this->EX_rasStatus->connectivity;
         if( $this->EX_rasStatus->robotics > $status )
            $status = $this->EX_rasStatus->robotics;
         if( $this->EX_rasStatus->control > $status )
            $status = $this->EX_rasStatus->control;
         if( $this->EX_rasStatus->cooling > $status )
            $status = $this->EX_rasStatus->cooling;
         if( $this->EX_rasStatus->library > $status )
            $status = $this->EX_rasStatus->library;
      }
      return $status;
   }
}
?>
