<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
class TicketInfoXML extends InfoXML
{
   var $list = array(); // Ticket list
   var $user = null;
   var $EX_ticketInfo = null;

   function TicketInfoXML( $user = null )
   {
      parent::InfoXML();
      $this->user = $user;
      $this->getData();
   }

   function getData()
   {
      $sortCriteria = new SortCriteria();
      $sortCriteria->ascending = true;
      $subsystem = "all";
      $state = 4;    // 1=UnOpen 2=Open 3=Closed 4=All (Open and Unopend)
      $start = gettimeofday();
      $this->EX_ticketInfo = @get_ras_tickets($this->user, $sortCriteria, $state, $subsystem, false);
      @$this->checkError( $this->EX_ticketInfo, "get_ras_tickets()", $start );

      if( isset( $this->EX_ticketInfo ) )
      {
         foreach( $this->EX_ticketInfo as $item )
         {
            $ticket = new Ticket( $item );
            $this->list[] = $ticket;
         }
      }
   }

   function toXML()
   {
      $out = "";
      $count = count( $this->list );
      if( $count > 0 )
      {
         $out = $this->tab . "<TicketInfo>\n";
         for( $i = 0; $i < $count; $i++ )
            $out .= $this->list[$i]->toXML();
         $out .= $this->tab . "</TicketInfo>\n";
      }
      return $out;
   }
}

class Ticket extends InfoXML
{
   var $number;
   var $name;
   var $dateTime;
   var $description;
   var $status;

   var $ticket = null;
   var $ticketPriority = array( "Unspecified", "Low", "High", "Urgent" );

   function Ticket( $ticket = null )
   {
      parent::InfoXML();
      $this->ticket = $ticket;
      $this->initializeVariables();
      $this->getData();
   }

   function getData()
   {
      if( isset( $this->ticket ) )
      {
         $this->number = $this->ticket->ticketNumber;
         $this->name = sprintf("T%03d", $this->ticket->causecode);
         $this->dateTime = $this->ticket->createTime;
         $this->description = $this->ticket->description;
         $this->status = $this->ticketPriority[ $this->ticket->priority % 4 ];
      }
   }

   function initializeVariables()
   {
      $this->number = $this->INTERFACE_ERROR_STRING;
      $this->name = $this->INTERFACE_ERROR_STRING;
      $this->dateTime = $this->INTERFACE_ERROR_STRING;
      $this->description = $this->INTERFACE_ERROR_STRING;
      $this->status = $this->INTERFACE_ERROR_STRING;
   }

   function toXML()
   {
      $out = $this->tab1 . "<Ticket>\n";
      $this->createTag( $out, $this->tab2, "Number", $this->number );
      $this->createTag( $out, $this->tab2, "Name", $this->name );
      $this->createTag( $out, $this->tab2, "DateTime", $this->dateTime );
      $this->createTag( $out, $this->tab2, "Description", $this->description );
      $this->createTag( $out, $this->tab2, "Status", $this->status );
      $out .= $this->tab1 . "</Ticket>\n";
      return $out;
   }
}

?>
