<?
/*
 * Quantum Confidential
 *
 * Automated Tape Library Software Source
 * (C) Copyright Quantum 2009. All Rights Reserved.
 * Non-published
 * 
 * $Id: $
 */
require_once('./xml/InfoXML.php');
require_once('./xml/NetworkInfoXML.php');
require_once('./xml/ModuleInfoXML.php');
require_once('./xml/LicenseInfoXML.php');
require_once('./xml/DateTimeInfoXML.php');
require_once('./xml/PartitionInfoXML.php');
require_once('./xml/ProductInfoXML.php');
require_once('./xml/DriveInfoXML.php');
require_once('./xml/BladeInfoXML.php');
require_once('./xml/RASInfoXML.php');
require_once('./xml/TicketInfoXML.php');

class XMLmanager extends InfoXML
{
   var $user = null;
   var $rootElement = "";

   function XMLmanager( $rootElement = "" )
   {
      parent::InfoXML();
      echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
      echo "<$rootElement>\n";
      $this->rootElement = $rootElement;
   }

   function login( $username = null, $password = null, $server = null, $serverAddress = null, $domain = null )
   {
      $start = gettimeofday();
      $this->user = @login( $username, $password, $server, $serverAddress, $domain, session_id() );
      $this->checkError( $this->user, "login", $start );
      if( !isset( $this->user ) )
      {
         echo "$this->tab<Error>InterfaceFailure</Error>\n";
         echo "</$this->rootElement>";
         exit;
      }
      else if( isset( $this->user->reason ) && $this->user->reason == 4103 )
      {
         echo "$this->tab<Error>AuthenticationFailed</Error>\n";
         echo "</$this->rootElement>";
         exit;
      }
      else if( isset( $this->user->reason ) && $this->user->reason == 4104 )
      {
         echo "$this->tab<Error>ServiceInProgress</Error>\n";
         echo "</$this->rootElement>";
         exit;
      }
      return $this->user;
   }

   function logoff()
   {
      @logoff( $this->user );
   }

   function getLibraryConfigurationInfo()
   {
      $productInfo = new ProductInfoXML( $this->user );
      $xmlData = $productInfo->toXML();

      $partitionInfo = new PartitionInfoXML( $this->user, $productInfo );
      $xmlData .= $partitionInfo->toXML();

      $driveInfo = new DriveInfoXML( $this->user );
      $xmlData .= $driveInfo->toXML();

      $bladeInfo = new BladeInfoXML( $this->user );
      $xmlData .= $bladeInfo->toXML();

      $rasStatus = new RASInfoXML( $this->user );
      $xmlData .= $rasStatus->toXML();

      $ticketInfo = new TicketInfoXML( $this->user );
      $xmlData .= $ticketInfo->toXML();

      // $xmlData .= "</LibraryConfiguration>\n";
      return $xmlData;
   }
}
?>
