/*
 * COPYRIGHT:  (C) Copyright IBM Corporation, 2001
 *       All rights reserved.   Licensed Materials    Property of IBM
 *       Note to US Government users
 *       Documentation related to restricted rights
 *       Use, duplication or disclosure is subject to restrictions
 *       set forth in GSA ADP Schedule with IBM Corp.
 *       All online documentation is subject to product license.  You will
 *       receive no rights beyond those listed in the product license.
 */

/**
 * wsmritxt.js
 *
 * String constants
 *
 * @version "1.3";
 */
 
var PWD_NOT_MATCH_ERROR = "The passwords you entered did not match.  Please try again.";
var CONFIRM_DELETE_USER = "Are you sure you want to delete this user?";
var USER_ID_BLANK = "Please enter a username";
var WS_NO_USERID = "Please enter a user ID";
var WS_NO_PASSWORD = "Please enter a password";
var WS_RESERVED_USERID  = "The user ID is reserved. Please enter a different user ID";
var WS_USER_EXISTS = "The user already exists.  Please enter a unique user ID";
var WS_USER_LIMIT = "Your request failed because you have added the maximum number of users allowed.";
var WS_INVALID_USERID = "Invalid user ID.  Please enter a valid user ID";
var WS_INVALID_PASSWORD = "Invalid password.  Please enter a valid password";
var WS_USER_NOT_FOUND  = "The user ID you selected no longer exists.";
var WS_INCORRECT_PASSWORD  = "The password you entered was incorrect";
var WS_SUCCESS = "Your request was successfully completed";
var PP_ENTER_POOL = "You must select a pool from the table";
var PP_DESCRIPTION = "Select a pool from the table."
var VR_ENTER_VOL1 = "You must make an entry in the From field";
var VR_ENTER_VOL2 = "You must make an entry in the To field";
var VR_ENTER_VOLS = "You must make an entry in the From and To fields";
var VR_ENTER_RANGE = "You must choose a range from the table";
var MSV_SELECT_ACTION = "You must selection an action before you can proceed";
var MC_ENTER_NAME = "You must enter a construct name.";
var MC_ENTER_DESCRIPTION = "You must enter a description from 1 to 70 characters.";
var FLV_ENTER_NAME = "You must enter a volser.";
var FLV_REQUEST_LOGICAL_VOLUME = "Request logical volume ";
var FLV_FINISHED = " finished ";
var FLV_PSV = "Primary stacked volume: ";
var FLV_SPSV = "Spanned primary stacked volume: ";
var FLV_SSSV = "Spanned secondary stacked volume: ";
var FLV_SSV = "Secondary stacked volume: ";

var MSV_INVALID_HONOR = "Honor Inhibit Reclaim Schedule cannot be selected with a Deferred Move";
var MSV_ENTER_SOURCE_POOL = "You must choose a source pool";
var MSV_ENTER_TARGET_POOL = "You must choose a target pool";
var MSV_ENTER_MOVETYPE = "You must choose a move type of deferred or priority";
var MSV_ENTER_NUMVOLS = "You must enter a number of volumes to move.";
var MSV_ENTER_EJECTDEST = "You must choose an eject destination";
var MSV_RANGE = "Range of Stacked Volumes";
var MSV_RANGE_SCRATCH = "Range of Scratch Only Volumes";
var MSV_QUANTITY = "Quantity of Scratch Only Volumes";
var MSV_MOVE = "Move";
var MSV_EJECT = "Eject";
var MSVER_EXISTING_RANGE = "Select an Existing Range";
var MSV_DATA = "Logical Volumes";
var MOVE_TYPE = "Move Type";
var EJECT_TYPE = "Eject Type";
var EJECT_DESTINATION = "Eject Destination";
var ALT_INFO_MSG = "information message";
var ALT_WARNING_MSG = "warning message";
var ALT_ERROR_MSG = "error message";
var ALT_REQUIRED_FIELD = "required";
var ALT_ERROR_FIELD = "error";
var ACTION = "Action";
var REFRESH = "Refresh";

var LAUNCH_UA = "Help";

var FLV_SEARCHING = "The Library Manager is searching for the logical volume's home.<BR><BR>Check the History window after you click 'Refresh'.";
var FLV_HISTORY_NOTE = "The above History window displays volsers for the primary stacked volume, the spanned primary stacked volume, the secondary stacked volume, and the spanned secondary stacked volume, respectively. A volser of '000000' indicates that the volume does not exist.";
var SVM_ENTER_MAP = "You must enter a Volser or select an existing map from the dropdown list box.";
var SVM_WAIT = "The Library Manager has accepted your request for a Stacked Volume Map.  It is currently being generated.  Please refresh the page periodically, and watch the History window to see when your map is complete.  At that time you may download it by choosing it in the Existing Maps list.";
var SVM_SELECT_MAP = "Select an existing map to save to your disk.";
var MSVCN_ALL_POOLS = "All Pools";
var MSVCN_CANCEL_ALL_MOVES = "Cancel All Moves";
var MSVCN_CANCEL_PRI_MOVES = "Cancel Priority Moves Only";
var MSVCN_CANCEL_DEF_MOVES = "Cancel Deferred Moves Only";
var MSVCN_CANCEL_ALL_EJECTS = "Cancel All Ejects";
var MSVCN_CANCEL_PRI_EJECTS = "Cancel Priority Ejects Only";
var MSVCN_CANCEL_DEF_EJECTS = "Cancel Deferred Ejects Only";
var MSVEN_SELECT_POOL = "Select a Pool";
var MSVCN_SELECT_POOL = "Select a Pool";

var DEVICE_ID = "Drive ID";
var FRAME_NUM = "Frame Number";
var COMMAND_STATUS = "Command status";
var EC_NUM = "EC number";
var SERIAL_NUM = "Serial number";
var ACTIVE_MCODE = "Active microcode";
var INACTIVE_MCODE = "Inactive microcode";
var ACTIVE_CODE_FLAG = "Activate code flag";

var DAY_OF_WEEK = "Day of Week";
var START_TIME = "Start Time (24HR)";
var DURATION = "Duration";
var SCHEDULES = "Schedules";
var SUNDAY = "Sunday";
var MONDAY = "Monday";
var TUESDAY = "Tuesday";
var WEDNESDAY = "Wednesday";
var THURSDAY = "Thursday";
var FRIDAY = "Friday";
var SATURDAY = "Saturday";
var EVERYDAY = "Everyday";
var SET_ALL_POOLS = "Set all Pools to:";

var ADIST_VIEW = "View by storage pool:";
var ADIST_VOLUMES = "Number of volumes with active data:";
var ADIST_PERCENTAGE = "Reclaim threshold percentage:";
var ADIST_ALL_STORAGE_POOLS = " - All Storage Pools";
var ADIST_STORAGE_POOL = " - Storage Pool ";
var SVTSST_BMC = "Backstore Media Counts";
var BMC_POOL_ZERO_ZERO = "Pool 00";
var BMC_TOTAL_STACKED_VOLUME_COUNT = "Total stacked volume count = ";
var BMC_CAPTION = "Backstore Media Counts by Pool";

var DATE = "Date";
var TIME = "Time";
var TIMESTAMP = "Timestamp";
var HIST_MESSAGE = "Message";

var MLV_LIB_SEQ_NUM = "Library Sequence Number";
var MLV_MAX_NUM = "Maximum Number";
var MLV_CURR_NUM = "Current Number";
var MLV_AVLBL_NUM = "Available Number";
var MLV_ENTER_VOLSER = "You must enter a volser in the 'From' textbox.  Optionally, you may enter a volser in the 'To' textbox to select a volser range.";
var MLV_SELECT_MEDIA_TYPE = "To insert a logical volume, you must select a media type.";
var MCMC_SECONDARY_POOL = "Secondary Pool";
var MCMC_SELECTIVE = "Selective Peer-to-Peer Copy Mode";
var PTP_IOVTS = "Peer-to-Peer I/O VTS";
var MCSC_TVCP = "Tape Volume Cache Preference";

var const_ALL = "All";
var const_MEDIA_TYPE = "Media Type";
var const_NUMBER_EMPTY = "Number Empty";
var const_NUMBER_FILLING = "Number Filling";
var const_NUMBER_FULL_ACTIVE = "Number Full Active";
var const_POOL = "Pool";
var CONST_STORAGE_GROUP = "Storage group";
var CONST_STORAGE_CLASS = "Storage class";
var CONST_MANAGEMENT_CLASS = "Management class";
var CONST_DATA_CLASS = "Data class";
var CONST_NAME = "Name";
var const_NAME = "Name";
var CONST_DESCRIPTION = "Description";
var CONST_FROM = "From";
var CONST_TO = "To";
var CONST_MEDIA = "Media";
var CONST_FIRST_MEDIA = "First Media";
var CONST_SECOND_MEDIA = "Second Media";
var CONST_BORROW_INDICATOR= "Borrow Indicator";
var CONST_RECLAIM_POOL = "Reclaim Pool";
var CONST_MAX_DEVICES = "Maximum Drives";
var CONST_PARTITION = "Partition";
var CONST_HOME_POOL = "Home Pool";
var CONST_POOL = "Pool";
var CONST_PRIMARY_POOL = "Primary Pool";
var CONST_SPACE = "&nbsp;";
var CONST_TO_VIEW = "Click here to view ";

var HIST_USER_ID = "User ID";
var HIST_STATUS = "Status";
var HIST_VTS_NUMBER = "VTS Number";
var HIST_NUM_LOG_VOLS = "Number Logical Volumes";
var HIST_NUM_LOG_VOLS_PROC = "Number Logical Volumes Processed";
var HIST_LAST_VOL_PROC = "Last Volume Processed";

var HIST_VOLSER = "Volser";
var HIST_P_STKD_VOL = "Primary Stacked Volume";
var HIST_S_P_STKD_VOL = "Spanned Primary Stacked Volume";
var HIST_S_STKD_VOL = "Secondary Stacked Volume";
var HIST_S_S_STKD_VOL = "Spanned Secondary Stacked Volume";
var HIST_PRIMARY_POOL = "Primary Pool";

var HIST_POOL = "Pool";
var HIST_FIRST_MEDIA = "First Media";
var HIST_SECOND_MEDIA = "Second Media";
var HIST_BORROW = "Borrow";
var HIST_RECLAIM = "Reclaim";
var HIST_MAX_DEVICES = "Max Drives";

var HIST_ACTION = "Action";
var HIST_CONSTRUCT_NAME = "Construct Name";

var HIST_PTP_CONTROL = "PtP Copy Control";
var HIST_SEC_STOR_POOL = "Secondary Storage Pool";

var HIST_TVC_PREF = "TVC Preference";

var HIST_PARTITION = "Partition";
var HIST_LIB_SEQ_NUM = "Library Sequence Number";
var HIST_START_VOLSER = "Start Volser";
var HIST_END_VOLSER = "End Volser";
var HIST_MEDIA_TYPE = "Media Type";
var HIST_HOME_POOL = "Home Pool";

var HIST_TARGET_POOL = "Target Pool";
var HIST_SOURCE_POOL = "Source Pool";
var HIST_SCRATCHIND = "Scratch/Private";
var HIST_NUMBER_VOLUMES = "Number Volumes";
var HIST_PRIORITY = "Request Indicator";
var HIST_EJECT_DESTINATION = "Eject Destination";

var HIST_STORAGE_GROUP = "Storage Group";
var HIST_STORAGE_CLASS = "Storage Class";
var HIST_MANAGEMENT_CLASS = "Management Class";
var HIST_DATA_CLASS = "Data Class";

var HIST_REQ_NUM_MOVES = "Requested Number Moves";
var HIST_ACT_NUM_MOVES = "Actual Number Moves";
var HIST_NUM_MARKED_EJECT = "Marked Eject";
var HIST_ACT_SCR_MOVED = "Scratch Moved";
var HIST_ACT_TO_MOVE_PR = "Number Priority To Move";
var HIST_ACT_TO_MOVE_DEF = "Number Deferred To Move";

var SET_NOTIFY = "Set Notify";
var NUM_TO_CLEAR = "Number to Clear";
var NUM_ACT_CLEARED = "Number actually Cleared";

var HIST_NUMRESULTS = "Number of Results";
var HIST_FILENAME = "Filename";

var MLV_CHANGE_WARNING = "The 'Change Existing Logical Volumes' function is only valid for logical volumes used by non-MVS hosts.  MVS hosts will automatically assign (change) constructs for logical volumes.";
var MSVCN_NO_POOL = "It is unnecessary to select a target pool when cancelling ejects.";

var SHOWWORK = "Show Work Items";
var HIDEWORK = "Hide Work Items";

var SECONDS = "Seconds";
var MINUTES = "Minutes";
var HOURS = "Hours";
var DAYS = "Days";
var WEEKS = "Weeks";
var NOTSET = "Not Set";
var EXPIRED = "Expired";

var HIST_INSTRUCTION = "Select an entry in the history table to display details.";

var DBS_WELCOME_STEP = "Welcome";
var DBS_SEARCH_CRITERIA_STEP = "Specify Search Criteria";
var DBS_OUTPUT_COLUMNS_STEP = "Select Results Set";
var DBS_DISPLAY_FORMAT_STEP = "Select Output Destination";

var DBS_WELCOME_DESCRIPTION = "Search Database allows you to search the volume database for specific volumes. To start a new search, select 'New Search' and then the Next button. To view the results of a previous search, select 'Previous Result', an item in the dropdown list, and the Finish button.";
var DBS_SEARCH_CRITERIA_DESCRIPTION = "Make selections below to define the database search criteria. The more search criteria used, the more restrictive the search.";
var DBS_OUTPUT_COLUMNS_DESCRIPTION = "Select the fields to be displayed in the search results. If more than six fields are selected, results must be saved to a file.";
var DBS_DISPLAY_FORMAT_DESCRIPTION = "Select the search results output destination (and enter a name if saving to a file).";

var VMP_DESCRIPTION = "This screen allows you to set the Inhibit Reclaim Schedule, the Reclaim Threshold Percentage, and the Free Storage Threshold (GB).";
var INHIBIT_RECLAIM_TITLE = "Inhibit Reclaim Schedule";
var INHIBIT_RECLAIM_DESCRIPTION = "Select a day of week, start time, and duration to add an entry to the schedule. Select an entry in the schedule to modify or delete.";
var FREE_STORAGE_TITLE = "Free Storage Threshold (GB)";
var FREE_STORAGE_DESCRIPTION = "Enter a free storage threshold in gigabytes. The default value is 600 GB.";
var RECLAIM_THRESH_TITLE = "Reclaim Threshold Percentage";
var RECLAIM_THRESH_DESCRIPTION = "Assign reclaim threshold percentages by selecting the appropriate percentage.";
var ENTER_NUMERIC_VALUE = "Field(s) with error indicator accept numeric values only";
var VTS = "VTS";
var WORM_CAPABLE = "WORM Capable";

var SEARCH_RESULTS = "Search Results"
var RECORDS_FOUND = "Records found: "

var mritxtSELECT = "Select";
var SELECT_ALL = "Select All";
var DESELECT_ALL = "Deselect All";

var MONITOR = "Monitor";
var ADMINISTER = "Administer";

var PRIORITY = "Priority";
var INTERVENTION = "Intervention";

var VPD_DESCRIPTION = "This screen displays vital product data of the 3592 drives. Select a drive ID and press the Submit button to view vital product data for the specified drive.";
var VPD_TITLE = "Vital Product Data";

var MOI_DESCRIPTION = "This screen allows you to modify operator interventions and enable/disable host notification.";
var MOI_HOST_DESCRIPTION  = "Mark or unmark the checkbox to enable or disable host notification.";
var MOI_HOST_TITLE = "Host Notification";
var MOI_NOTIFY = "Notify all hosts of future interventions";
var MOI_OP_DESCRIPTION  = "To clear specific operator interventions, mark the checkbox next to the appropriate intervention and select the Clear button. ";
var MOI_OP_TITLE = "Operator Interventions";
var MOI_SYS_DESCRIPTION  = "To clear system interventions, select the Clear All button.";
var MOI_SYS_TITLE = "System Interventions";

var BROWSER_WARNING = "The Enterprise Automated Tape Library Specialist is optimized for Microsoft Internet Explorer 6.0 or above";

var HISTORY = "History";
var STATUS = "Status";
var CLOSE_MESSAGE = "Close message";

var CONVENIENCE_IO = "Convenience I/O";
var HIGH_CAPACITY_IO = "High Capacity I/O Facility"
 
 
//START NON-TRANSLATABLE

var navInfo = new Array ();
navInfo[0] = new Array("welcome");
navInfo[1] = new Array("MONITORSYS");
navInfo[2] = new Array("syssum");
navInfo[3] = new Array("libmap");
navInfo[4] = new Array("loggedin");
navInfo[5] = new Array("netset");
navInfo[6] = new Array("MANAGECART");
navInfo[7] = new Array("datacart");
navInfo[8] = new Array("cleancart");
navInfo[9] = new Array("io");
navInfo[10] = new Array("MANAGEDRIVES");
navInfo[11] = new Array("load");
navInfo[12] = new Array("clean");
navInfo[13] = new Array("changestate");
navInfo[14] = new Array("driveid");
navInfo[15] = new Array("MANAGELIB");
navInfo[16] = new Array("setupwiz");
navInfo[17] = new Array("lockio");
navInfo[18] = new Array("shutdown");
navInfo[19] = new Array("PHYSICALCONFIG");
navInfo[20] = new Array("loglib");
navInfo[21] = new Array("cleanslot");
navInfo[22] = new Array("ioslot");
navInfo[23] = new Array("SETTINGS");
navInfo[24] = new Array("license");
navInfo[25] = new Array("datetime");
navInfo[26] = new Array("contactinfo");
navInfo[27] = new Array("registerlib");
navInfo[28] = new Array("MANAGEACCESS");
navInfo[29] = new Array("users");
navInfo[30] = new Array("notify");
navInfo[31] = new Array("emailconfig");
navInfo[32] = new Array("SERVICELIB");
navInfo[33] = new Array("opinterv");
navInfo[34] = new Array("logs");
navInfo[35] = new Array("idports");
navInfo[36] = new Array("firmware");
navInfo[37] = new Array("ADVANCEDSERVICE");
navInfo[38] = new Array("drives");
navInfo[39] = new Array("cartridges");
navInfo[40] = new Array("connectivity");
navInfo[41] = new Array("robotics");
navInfo[42] = new Array("cooling");
navInfo[43] = new Array("power");
navInfo[44] = new Array("control");
navInfo[45] = new Array("servicelogs");

//END NON-TRANSLATABLE

navInfo[0][1] = "Welcome";
navInfo[1][1] = "Monitor System";
navInfo[2][1] = "System Summary";
navInfo[3][1] = "Library Map";
navInfo[4][1] = "Logged in Users";
navInfo[5][1] = "Network Settings";
navInfo[6][1] = "Manage Cartridges";
navInfo[7][1] = "Data Cartridges";
navInfo[8][1] = "Cleaning Cartridges";
navInfo[9][1] = "I/O Station";
navInfo[10][1] = "Manage Drives";
navInfo[11][1] = "Load/Unload";
navInfo[12][1] = "Clean";
navInfo[13][1] = "Change State (Online/Offline)";
navInfo[14][1] = "Drive IDs";
navInfo[15][1] = "Manage Library";
navInfo[16][1] = "Setup Wizard";
navInfo[17][1] = "Lock/Unlock I/O Station Doors";
navInfo[18][1] = "Shutdown System";
navInfo[19][1] = "Physical Configuration";
navInfo[20][1] = "Logical Libraries";
navInfo[21][1] = "Cleaning Slots";
navInfo[22][1] = "I/O Station Slots";
navInfo[23][1] = "Settings";
navInfo[24][1] = "Feature Licenses";
navInfo[25][1] = "Date & Time";
navInfo[26][1] = "Contact Information";
navInfo[27][1] = "Register Library";
navInfo[28][1] = "Manage Access";
navInfo[29][1] = "Users";
navInfo[30][1] = "Notifications";
navInfo[31][1] = "Email Configuration";
navInfo[32][1] = "Service Library";
navInfo[33][1] = "Operator Interventions";
navInfo[34][1] = "Event & Error Logs";
navInfo[35][1] = "Identify Partition's Control Path Drive";
navInfo[36][1] = "Update Firmware";
navInfo[37][1] = "Advanced Service";
navInfo[38][1] = "Drives";
navInfo[39][1] = "Cartridges";
navInfo[40][1] = "Connectivity";
navInfo[41][1] = "Robotics";
navInfo[42][1] = "Cooling";
navInfo[43][1] = "Power";
navInfo[44][1] = "Control";
navInfo[45][1] = "Service Logs";