APPROOTDIR=/home/embedded/library

rm -f `find / -name "core.*" -type f`

if [ ! -d ${APPROOTDIR} ] 
then
	echo "Application home directory not found"
	exit 0
else
	echo "Executing clean"
fi 

cd ${APPROOTDIR}

if [ -d ./lib ]
then
	rm -r ./lib
fi

if [ -d ./bin ]
then
	rm -r ./bin
fi

if [ -d ./upload ]
then
	rm -r ./upload
	mkdir -m +w ./upload
fi


if [ -d ./AppManager ]
then
	rm -r ./AppManager
fi

if [ -d ./CoreService ]
then
	rm -r ./CoreService/bin
	rm -f ./CoreService/dat/[CcDPRSTmsu]*
fi

if [ -d ./ConsoleService ]
then
	rm -r ./ConsoleService
fi

if [ -d ./HTTPService ]
then
	rm -r ./HTTPService
fi

if [ -d ./SMI-SService ]
then
	rm -r ./SMI-SService
fi
if [ -d ./SNMPService ]
then
	rm -r ./SNMPService
fi
if [ -d ./SSLService ]
then
	rm -r ./SSLService
fi
if [ -f S101CoreVersion.cpp ]
then
	rm S101CoreVersion.cpp
fi
if [ -f /var/log/messages ]
then
	rm -f /var/log/messages
fi

if [ -f InstallingFirmware ] 
then
	rm -f InstallingFirmware
fi

HOSTNAME=`hostname`
DEFAULT='lcb1'
sed -r -i 's/^.*'"$HOSTNAME"'$/192\.168\.1\.1  '"$DEFAULT"'/' /etc/hosts
sed -r -i 's/^'"$HOSTNAME"'/'"$DEFAULT"'/' /etc/hostname
/bin/hostname -F /etc/hostname
/usr/bin/ifswitch-to-dhcp 2

