echo "Entered LibraryAppStart.sh"
APPROOTDIR=/home/embedded/library

. /etc/profile

if [ ! -d ${APPROOTDIR} ] 
then
	mkdir -p ${APPROOTDIR}
fi 

cd ${APPROOTDIR}

if [ ! -f ./AppManager/bin/AppMgr.exe ]
then
    if [ ! -f ./images/library.tgz]
    then
    	echo "ERROR! Cannot start library application" 
      	exit -1
    else
      	tar -xzvf ./images/library.tgz ./AppManager/bin/AppMgr.exe
    fi
fi


if [ ! -f ./lib/libCcp.so ]
then
    if [ ! -f ./images/library.tgz ]
    then
    	echo "ERROR! Cannot start library application" 
      	exit -2
    else
      	tar -xzvf ./images/library.tgz ./lib/libCcp.so
    fi
fi


if [ ! -f ./lib/libCMI.so ]
then
    if [ ! -f ./images/library.tgz ]
    then
    	echo "ERROR! Cannot start library application"
      	exit -3
    else
      	tar -xzvf ./images/library.tgz ./lib/libCMI.so
    fi
fi

if [ ! -d ./AppManager/dat ]
then
	mkdir ./AppManager/dat
	#TODO: set ownership and group
fi

if [ "${1}" = "unpack" ]
then
	echo "Unpacking only..."
else
	cd ./AppManager/dat

	export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${APPROOTDIR}/lib

	./../bin/AppMgr.exe start -quiet &
fi

echo "Exited LibraryAppStart.sh"

