#!/bin/sh

#########################################
# Display usage message
# Inputs: 
#
#########################################
Usage()
{
    echo "Usage: $0 [-o old dir] [-n new dir] [-p port dir] [-t tool dir]
    -o directory of the old repository which contains indications
    -n directory of new repository which contains new schema with no indications
    -p directory of the final repository with new schema and old indications
    -t directory of the binary tools owmofc and owrepositorydump which this script needs"
}

#########################################
# Display usage message
# Inputs: 
#
#########################################
Cleanup()
{
    rm -rf $TMPOLDMOF $TMPINSTMOF $TMPNEWMOF 
}

TMPDIR=/tmp
TOOLDIR=.
OLDREPDIR=/home/embedded/library/SMI-SService/repository
NEWREPDIR=$TMPDIR/new_rep
PORTREPDIR=$TMPDIR/final_rep

if [ $# -gt 0 ]; then
    while getopts "o:n:p:t:" opt
    do
      case "$opt" in
	  o) OLDREPDIR=$OPTARG;
	  ;;
	  n) NEWREPDIR=$OPTARG;
	  ;;
	  p) PORTREPDIR=$OPTARG;
	  ;;
	  t) TOOLDIR=$OPTARG;
	  ;;
	  *)Usage
	      exit 1;
	  ;;
      esac
    done
fi  

REPDUMP=$TOOLDIR/owrepositorydump
REPCOMP=$TOOLDIR/owmofc

TMPOLDMOF=$TMPDIR/oldmof.mof
TMPINSTMOF=$TMPDIR/instmof.mof
TMPNEWMOF=$TMPDIR/newmof.mof

rm -rf $PORTREPDIR;

$REPDUMP -d $OLDREPDIR -o $TMPOLDMOF
if [ $? -ne 0 ]; then
    echo "Failed to  make MOF out of old repository "
    Cleanup
    exit 1;
fi

INSTGREP=`grep -n INSTANCE $TMPOLDMOF | awk -F ":" '{print $1}'`;
start_line=`echo $INSTGREP | awk '{print $1}'`;
if [ $start_line = "" ]; then
    echo "No instances to port, leaving, port is just a copy "
    mkdir $PORTREPDIR
    cp -rf $NEWREPDIR $PORTREPDIR
fi

tot_line=`wc -l /$TMPOLDMOF | awk '{print $1}'`;
let cut_lines=$tot_line-$start_line+1;

tail -n$cut_lines $TMPOLDMOF > $TMPINSTMOF;

$REPDUMP -d $NEWREPDIR -o $TMPNEWMOF;
if [ $? -ne 0 ]; then
    echo "Failed to dump new repository, exiting "
    Cleanup
    exit 1;
fi

cat $TMPINSTMOF >> $TMPNEWMOF;

$REPCOMP -m -c -n root/cimv2 -d $PORTREPDIR $TMPNEWMOF > /dev/null;
if [ $? -ne 0 ]; then
    echo "Failed to compile the ported repository, exiting "
    Cleanup
    exit 1;
fi

Cleanup;
return 0;