#!/bin/sh
#
##
# $Header: cfl.sh 1.1 2006/09/08 16:32:33MDT Ahmed Teirelbar (ateirelbar) dev  $
#
# $ADICCopyright: Copyright 2007 Quantum Corp. $
#
# $Log: cfl.sh  $
# Revision 1.1 2006/09/08 16:32:33MDT Ahmed Teirelbar (ateirelbar) 
# Initial revision
# Member added to project e:/mks/projects/ccDevModel/Code/Applications/Scalar101/S101SystemBuild/project.pj
#

#
#   Exit Codes:
#   1   Failed to connect to blade
#   2   Blade command failed
#   3   Invalid args
#

BLD_CMD="cfLogEventPlayback"
NUM_EVENTS=100
SINGLE_BLADE=/home/embedded/library/singleBladeOp

if [ $# -le 2 ]; then
    echo "usage: $0 <IP> <LUN> <File>"
    exit 3;
fi

# Get arguments
IP=$1
LUN=$2
FILE_NAME=$3
TMP_FILE_NAME="CFL_$2_$IP"

# Run operation on blade
CMD_STR="expect ${SINGLE_BLADE} $IP '$BLD_CMD $LUN,$NUM_EVENTS > /log/$TMP_FILE_NAME'"
eval $CMD_STR
ret=$?

# If the operation succeeded, move the temp file to the name specified by the
# caller
if [ $ret -eq 0 ]; then
    mv /var/log/adic/I*/$TMP_FILE_NAME $FILE_NAME
fi

exit $ret;

